/* Generated by nsgenbind from javascript/jsapi/htmldocument.bnd
 *
 * nsgenbind is published under the MIT Licence.
 * nsgenbind is similar to a compiler is a purely transformative tool which
 * explicitly makes no copyright claim on this generated output
 * 
 * Copyright 2012 Vincent Sanders <vince@netsurf-browser.org>
 * 
 * This file is part of NetSurf, http://www.netsurf-browser.org/
 * 
 * Released under the terms of the MIT License,
 * 
 *         http://www.opensource.org/licenses/mit-license
 */



#include <dom/dom.h>

#include "utils/config.h"
#include "utils/log.h"
#include "utils/corestrings.h"
#include "utils/libdom.h"
#include "content/urldb.h"
#include "javascript/js.h"
#include "javascript/jsapi.h"
#include "render/html_internal.h"

#include "htmldocument.h"
#include "htmlelement.h"
#include "text.h"
#include "nodelist.h"
#include "location.h"


#include "comment.h"
#include "text.h"
#include "htmlelement.h"


struct jsclass_private {
        dom_document *node;
        struct html_content *htmlc;
};

static void jsclass_finalize(JSContext *cx, JSObject *obj);

static JSPropertySpec jsclass_properties[];

JSClass JSClass_Document = {
	"Document",
	0 | JSCLASS_HAS_PRIVATE,
	JS_PropertyStub,	/* addProperty */
	JS_PropertyStub,	/* delProperty */
	JS_PropertyStub,	/* getProperty */
	JS_StrictPropertyStub,	/* setProperty */
	JS_EnumerateStub,	/* enumerate */
	JS_ResolveStub,
	JS_ConvertStub,	/* convert */
	jsclass_finalize,
	0,	/* reserved */
	NULL,	/* checkAccess */
	NULL,	/* call */
	NULL,	/* construct */
	NULL,	/* xdr Object */
	NULL,	/* hasInstance */
	NULL, /* trace/mark */
	JSAPI_CLASS_NO_INTERNAL_MEMBERS
};

enum property_tinyid {
	/**** Document ****/
	JSAPI_PROP_TINYID_location,
	JSAPI_PROP_TINYID_domain,
	JSAPI_PROP_TINYID_referrer,
	JSAPI_PROP_TINYID_cookie,
	JSAPI_PROP_TINYID_lastModified,
	JSAPI_PROP_TINYID_readyState,
	JSAPI_PROP_TINYID_title,
	JSAPI_PROP_TINYID_dir,
	JSAPI_PROP_TINYID_body,
	JSAPI_PROP_TINYID_head,
	JSAPI_PROP_TINYID_images,
	JSAPI_PROP_TINYID_embeds,
	JSAPI_PROP_TINYID_plugins,
	JSAPI_PROP_TINYID_links,
	JSAPI_PROP_TINYID_forms,
	JSAPI_PROP_TINYID_scripts,
	JSAPI_PROP_TINYID_cssElementMap,
	JSAPI_PROP_TINYID_defaultView,
	JSAPI_PROP_TINYID_activeElement,
	JSAPI_PROP_TINYID_designMode,
	JSAPI_PROP_TINYID_commands,
	JSAPI_PROP_TINYID_onabort,
	JSAPI_PROP_TINYID_onblur,
	JSAPI_PROP_TINYID_oncancel,
	JSAPI_PROP_TINYID_oncanplay,
	JSAPI_PROP_TINYID_oncanplaythrough,
	JSAPI_PROP_TINYID_onchange,
	JSAPI_PROP_TINYID_onclick,
	JSAPI_PROP_TINYID_onclose,
	JSAPI_PROP_TINYID_oncontextmenu,
	JSAPI_PROP_TINYID_oncuechange,
	JSAPI_PROP_TINYID_ondblclick,
	JSAPI_PROP_TINYID_ondrag,
	JSAPI_PROP_TINYID_ondragend,
	JSAPI_PROP_TINYID_ondragenter,
	JSAPI_PROP_TINYID_ondragleave,
	JSAPI_PROP_TINYID_ondragover,
	JSAPI_PROP_TINYID_ondragstart,
	JSAPI_PROP_TINYID_ondrop,
	JSAPI_PROP_TINYID_ondurationchange,
	JSAPI_PROP_TINYID_onemptied,
	JSAPI_PROP_TINYID_onended,
	JSAPI_PROP_TINYID_onerror,
	JSAPI_PROP_TINYID_onfocus,
	JSAPI_PROP_TINYID_oninput,
	JSAPI_PROP_TINYID_oninvalid,
	JSAPI_PROP_TINYID_onkeydown,
	JSAPI_PROP_TINYID_onkeypress,
	JSAPI_PROP_TINYID_onkeyup,
	JSAPI_PROP_TINYID_onload,
	JSAPI_PROP_TINYID_onloadeddata,
	JSAPI_PROP_TINYID_onloadedmetadata,
	JSAPI_PROP_TINYID_onloadstart,
	JSAPI_PROP_TINYID_onmousedown,
	JSAPI_PROP_TINYID_onmousemove,
	JSAPI_PROP_TINYID_onmouseout,
	JSAPI_PROP_TINYID_onmouseover,
	JSAPI_PROP_TINYID_onmouseup,
	JSAPI_PROP_TINYID_onmousewheel,
	JSAPI_PROP_TINYID_onpause,
	JSAPI_PROP_TINYID_onplay,
	JSAPI_PROP_TINYID_onplaying,
	JSAPI_PROP_TINYID_onprogress,
	JSAPI_PROP_TINYID_onratechange,
	JSAPI_PROP_TINYID_onreset,
	JSAPI_PROP_TINYID_onscroll,
	JSAPI_PROP_TINYID_onseeked,
	JSAPI_PROP_TINYID_onseeking,
	JSAPI_PROP_TINYID_onselect,
	JSAPI_PROP_TINYID_onshow,
	JSAPI_PROP_TINYID_onstalled,
	JSAPI_PROP_TINYID_onsubmit,
	JSAPI_PROP_TINYID_onsuspend,
	JSAPI_PROP_TINYID_ontimeupdate,
	JSAPI_PROP_TINYID_onvolumechange,
	JSAPI_PROP_TINYID_onwaiting,
	JSAPI_PROP_TINYID_onreadystatechange,
	/**** Document ****/
	JSAPI_PROP_TINYID_fgColor,
	JSAPI_PROP_TINYID_linkColor,
	JSAPI_PROP_TINYID_vlinkColor,
	JSAPI_PROP_TINYID_alinkColor,
	JSAPI_PROP_TINYID_bgColor,
	JSAPI_PROP_TINYID_anchors,
	JSAPI_PROP_TINYID_applets,
	JSAPI_PROP_TINYID_all,
	/**** Document ****/
	JSAPI_PROP_TINYID_implementation,
	JSAPI_PROP_TINYID_URL,
	JSAPI_PROP_TINYID_documentURI,
	JSAPI_PROP_TINYID_compatMode,
	JSAPI_PROP_TINYID_characterSet,
	JSAPI_PROP_TINYID_contentType,
	JSAPI_PROP_TINYID_doctype,
	JSAPI_PROP_TINYID_documentElement,
	/**** Node ****/
	JSAPI_PROP_TINYID_nodeType,
	JSAPI_PROP_TINYID_nodeName,
	JSAPI_PROP_TINYID_baseURI,
	JSAPI_PROP_TINYID_ownerDocument,
	JSAPI_PROP_TINYID_parentNode,
	JSAPI_PROP_TINYID_parentElement,
	JSAPI_PROP_TINYID_childNodes,
	JSAPI_PROP_TINYID_firstChild,
	JSAPI_PROP_TINYID_lastChild,
	JSAPI_PROP_TINYID_previousSibling,
	JSAPI_PROP_TINYID_nextSibling,
	JSAPI_PROP_TINYID_nodeValue,
	JSAPI_PROP_TINYID_textContent,
	/**** EventTarget ****/
	JSAPI_PROP_TINYID_END,
};


/* CAUTION this expects all javascript Node objects private pointers
 * to have private->node in the same place.
 */
static struct dom_node *jsnode_to_domnode(JSContext *cx, JSObject *jsnode)
{
	struct jsclass_private *jsnode_private;

	if (jsnode == NULL) {
		return NULL;
	}

	/* element */
	jsnode_private = JS_GetInstancePrivate(cx,
					       jsnode,
					       &JSClass_HTMLElement,
					       NULL);
	if (jsnode_private != NULL) {
		return (struct dom_node *)jsnode_private->node;
	}

	/* text */
	jsnode_private = JS_GetInstancePrivate(cx,
					       jsnode,
					       &JSClass_Text,
					       NULL);
	if (jsnode_private != NULL) {
		return (struct dom_node *)jsnode_private->node;
	}

	/* comment */
	jsnode_private = JS_GetInstancePrivate(cx,
					       jsnode,
					       &JSClass_Comment,
					       NULL);
	if (jsnode_private != NULL) {
		return (struct dom_node *)jsnode_private->node;
	}

	return NULL;
}



/**** Document ****/
static JSBool JSAPI_FUNC(getElementsByName, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* NodeList */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *elementName_jsstr = NULL;
	int elementName_len = 0;
	char *elementName = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		elementName_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		elementName_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (elementName_jsstr != NULL) {
		JSString_to_char(elementName_jsstr, elementName, elementName_len);
	}

	JSLOG("operation Document.getElementsByName has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(getItems, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* NodeList */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Document.getItems has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(open, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Document */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Document.open has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(close, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Document.close has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(write, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *text_jsstr = NULL;
	int text_len = 0;
	char *text = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		text_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		text_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (text_jsstr != NULL) {
		JSString_to_char(text_jsstr, text, text_len);
	}


	if (private->htmlc->parser != NULL) {
		dom_hubbub_parser_insert_chunk(private->htmlc->parser, (uint8_t *)text, text_len);
	}

	return JS_TRUE;
}

static JSBool JSAPI_FUNC(writeln, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *text_jsstr = NULL;
	int text_len = 0;
	char *text = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		text_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		text_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (text_jsstr != NULL) {
		JSString_to_char(text_jsstr, text, text_len);
	}

	JSLOG("operation Document.writeln has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(hasFocus, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Document.hasFocus has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(execCommand, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *commandId_jsstr = NULL;
	int commandId_len = 0;
	char *commandId = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		commandId_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		commandId_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (commandId_jsstr != NULL) {
		JSString_to_char(commandId_jsstr, commandId, commandId_len);
	}

	JSLOG("operation Document.execCommand has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(queryCommandEnabled, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *commandId_jsstr = NULL;
	int commandId_len = 0;
	char *commandId = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		commandId_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		commandId_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (commandId_jsstr != NULL) {
		JSString_to_char(commandId_jsstr, commandId, commandId_len);
	}

	JSLOG("operation Document.queryCommandEnabled has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(queryCommandIndeterm, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *commandId_jsstr = NULL;
	int commandId_len = 0;
	char *commandId = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		commandId_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		commandId_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (commandId_jsstr != NULL) {
		JSString_to_char(commandId_jsstr, commandId, commandId_len);
	}

	JSLOG("operation Document.queryCommandIndeterm has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(queryCommandState, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *commandId_jsstr = NULL;
	int commandId_len = 0;
	char *commandId = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		commandId_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		commandId_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (commandId_jsstr != NULL) {
		JSString_to_char(commandId_jsstr, commandId, commandId_len);
	}

	JSLOG("operation Document.queryCommandState has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(queryCommandSupported, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *commandId_jsstr = NULL;
	int commandId_len = 0;
	char *commandId = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		commandId_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		commandId_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (commandId_jsstr != NULL) {
		JSString_to_char(commandId_jsstr, commandId, commandId_len);
	}

	JSLOG("operation Document.queryCommandSupported has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(queryCommandValue, JSContext *cx, uintN argc, jsval *vp)
{
	JSString *jsret = NULL;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *commandId_jsstr = NULL;
	int commandId_len = 0;
	char *commandId = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		commandId_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		commandId_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (commandId_jsstr != NULL) {
		JSString_to_char(commandId_jsstr, commandId, commandId_len);
	}

	JSLOG("operation Document.queryCommandValue has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** Document ****/
static JSBool JSAPI_FUNC(clear, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Document.clear has no implementation");
	return JS_TRUE;
}

/**** Document ****/
static JSBool JSAPI_FUNC(getElementsByTagName, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* HTMLCollection */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *localName_jsstr = NULL;
	int localName_len = 0;
	char *localName = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		localName_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		localName_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (localName_jsstr != NULL) {
		JSString_to_char(localName_jsstr, localName, localName_len);
	}


	dom_string *localName_dom;
	/* dom_html_collection *collection;*/
	dom_nodelist *nodelist;
	dom_exception exc;

	exc = dom_string_create((uint8_t *)localName, localName_len, &localName_dom);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	exc = dom_document_get_elements_by_tag_name(private->node, localName_dom, /*&collection*/&nodelist);
	dom_string_unref(localName_dom);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	if (/*collection*/nodelist != NULL) {
		/*jsret = jsapi_new_HTMLCollection(cx,
						 NULL,
						 NULL,
						 collection,
						 private->htmlc);*/
		jsret = jsapi_new_NodeList(cx,
						 NULL,
						 NULL,
						 nodelist,
						 private->htmlc);
	}


	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(getElementsByTagNameNS, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* HTMLCollection */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *namespace_jsstr = NULL;
	int namespace_len = 0;
	char *namespace = NULL;
	JSString *localName_jsstr = NULL;
	int localName_len = 0;
	char *localName = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		namespace_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		namespace_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (namespace_jsstr != NULL) {
		JSString_to_char(namespace_jsstr, namespace, namespace_len);
	}

	if (argc > 1) {
		localName_jsstr = JS_ValueToString(cx, argv[1]);
	} else {
		localName_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (localName_jsstr != NULL) {
		JSString_to_char(localName_jsstr, localName, localName_len);
	}

	JSLOG("operation Document.getElementsByTagNameNS has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(getElementsByClassName, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* HTMLCollection */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *classNames_jsstr = NULL;
	int classNames_len = 0;
	char *classNames = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		classNames_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		classNames_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (classNames_jsstr != NULL) {
		JSString_to_char(classNames_jsstr, classNames, classNames_len);
	}

	JSLOG("operation Document.getElementsByClassName has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(getElementById, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Element */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *elementId_jsstr = NULL;
	int elementId_len = 0;
	char *elementId = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		elementId_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		elementId_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (elementId_jsstr != NULL) {
		JSString_to_char(elementId_jsstr, elementId, elementId_len);
	}


	dom_string *elementId_dom;
	dom_element *element;
	dom_exception exc;

	exc = dom_string_create((unsigned char*)elementId, elementId_len, &elementId_dom);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	exc = dom_document_get_element_by_id(private->node, elementId_dom, &element);
	dom_string_unref(elementId_dom);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	if (element != NULL) {
	      jsret = jsapi_new_HTMLElement(cx, NULL, NULL, element, private->htmlc);
	}

	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(createElement, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Element */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *localName_jsstr = NULL;
	int localName_len = 0;
	char *localName = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		localName_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		localName_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (localName_jsstr != NULL) {
		JSString_to_char(localName_jsstr, localName, localName_len);
	}


	dom_string *localName_dom;
	dom_exception exc;
	dom_element *element;

	if (localName != NULL) {
		JSDBG("Creating text node for string \"%s\"", localName);
		exc = dom_string_create((unsigned char*)localName, localName_len, &localName_dom);
		if (exc != DOM_NO_ERR) {
			return JS_FALSE;
		}

		exc = dom_document_create_element(private->node, localName_dom, &element);
		dom_string_unref(localName_dom);
		if (exc != DOM_NO_ERR) {
			return JS_FALSE;
		}

		jsret = jsapi_new_HTMLElement(cx, NULL, NULL, element, private->htmlc);
	}

	JSDBG("returning jsobject %p",jsret);


	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(createElementNS, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Element */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *namespace_jsstr = NULL;
	int namespace_len = 0;
	char *namespace = NULL;
	JSString *qualifiedName_jsstr = NULL;
	int qualifiedName_len = 0;
	char *qualifiedName = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		namespace_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		namespace_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (namespace_jsstr != NULL) {
		JSString_to_char(namespace_jsstr, namespace, namespace_len);
	}

	if (argc > 1) {
		qualifiedName_jsstr = JS_ValueToString(cx, argv[1]);
	} else {
		qualifiedName_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (qualifiedName_jsstr != NULL) {
		JSString_to_char(qualifiedName_jsstr, qualifiedName, qualifiedName_len);
	}

	JSLOG("operation Document.createElementNS has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(createDocumentFragment, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* DocumentFragment */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Document.createDocumentFragment has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(createTextNode, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Text */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *data_jsstr = NULL;
	int data_len = 0;
	char *data = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		data_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		data_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (data_jsstr != NULL) {
		JSString_to_char(data_jsstr, data, data_len);
	}


	dom_string *data_dom;
	dom_exception exc;
	dom_text *text;

	if (data != NULL) {

		JSDBG("Creating text node for string \"%s\"", data);
		exc = dom_string_create((unsigned char*)data, data_len, &data_dom);
		if (exc != DOM_NO_ERR) {
			return JS_FALSE;
		}

		exc = dom_document_create_text_node(private->node, data_dom, &text);
		dom_string_unref(data_dom);
		if (exc != DOM_NO_ERR) {
			return JS_FALSE;
		}

		jsret = jsapi_new_Text(cx, NULL, NULL, text, private->htmlc);
	}

	JSDBG("returning jsobject %p",jsret);


	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(createComment, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Comment */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *data_jsstr = NULL;
	int data_len = 0;
	char *data = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		data_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		data_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (data_jsstr != NULL) {
		JSString_to_char(data_jsstr, data, data_len);
	}


	dom_string *data_dom;
	dom_exception exc;
	dom_comment *comment;

	if (data != NULL) {

		JSDBG("Creating string \"%s\"", data);
		exc = dom_string_create((unsigned char*)data,
					data_len,
					&data_dom);
		if (exc != DOM_NO_ERR) {
			return JS_FALSE;
		}

		JSDBG("Creating comment object for dom string \"%s\"",
		      dom_string_data(data_dom));
		exc = dom_document_create_comment(private->node,
						  data_dom,
						  &comment);
		dom_string_unref(data_dom);
		if (exc != DOM_NO_ERR) {
			return JS_FALSE;
		}

		jsret = jsapi_new_Comment(cx, NULL, NULL, comment, private->htmlc);
	}

	JSDBG("returning jsobject %p", jsret);


	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(createProcessingInstruction, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* ProcessingInstruction */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *target_jsstr = NULL;
	int target_len = 0;
	char *target = NULL;
	JSString *data_jsstr = NULL;
	int data_len = 0;
	char *data = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		target_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		target_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (target_jsstr != NULL) {
		JSString_to_char(target_jsstr, target, target_len);
	}

	if (argc > 1) {
		data_jsstr = JS_ValueToString(cx, argv[1]);
	} else {
		data_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (data_jsstr != NULL) {
		JSString_to_char(data_jsstr, data, data_len);
	}

	JSLOG("operation Document.createProcessingInstruction has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(importNode, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *node = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	node = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation Document.importNode has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(adoptNode, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *node = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	node = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation Document.adoptNode has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(createEvent, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Event */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *interface_jsstr = NULL;
	int interface_len = 0;
	char *interface = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		interface_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		interface_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (interface_jsstr != NULL) {
		JSString_to_char(interface_jsstr, interface, interface_len);
	}

	JSLOG("operation Document.createEvent has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(createRange, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Range */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Document.createRange has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(createNodeIterator, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* NodeIterator */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *root = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	root = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation Document.createNodeIterator has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(createTreeWalker, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* TreeWalker */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *root = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	root = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation Document.createTreeWalker has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(prepend, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Document.prepend has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(append, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Document.append has no implementation");
	return JS_TRUE;
}

/**** Node ****/
static JSBool JSAPI_FUNC(hasChildNodes, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Document.hasChildNodes has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(insertBefore, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *node = NULL;
	JSObject *child = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	node = JSVAL_TO_OBJECT(argv[0]);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[1])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[1]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	child = JSVAL_TO_OBJECT(argv[1]);
	JSLOG("operation Document.insertBefore has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(appendChild, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *node = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	node = JSVAL_TO_OBJECT(argv[0]);

	struct dom_node *domnode; /* dom node from js input node */
	struct dom_node *result = NULL;
	dom_exception exc;
	dom_node_type node_type;

	domnode = jsnode_to_domnode(cx, node);
	if (domnode == NULL) {
		/* should cause Error: NOT_FOUND_ERR: DOM Exception 8 */
		JSLOG("Error: NOT_FOUND_ERR: DOM Exception 8");
		return JS_FALSE;
	}

	JSLOG("appending js node %p (dom %p)", node, domnode);

	/* append the found element */
	exc = dom_node_append_child(private->node, domnode, &result);
	if (exc != DOM_NO_ERR) {
		JSLOG("Error: DOM Exception (libdom append child)");
		return JS_FALSE;
	}

	if (result != NULL) {
		exc = dom_node_get_node_type(result, &node_type);
		if (exc != DOM_NO_ERR) {
			return JS_FALSE;
		}
		switch (node_type) {
		case DOM_ELEMENT_NODE:
			jsret = jsapi_new_HTMLElement(cx, NULL, NULL, (dom_element *)result, private->htmlc);
			break;

		case DOM_TEXT_NODE:
			jsret = jsapi_new_Text(cx, NULL, NULL, (dom_text *)result, private->htmlc);
			break;

		default:
			JSLOG("Unsupported result node type %d", node_type);
		}

	} else {
		JSLOG("No result");
	}

	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(replaceChild, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *node = NULL;
	JSObject *child = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	node = JSVAL_TO_OBJECT(argv[0]);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[1])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[1]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	child = JSVAL_TO_OBJECT(argv[1]);
	JSLOG("operation Document.replaceChild has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(removeChild, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *child = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	child = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation Document.removeChild has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(normalize, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Document.normalize has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(cloneNode, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Document.cloneNode has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(isEqualNode, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *node = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	node = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation Document.isEqualNode has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(compareDocumentPosition, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *other = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	other = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation Document.compareDocumentPosition has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(contains, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *other = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	other = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation Document.contains has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(lookupPrefix, JSContext *cx, uintN argc, jsval *vp)
{
	JSString *jsret = NULL;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *namespace_jsstr = NULL;
	int namespace_len = 0;
	char *namespace = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		namespace_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		namespace_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (namespace_jsstr != NULL) {
		JSString_to_char(namespace_jsstr, namespace, namespace_len);
	}

	JSLOG("operation Document.lookupPrefix has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(lookupNamespaceURI, JSContext *cx, uintN argc, jsval *vp)
{
	JSString *jsret = NULL;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *prefix_jsstr = NULL;
	int prefix_len = 0;
	char *prefix = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		prefix_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		prefix_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (prefix_jsstr != NULL) {
		JSString_to_char(prefix_jsstr, prefix, prefix_len);
	}

	JSLOG("operation Document.lookupNamespaceURI has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(isDefaultNamespace, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *namespace_jsstr = NULL;
	int namespace_len = 0;
	char *namespace = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		namespace_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		namespace_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (namespace_jsstr != NULL) {
		JSString_to_char(namespace_jsstr, namespace, namespace_len);
	}

	JSLOG("operation Document.isDefaultNamespace has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** EventTarget ****/
static JSBool JSAPI_FUNC(addEventListener, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *type_jsstr = NULL;
	int type_len = 0;
	char *type = NULL;
	JSObject *callback = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		type_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		type_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (type_jsstr != NULL) {
		JSString_to_char(type_jsstr, type, type_len);
	}

	if (!JSAPI_JSVAL_IS_OBJECT(argv[1])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[1]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	callback = JSVAL_TO_OBJECT(argv[1]);
	JSLOG("operation Document.addEventListener has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(removeEventListener, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *type_jsstr = NULL;
	int type_len = 0;
	char *type = NULL;
	JSObject *callback = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		type_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		type_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (type_jsstr != NULL) {
		JSString_to_char(type_jsstr, type, type_len);
	}

	if (!JSAPI_JSVAL_IS_OBJECT(argv[1])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[1]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	callback = JSVAL_TO_OBJECT(argv[1]);
	JSLOG("operation Document.removeEventListener has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(dispatchEvent, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *event = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Document,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	event = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation Document.dispatchEvent has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** Document ****/
/* PutForwards setter */
static JSBool JSAPI_STRICTPROP(location_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	jsval propval;
	if (JS_GetProperty(cx, obj, "location", &propval) == JS_TRUE) {
		JS_SetProperty(cx, JSVAL_TO_OBJECT(propval), "href", vp);
	}
	return JS_FALSE; /* disallow the asignment */
}

static JSBool JSAPI_PROP(location_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Location */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	if (!JSVAL_IS_VOID(JSAPI_PROP_RVAL(cx, vp))) {
		/* already created - return it */
		return JS_TRUE;
	}
	jsret = jsapi_new_Location(cx,
				   NULL,
				   NULL,
				   llcache_handle_get_url(private->htmlc->base.llcache));

	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(domain_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.domain has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(domain_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.domain has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(referrer_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.referrer has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(cookie_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.cookie has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(cookie_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	char *cookie_str;
	cookie_str = urldb_get_cookie(llcache_handle_get_url(private->htmlc->base.llcache), false);
	if (cookie_str != NULL) {
		jsret = JS_NewStringCopyN(cx, cookie_str, strlen(cookie_str));
		free(cookie_str);
	}

	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(lastModified_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.lastModified has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(readyState_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.readyState has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(title_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.title has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(title_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.title has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(dir_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.dir has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(dir_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.dir has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(body_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.body has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(body_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* HTMLElement */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	dom_node *element;
	dom_node *body;
	dom_exception exc;

	JSDBG("Getting your body");

	/* document (html) element */
	exc = dom_document_get_document_element(private->node, &element);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	if (element != NULL) {
		body = libdom_find_first_element(element, corestring_lwc_body) ;
		if (body != NULL) {
			jsret = jsapi_new_HTMLElement(cx, NULL, NULL, (dom_element *)body, private->htmlc);
		}
		dom_node_unref(element);
	}

	JSDBG("returning jsobject %p",jsret);


	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(head_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* HTMLHeadElement */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	dom_node *element;
	dom_node *head;
	dom_exception exc;

	/* document (html) element */
	exc = dom_document_get_document_element(private->node, &element);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	if (element != NULL) {
		head = libdom_find_first_element(element, corestring_lwc_head) ;
		if (head != NULL) {
			jsret = jsapi_new_HTMLElement(cx, NULL, NULL, (dom_element *)head, private->htmlc);
		}
		dom_node_unref(element);
	}

	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(images_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* HTMLCollection */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.images has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(embeds_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* HTMLCollection */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.embeds has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(plugins_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* HTMLCollection */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.plugins has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(links_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* HTMLCollection */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.links has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(forms_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* HTMLCollection */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.forms has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(scripts_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* HTMLCollection */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.scripts has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(cssElementMap_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* DOMElementMap */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.cssElementMap has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(defaultView_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* WindowProxy */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.defaultView has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(activeElement_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Element */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.activeElement has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(designMode_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.designMode has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(designMode_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.designMode has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(commands_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* HTMLCollection */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.commands has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(onerror_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.onerror has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(onerror_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* OnErrorEventHandler */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.onerror has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** Document ****/
static JSBool JSAPI_STRICTPROP(fgColor_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.fgColor has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(fgColor_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.fgColor has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(linkColor_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.linkColor has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(linkColor_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.linkColor has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(vlinkColor_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.vlinkColor has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(vlinkColor_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.vlinkColor has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(alinkColor_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.alinkColor has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(alinkColor_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.alinkColor has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(bgColor_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.bgColor has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(bgColor_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.bgColor has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(anchors_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* HTMLCollection */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.anchors has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(applets_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* HTMLCollection */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.applets has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(all_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* HTMLAllCollection */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.all has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** Document ****/
static JSBool JSAPI_PROP(implementation_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* DOMImplementation */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.implementation has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(URL_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	jsval loc;
	jsval jsstr = JSVAL_NULL;
	if (JS_GetProperty(cx, obj, "location", &loc) == JS_TRUE) {
		JS_GetProperty(cx, JSVAL_TO_OBJECT(loc), "href", &jsstr);
	}
	jsret = JSVAL_TO_STRING(jsstr);

	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(documentURI_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	jsval loc;
	jsval jsstr = JSVAL_NULL;
	if (JS_GetProperty(cx, obj, "location", &loc) == JS_TRUE) {
		JS_GetProperty(cx, JSVAL_TO_OBJECT(loc), "href", &jsstr);
	}
	jsret = JSVAL_TO_STRING(jsstr);

	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(compatMode_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	/* Returns the string "CSS1Compat" if document is in no-quirks
	 * mode or limited-quirks mode, and "BackCompat", if document
	 * is in quirks mode.
	 */
	if (!JSVAL_IS_VOID(JSAPI_PROP_RVAL(cx, vp))) {
		/* already created, just use it */
		return JS_TRUE;
	}
	if (private->htmlc->quirks == DOM_DOCUMENT_QUIRKS_MODE_FULL) {
		jsret = JS_NewStringCopyN(cx, "BackCompat", SLEN("BackCompat"));
	} else {
		jsret = JS_NewStringCopyN(cx, "CSS1Compat", SLEN("CSS1Compat"));
	}


	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(characterSet_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.characterSet has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(contentType_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.contentType has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(doctype_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* DocumentType */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.doctype has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(documentElement_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Element */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	dom_exception exc;
	dom_element *element;

	/* document (html) element */
	exc = dom_document_get_document_element(private->node, (void *)&element);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	if (element != NULL) {
		jsret = jsapi_new_HTMLElement(cx, NULL, NULL, element, private->htmlc);
	}

	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** Node ****/
static JSBool JSAPI_PROP(nodeType_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	uint16_t jsret = 0;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	dom_exception exc;
	dom_node_type node_type;

	exc = dom_node_get_node_type(private->node, &node_type);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}
	jsret = node_type;

	JSAPI_PROP_SET_RVAL(cx, vp, INT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(nodeName_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	dom_exception exc;
	dom_string *name;

	exc = dom_node_get_node_name(private->node, &name);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	if (name != NULL) {
		jsret = JS_NewStringCopyN(cx,
					  dom_string_data(name),
					  dom_string_length(name));
		dom_string_unref(name);
	}

	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(baseURI_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.baseURI has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(ownerDocument_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Document */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.ownerDocument has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(parentNode_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.parentNode has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(parentElement_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Element */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.parentElement has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(childNodes_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* NodeList */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.childNodes has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(firstChild_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.firstChild has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(lastChild_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.lastChild has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(previousSibling_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.previousSibling has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(nextSibling_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.nextSibling has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(nodeValue_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.nodeValue has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(nodeValue_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	dom_exception exc;
	dom_string *value;

	exc = dom_node_get_node_value(private->node, &value);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	if (value != NULL) {
		jsret = JS_NewStringCopyN(cx,
					  dom_string_data(value),
					  dom_string_length(value));
		dom_string_unref(value);
	}

	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(textContent_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Document.textContent has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(textContent_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	dom_exception exc;
	dom_string *content;

	exc = dom_node_get_text_content(private->node, &content);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	if (content != NULL) {
		jsret = JS_NewStringCopyN(cx, dom_string_data(content), dom_string_length(content));
		dom_string_unref(content);

	}

	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** EventTarget ****/
static JSBool
JSAPI_STRICTPROP(EventHandler_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	jsval tinyid_jsval;
	int8_t tinyid = JSAPI_PROP_TINYID_END;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	 /* obtain property tinyid */
	JSAPI_PROP_IDVAL(cx, &tinyid_jsval);
	tinyid = JSVAL_TO_INT(tinyid_jsval);


	dom_string *event_type_dom;

	JSLOG("propname[%d].name=\"%s\"",
	      tinyid,
	      jsclass_properties[tinyid].name);

	switch (tinyid) {
	case JSAPI_PROP_TINYID_onabort:
		event_type_dom = corestring_dom_abort;
		break;

	case JSAPI_PROP_TINYID_onblur:
		event_type_dom = corestring_dom_blur;
		break;

	case JSAPI_PROP_TINYID_oncancel:
		event_type_dom = corestring_dom_cancel;
		break;

	case JSAPI_PROP_TINYID_oncanplay:
		event_type_dom = corestring_dom_canplay;
		break;

	case JSAPI_PROP_TINYID_oncanplaythrough:
		event_type_dom = corestring_dom_canplaythrough;
		break;

	case JSAPI_PROP_TINYID_onchange:
		event_type_dom = corestring_dom_change;
		break;

	case JSAPI_PROP_TINYID_onclick:
		event_type_dom = corestring_dom_click;
		break;

	case JSAPI_PROP_TINYID_onclose:
		event_type_dom = corestring_dom_close;
		break;

	case JSAPI_PROP_TINYID_oncontextmenu:
		event_type_dom = corestring_dom_contextmenu;
		break;

	case JSAPI_PROP_TINYID_oncuechange:
		event_type_dom = corestring_dom_cuechange;
		break;

	case JSAPI_PROP_TINYID_ondblclick:
		event_type_dom = corestring_dom_dblclick;
		break;

	case JSAPI_PROP_TINYID_ondrag:
		event_type_dom = corestring_dom_drag;
		break;

	case JSAPI_PROP_TINYID_ondragend:
		event_type_dom = corestring_dom_dragend;
		break;

	case JSAPI_PROP_TINYID_ondragenter:
		event_type_dom = corestring_dom_dragenter;
		break;

	case JSAPI_PROP_TINYID_ondragleave:
		event_type_dom = corestring_dom_dragleave;
		break;

	case JSAPI_PROP_TINYID_ondragover:
		event_type_dom = corestring_dom_dragover;
		break;

	case JSAPI_PROP_TINYID_ondragstart:
		event_type_dom = corestring_dom_dragstart;
		break;

	case JSAPI_PROP_TINYID_ondrop:
		event_type_dom = corestring_dom_drop;
		break;

	case JSAPI_PROP_TINYID_ondurationchange:
		event_type_dom = corestring_dom_durationchange;
		break;

	case JSAPI_PROP_TINYID_onemptied:
		event_type_dom = corestring_dom_emptied;
		break;

	case JSAPI_PROP_TINYID_onended:
		event_type_dom = corestring_dom_ended;
		break;

	case JSAPI_PROP_TINYID_onerror:
		event_type_dom = corestring_dom_error;
		break;

	case JSAPI_PROP_TINYID_onfocus:
		event_type_dom = corestring_dom_focus;
		break;

	case JSAPI_PROP_TINYID_oninput:
		event_type_dom = corestring_dom_input;
		break;

	case JSAPI_PROP_TINYID_oninvalid:
		event_type_dom = corestring_dom_invalid;
		break;

	case JSAPI_PROP_TINYID_onkeydown:
		event_type_dom = corestring_dom_keydown;
		break;

	case JSAPI_PROP_TINYID_onkeypress:
		event_type_dom = corestring_dom_keypress;
		break;

	case JSAPI_PROP_TINYID_onkeyup:
		event_type_dom = corestring_dom_keyup;
		break;

	case JSAPI_PROP_TINYID_onload:
		event_type_dom = corestring_dom_load;
		break;

	case JSAPI_PROP_TINYID_onloadeddata:
		event_type_dom = corestring_dom_loadeddata;
		break;

	case JSAPI_PROP_TINYID_onloadedmetadata:
		event_type_dom = corestring_dom_loadedmetadata;
		break;

	case JSAPI_PROP_TINYID_onloadstart:
		event_type_dom = corestring_dom_loadstart;
		break;

	case JSAPI_PROP_TINYID_onmousedown:
		event_type_dom = corestring_dom_mousedown;
		break;

	case JSAPI_PROP_TINYID_onmousemove:
		event_type_dom = corestring_dom_mousemove;
		break;

	case JSAPI_PROP_TINYID_onmouseout:
		event_type_dom = corestring_dom_mouseout;
		break;

	case JSAPI_PROP_TINYID_onmouseover:
		event_type_dom = corestring_dom_mouseover;
		break;

	case JSAPI_PROP_TINYID_onmouseup:
		event_type_dom = corestring_dom_mouseup;
		break;

	case JSAPI_PROP_TINYID_onmousewheel:
		event_type_dom = corestring_dom_mousewheel;
		break;

	case JSAPI_PROP_TINYID_onpause:
		event_type_dom = corestring_dom_pause;
		break;

	case JSAPI_PROP_TINYID_onplay:
		event_type_dom = corestring_dom_play;
		break;

	case JSAPI_PROP_TINYID_onplaying:
		event_type_dom = corestring_dom_playing;
		break;

	case JSAPI_PROP_TINYID_onprogress:
		event_type_dom = corestring_dom_progress;
		break;

	case JSAPI_PROP_TINYID_onratechange:
		event_type_dom = corestring_dom_ratechange;
		break;

	case JSAPI_PROP_TINYID_onreset:
		event_type_dom = corestring_dom_reset;
		break;

	case JSAPI_PROP_TINYID_onscroll:
		event_type_dom = corestring_dom_scroll;
		break;

	case JSAPI_PROP_TINYID_onseeked:
		event_type_dom = corestring_dom_seeked;
		break;

	case JSAPI_PROP_TINYID_onseeking:
		event_type_dom = corestring_dom_seeking;
		break;

	case JSAPI_PROP_TINYID_onselect:
		event_type_dom = corestring_dom_select;
		break;

	case JSAPI_PROP_TINYID_onshow:
		event_type_dom = corestring_dom_show;
		break;

	case JSAPI_PROP_TINYID_onstalled:
		event_type_dom = corestring_dom_stalled;
		break;

	case JSAPI_PROP_TINYID_onsubmit:
		event_type_dom = corestring_dom_submit;
		break;

	case JSAPI_PROP_TINYID_onsuspend:
		event_type_dom = corestring_dom_suspend;
		break;

	case JSAPI_PROP_TINYID_ontimeupdate:
		event_type_dom = corestring_dom_timeupdate;
		break;

	case JSAPI_PROP_TINYID_onvolumechange:
		event_type_dom = corestring_dom_volumechange;
		break;

	case JSAPI_PROP_TINYID_onwaiting:
		event_type_dom = corestring_dom_waiting;
		break;

	case JSAPI_PROP_TINYID_onreadystatechange:
		event_type_dom = corestring_dom_readystatechange;
		break;

	default:
		JSLOG("called with unknown tinyid");
		return JS_TRUE;
	}

	js_dom_event_add_listener((struct jscontext *)cx,
				  private->node,
				  (dom_node *)private->node,
				  event_type_dom,
				  vp);

	return JS_TRUE;
}

static JSBool JSAPI_PROP(EventHandler_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	jsval tinyid_jsval;
	int8_t tinyid = JSAPI_PROP_TINYID_END;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	 /* obtain property tinyid */
	JSAPI_PROP_IDVAL(cx, &tinyid_jsval);
	tinyid = JSVAL_TO_INT(tinyid_jsval);


	JSLOG("propname[%d].name=\"%s\"",
	      tinyid,
	      jsclass_properties[tinyid].name);

        return JS_TRUE;
}

static JSFunctionSpec jsclass_functions[] = {
	/**** Document ****/
	JSAPI_FS(getElementsByName, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(getItems, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(open, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(close, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(write, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(writeln, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(hasFocus, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(execCommand, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(queryCommandEnabled, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(queryCommandIndeterm, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(queryCommandState, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(queryCommandSupported, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(queryCommandValue, 0, JSPROP_ENUMERATE ),
	/**** Document ****/
	JSAPI_FS(clear, 0, JSPROP_ENUMERATE ),
	/**** Document ****/
	JSAPI_FS(getElementsByTagName, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(getElementsByTagNameNS, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(getElementsByClassName, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(getElementById, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(createElement, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(createElementNS, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(createDocumentFragment, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(createTextNode, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(createComment, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(createProcessingInstruction, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(importNode, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(adoptNode, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(createEvent, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(createRange, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(createNodeIterator, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(createTreeWalker, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(prepend, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(append, 0, JSPROP_ENUMERATE ),
	/**** Node ****/
	JSAPI_FS(hasChildNodes, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(insertBefore, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(appendChild, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(replaceChild, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(removeChild, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(normalize, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(cloneNode, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(isEqualNode, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(compareDocumentPosition, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(contains, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(lookupPrefix, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(lookupNamespaceURI, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(isDefaultNamespace, 0, JSPROP_ENUMERATE ),
	/**** EventTarget ****/
	JSAPI_FS(addEventListener, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(removeEventListener, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(dispatchEvent, 0, JSPROP_ENUMERATE ),
	JSAPI_FS_END
};

static JSPropertySpec jsclass_properties[] = {
	/**** Document ****/
	JSAPI_PS("location",
		location,
		JSAPI_PROP_TINYID_location,
		JSPROP_ENUMERATE),
	JSAPI_PS("domain",
		domain,
		JSAPI_PROP_TINYID_domain,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("referrer",
		referrer,
		JSAPI_PROP_TINYID_referrer,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("cookie",
		cookie,
		JSAPI_PROP_TINYID_cookie,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("lastModified",
		lastModified,
		JSAPI_PROP_TINYID_lastModified,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("readyState",
		readyState,
		JSAPI_PROP_TINYID_readyState,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("title",
		title,
		JSAPI_PROP_TINYID_title,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("dir",
		dir,
		JSAPI_PROP_TINYID_dir,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("body",
		body,
		JSAPI_PROP_TINYID_body,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("head",
		head,
		JSAPI_PROP_TINYID_head,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("images",
		images,
		JSAPI_PROP_TINYID_images,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("embeds",
		embeds,
		JSAPI_PROP_TINYID_embeds,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("plugins",
		plugins,
		JSAPI_PROP_TINYID_plugins,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("links",
		links,
		JSAPI_PROP_TINYID_links,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("forms",
		forms,
		JSAPI_PROP_TINYID_forms,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("scripts",
		scripts,
		JSAPI_PROP_TINYID_scripts,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("cssElementMap",
		cssElementMap,
		JSAPI_PROP_TINYID_cssElementMap,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("defaultView",
		defaultView,
		JSAPI_PROP_TINYID_defaultView,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("activeElement",
		activeElement,
		JSAPI_PROP_TINYID_activeElement,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("designMode",
		designMode,
		JSAPI_PROP_TINYID_designMode,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("commands",
		commands,
		JSAPI_PROP_TINYID_commands,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("onabort",
		EventHandler,
		JSAPI_PROP_TINYID_onabort,
		JSPROP_ENUMERATE),
	JSAPI_PS("onblur",
		EventHandler,
		JSAPI_PROP_TINYID_onblur,
		JSPROP_ENUMERATE),
	JSAPI_PS("oncancel",
		EventHandler,
		JSAPI_PROP_TINYID_oncancel,
		JSPROP_ENUMERATE),
	JSAPI_PS("oncanplay",
		EventHandler,
		JSAPI_PROP_TINYID_oncanplay,
		JSPROP_ENUMERATE),
	JSAPI_PS("oncanplaythrough",
		EventHandler,
		JSAPI_PROP_TINYID_oncanplaythrough,
		JSPROP_ENUMERATE),
	JSAPI_PS("onchange",
		EventHandler,
		JSAPI_PROP_TINYID_onchange,
		JSPROP_ENUMERATE),
	JSAPI_PS("onclick",
		EventHandler,
		JSAPI_PROP_TINYID_onclick,
		JSPROP_ENUMERATE),
	JSAPI_PS("onclose",
		EventHandler,
		JSAPI_PROP_TINYID_onclose,
		JSPROP_ENUMERATE),
	JSAPI_PS("oncontextmenu",
		EventHandler,
		JSAPI_PROP_TINYID_oncontextmenu,
		JSPROP_ENUMERATE),
	JSAPI_PS("oncuechange",
		EventHandler,
		JSAPI_PROP_TINYID_oncuechange,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondblclick",
		EventHandler,
		JSAPI_PROP_TINYID_ondblclick,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondrag",
		EventHandler,
		JSAPI_PROP_TINYID_ondrag,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondragend",
		EventHandler,
		JSAPI_PROP_TINYID_ondragend,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondragenter",
		EventHandler,
		JSAPI_PROP_TINYID_ondragenter,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondragleave",
		EventHandler,
		JSAPI_PROP_TINYID_ondragleave,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondragover",
		EventHandler,
		JSAPI_PROP_TINYID_ondragover,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondragstart",
		EventHandler,
		JSAPI_PROP_TINYID_ondragstart,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondrop",
		EventHandler,
		JSAPI_PROP_TINYID_ondrop,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondurationchange",
		EventHandler,
		JSAPI_PROP_TINYID_ondurationchange,
		JSPROP_ENUMERATE),
	JSAPI_PS("onemptied",
		EventHandler,
		JSAPI_PROP_TINYID_onemptied,
		JSPROP_ENUMERATE),
	JSAPI_PS("onended",
		EventHandler,
		JSAPI_PROP_TINYID_onended,
		JSPROP_ENUMERATE),
	JSAPI_PS("onerror",
		onerror,
		JSAPI_PROP_TINYID_onerror,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("onfocus",
		EventHandler,
		JSAPI_PROP_TINYID_onfocus,
		JSPROP_ENUMERATE),
	JSAPI_PS("oninput",
		EventHandler,
		JSAPI_PROP_TINYID_oninput,
		JSPROP_ENUMERATE),
	JSAPI_PS("oninvalid",
		EventHandler,
		JSAPI_PROP_TINYID_oninvalid,
		JSPROP_ENUMERATE),
	JSAPI_PS("onkeydown",
		EventHandler,
		JSAPI_PROP_TINYID_onkeydown,
		JSPROP_ENUMERATE),
	JSAPI_PS("onkeypress",
		EventHandler,
		JSAPI_PROP_TINYID_onkeypress,
		JSPROP_ENUMERATE),
	JSAPI_PS("onkeyup",
		EventHandler,
		JSAPI_PROP_TINYID_onkeyup,
		JSPROP_ENUMERATE),
	JSAPI_PS("onload",
		EventHandler,
		JSAPI_PROP_TINYID_onload,
		JSPROP_ENUMERATE),
	JSAPI_PS("onloadeddata",
		EventHandler,
		JSAPI_PROP_TINYID_onloadeddata,
		JSPROP_ENUMERATE),
	JSAPI_PS("onloadedmetadata",
		EventHandler,
		JSAPI_PROP_TINYID_onloadedmetadata,
		JSPROP_ENUMERATE),
	JSAPI_PS("onloadstart",
		EventHandler,
		JSAPI_PROP_TINYID_onloadstart,
		JSPROP_ENUMERATE),
	JSAPI_PS("onmousedown",
		EventHandler,
		JSAPI_PROP_TINYID_onmousedown,
		JSPROP_ENUMERATE),
	JSAPI_PS("onmousemove",
		EventHandler,
		JSAPI_PROP_TINYID_onmousemove,
		JSPROP_ENUMERATE),
	JSAPI_PS("onmouseout",
		EventHandler,
		JSAPI_PROP_TINYID_onmouseout,
		JSPROP_ENUMERATE),
	JSAPI_PS("onmouseover",
		EventHandler,
		JSAPI_PROP_TINYID_onmouseover,
		JSPROP_ENUMERATE),
	JSAPI_PS("onmouseup",
		EventHandler,
		JSAPI_PROP_TINYID_onmouseup,
		JSPROP_ENUMERATE),
	JSAPI_PS("onmousewheel",
		EventHandler,
		JSAPI_PROP_TINYID_onmousewheel,
		JSPROP_ENUMERATE),
	JSAPI_PS("onpause",
		EventHandler,
		JSAPI_PROP_TINYID_onpause,
		JSPROP_ENUMERATE),
	JSAPI_PS("onplay",
		EventHandler,
		JSAPI_PROP_TINYID_onplay,
		JSPROP_ENUMERATE),
	JSAPI_PS("onplaying",
		EventHandler,
		JSAPI_PROP_TINYID_onplaying,
		JSPROP_ENUMERATE),
	JSAPI_PS("onprogress",
		EventHandler,
		JSAPI_PROP_TINYID_onprogress,
		JSPROP_ENUMERATE),
	JSAPI_PS("onratechange",
		EventHandler,
		JSAPI_PROP_TINYID_onratechange,
		JSPROP_ENUMERATE),
	JSAPI_PS("onreset",
		EventHandler,
		JSAPI_PROP_TINYID_onreset,
		JSPROP_ENUMERATE),
	JSAPI_PS("onscroll",
		EventHandler,
		JSAPI_PROP_TINYID_onscroll,
		JSPROP_ENUMERATE),
	JSAPI_PS("onseeked",
		EventHandler,
		JSAPI_PROP_TINYID_onseeked,
		JSPROP_ENUMERATE),
	JSAPI_PS("onseeking",
		EventHandler,
		JSAPI_PROP_TINYID_onseeking,
		JSPROP_ENUMERATE),
	JSAPI_PS("onselect",
		EventHandler,
		JSAPI_PROP_TINYID_onselect,
		JSPROP_ENUMERATE),
	JSAPI_PS("onshow",
		EventHandler,
		JSAPI_PROP_TINYID_onshow,
		JSPROP_ENUMERATE),
	JSAPI_PS("onstalled",
		EventHandler,
		JSAPI_PROP_TINYID_onstalled,
		JSPROP_ENUMERATE),
	JSAPI_PS("onsubmit",
		EventHandler,
		JSAPI_PROP_TINYID_onsubmit,
		JSPROP_ENUMERATE),
	JSAPI_PS("onsuspend",
		EventHandler,
		JSAPI_PROP_TINYID_onsuspend,
		JSPROP_ENUMERATE),
	JSAPI_PS("ontimeupdate",
		EventHandler,
		JSAPI_PROP_TINYID_ontimeupdate,
		JSPROP_ENUMERATE),
	JSAPI_PS("onvolumechange",
		EventHandler,
		JSAPI_PROP_TINYID_onvolumechange,
		JSPROP_ENUMERATE),
	JSAPI_PS("onwaiting",
		EventHandler,
		JSAPI_PROP_TINYID_onwaiting,
		JSPROP_ENUMERATE),
	JSAPI_PS("onreadystatechange",
		EventHandler,
		JSAPI_PROP_TINYID_onreadystatechange,
		JSPROP_ENUMERATE),
	/**** Document ****/
	JSAPI_PS("fgColor",
		fgColor,
		JSAPI_PROP_TINYID_fgColor,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("linkColor",
		linkColor,
		JSAPI_PROP_TINYID_linkColor,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("vlinkColor",
		vlinkColor,
		JSAPI_PROP_TINYID_vlinkColor,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("alinkColor",
		alinkColor,
		JSAPI_PROP_TINYID_alinkColor,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("bgColor",
		bgColor,
		JSAPI_PROP_TINYID_bgColor,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("anchors",
		anchors,
		JSAPI_PROP_TINYID_anchors,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("applets",
		applets,
		JSAPI_PROP_TINYID_applets,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("all",
		all,
		JSAPI_PROP_TINYID_all,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	/**** Document ****/
	JSAPI_PS_RO("implementation",
		implementation,
		JSAPI_PROP_TINYID_implementation,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("URL",
		URL,
		JSAPI_PROP_TINYID_URL,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("documentURI",
		documentURI,
		JSAPI_PROP_TINYID_documentURI,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("compatMode",
		compatMode,
		JSAPI_PROP_TINYID_compatMode,
		JSPROP_ENUMERATE),
	JSAPI_PS_RO("characterSet",
		characterSet,
		JSAPI_PROP_TINYID_characterSet,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("contentType",
		contentType,
		JSAPI_PROP_TINYID_contentType,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("doctype",
		doctype,
		JSAPI_PROP_TINYID_doctype,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("documentElement",
		documentElement,
		JSAPI_PROP_TINYID_documentElement,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	/**** Node ****/
	JSAPI_PS_RO("nodeType",
		nodeType,
		JSAPI_PROP_TINYID_nodeType,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("nodeName",
		nodeName,
		JSAPI_PROP_TINYID_nodeName,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("baseURI",
		baseURI,
		JSAPI_PROP_TINYID_baseURI,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("ownerDocument",
		ownerDocument,
		JSAPI_PROP_TINYID_ownerDocument,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("parentNode",
		parentNode,
		JSAPI_PROP_TINYID_parentNode,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("parentElement",
		parentElement,
		JSAPI_PROP_TINYID_parentElement,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("childNodes",
		childNodes,
		JSAPI_PROP_TINYID_childNodes,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("firstChild",
		firstChild,
		JSAPI_PROP_TINYID_firstChild,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("lastChild",
		lastChild,
		JSAPI_PROP_TINYID_lastChild,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("previousSibling",
		previousSibling,
		JSAPI_PROP_TINYID_previousSibling,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("nextSibling",
		nextSibling,
		JSAPI_PROP_TINYID_nextSibling,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("nodeValue",
		nodeValue,
		JSAPI_PROP_TINYID_nodeValue,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("textContent",
		textContent,
		JSAPI_PROP_TINYID_textContent,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	/**** EventTarget ****/
	JSAPI_PS_END
};

static void jsclass_finalize(JSContext *cx, JSObject *obj)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Document, NULL);
	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	LOG(("jscontext:%p jsobject:%p private:%p", cx, obj, private));
	if (private != NULL) {
		JSLOG("dom_document %p in content %p",
		     private->node, private->htmlc);
		dom_node_unref(private->node);
	}

	if (private != NULL) {
		free(private);
	}
}

JSObject *jsapi_InitClass_Document(JSContext *cx, JSObject *parent)
{
	JSObject *prototype;

	prototype = JS_InitClass(cx,
		parent,
		NULL,
		&JSClass_Document,
		NULL,
		0,
		NULL,
		NULL, 
		NULL, 
		NULL);
	/**** Document ****/
	/**** Document ****/
	/**** Document ****/
	/**** Node ****/
	JS_DefineProperty(cx,
		prototype,
		"ELEMENT_NODE",
		INT_TO_JSVAL(1),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"ATTRIBUTE_NODE",
		INT_TO_JSVAL(2),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"TEXT_NODE",
		INT_TO_JSVAL(3),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"CDATA_SECTION_NODE",
		INT_TO_JSVAL(4),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"ENTITY_REFERENCE_NODE",
		INT_TO_JSVAL(5),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"ENTITY_NODE",
		INT_TO_JSVAL(6),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"PROCESSING_INSTRUCTION_NODE",
		INT_TO_JSVAL(7),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"COMMENT_NODE",
		INT_TO_JSVAL(8),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_NODE",
		INT_TO_JSVAL(9),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_TYPE_NODE",
		INT_TO_JSVAL(10),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_FRAGMENT_NODE",
		INT_TO_JSVAL(11),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"NOTATION_NODE",
		INT_TO_JSVAL(12),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_POSITION_DISCONNECTED",
		INT_TO_JSVAL(1),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_POSITION_PRECEDING",
		INT_TO_JSVAL(2),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_POSITION_FOLLOWING",
		INT_TO_JSVAL(4),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_POSITION_CONTAINS",
		INT_TO_JSVAL(8),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_POSITION_CONTAINED_BY",
		INT_TO_JSVAL(16),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC",
		INT_TO_JSVAL(32),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	/**** EventTarget ****/
	return prototype;
}

JSObject *jsapi_new_Document(JSContext *cx,
		JSObject *prototype,
		JSObject *parent,
		dom_document *node,
		struct html_content *htmlc)
{
	JSObject *newobject;
	struct jsclass_private *private;

	private = malloc(sizeof(struct jsclass_private));
	if (private == NULL) {
		return NULL;
	}
	private->node = node;
	private->htmlc = htmlc;

	newobject = JS_NewObject(cx, &JSClass_Document, prototype, parent);
	if (newobject == NULL) {
		free(private);
		return NULL;
	}

	if (JSAPI_ADD_OBJECT_ROOT(cx, &newobject) != JS_TRUE) {
		free(private);
		return NULL;
	}


	/* attach private pointer */
	if (JS_SetPrivate(cx, newobject, private) != JS_TRUE) {
		free(private);
		return NULL;
	}

	if (JS_DefineFunctions(cx, newobject, jsclass_functions) != JS_TRUE) {
		free(private);
		return NULL;
	}

	if (JS_DefineProperties(cx, newobject, jsclass_properties) != JS_TRUE) {
		free(private);
		return NULL;
	}

	JSAPI_REMOVE_OBJECT_ROOT(cx, &newobject);

	return newobject;
}


