/* Generated by nsgenbind from javascript/jsapi/htmlelement.bnd
 *
 * nsgenbind is published under the MIT Licence.
 * nsgenbind is similar to a compiler is a purely transformative tool which
 * explicitly makes no copyright claim on this generated output
 * 
 * Copyright 2012 Vincent Sanders <vince@netsurf-browser.org>
 * 
 * This file is part of NetSurf, http://www.netsurf-browser.org/
 * 
 * Released under the terms of the MIT License,
 * 
 *         http://www.opensource.org/licenses/mit-license
 */



#include <dom/dom.h>

#include "utils/config.h"
#include "utils/log.h"
#include "utils/corestrings.h"
#include "javascript/js.h"
#include "javascript/jsapi.h"
#include "render/html_internal.h"

#include "htmlelement.h"
#include "text.h"
#include "location.h"
#include "nodelist.h"


#include "comment.h"
#include "text.h"
#include "htmlelement.h"


struct jsclass_private {
        dom_element *node;
        struct html_content *htmlc;
};

static void jsclass_finalize(JSContext *cx, JSObject *obj);

static JSPropertySpec jsclass_properties[];

JSClass JSClass_HTMLElement = {
	"HTMLElement",
	0 | JSCLASS_HAS_PRIVATE,
	JS_PropertyStub,	/* addProperty */
	JS_PropertyStub,	/* delProperty */
	JS_PropertyStub,	/* getProperty */
	JS_StrictPropertyStub,	/* setProperty */
	JS_EnumerateStub,	/* enumerate */
	JS_ResolveStub,
	JS_ConvertStub,	/* convert */
	jsclass_finalize,
	0,	/* reserved */
	NULL,	/* checkAccess */
	NULL,	/* call */
	NULL,	/* construct */
	NULL,	/* xdr Object */
	NULL,	/* hasInstance */
	NULL, /* trace/mark */
	JSAPI_CLASS_NO_INTERNAL_MEMBERS
};

enum property_tinyid {
	/**** HTMLElement ****/
	JSAPI_PROP_TINYID_title,
	JSAPI_PROP_TINYID_lang,
	JSAPI_PROP_TINYID_translate,
	JSAPI_PROP_TINYID_dir,
	JSAPI_PROP_TINYID_dataset,
	JSAPI_PROP_TINYID_itemScope,
	JSAPI_PROP_TINYID_itemType,
	JSAPI_PROP_TINYID_itemId,
	JSAPI_PROP_TINYID_itemRef,
	JSAPI_PROP_TINYID_itemProp,
	JSAPI_PROP_TINYID_properties,
	JSAPI_PROP_TINYID_itemValue,
	JSAPI_PROP_TINYID_hidden,
	JSAPI_PROP_TINYID_tabIndex,
	JSAPI_PROP_TINYID_accessKey,
	JSAPI_PROP_TINYID_accessKeyLabel,
	JSAPI_PROP_TINYID_draggable,
	JSAPI_PROP_TINYID_dropzone,
	JSAPI_PROP_TINYID_contentEditable,
	JSAPI_PROP_TINYID_isContentEditable,
	JSAPI_PROP_TINYID_contextMenu,
	JSAPI_PROP_TINYID_spellcheck,
	JSAPI_PROP_TINYID_commandType,
	JSAPI_PROP_TINYID_commandLabel,
	JSAPI_PROP_TINYID_commandIcon,
	JSAPI_PROP_TINYID_commandHidden,
	JSAPI_PROP_TINYID_commandDisabled,
	JSAPI_PROP_TINYID_commandChecked,
	JSAPI_PROP_TINYID_style,
	JSAPI_PROP_TINYID_onabort,
	JSAPI_PROP_TINYID_onblur,
	JSAPI_PROP_TINYID_oncancel,
	JSAPI_PROP_TINYID_oncanplay,
	JSAPI_PROP_TINYID_oncanplaythrough,
	JSAPI_PROP_TINYID_onchange,
	JSAPI_PROP_TINYID_onclick,
	JSAPI_PROP_TINYID_onclose,
	JSAPI_PROP_TINYID_oncontextmenu,
	JSAPI_PROP_TINYID_oncuechange,
	JSAPI_PROP_TINYID_ondblclick,
	JSAPI_PROP_TINYID_ondrag,
	JSAPI_PROP_TINYID_ondragend,
	JSAPI_PROP_TINYID_ondragenter,
	JSAPI_PROP_TINYID_ondragleave,
	JSAPI_PROP_TINYID_ondragover,
	JSAPI_PROP_TINYID_ondragstart,
	JSAPI_PROP_TINYID_ondrop,
	JSAPI_PROP_TINYID_ondurationchange,
	JSAPI_PROP_TINYID_onemptied,
	JSAPI_PROP_TINYID_onended,
	JSAPI_PROP_TINYID_onerror,
	JSAPI_PROP_TINYID_onfocus,
	JSAPI_PROP_TINYID_oninput,
	JSAPI_PROP_TINYID_oninvalid,
	JSAPI_PROP_TINYID_onkeydown,
	JSAPI_PROP_TINYID_onkeypress,
	JSAPI_PROP_TINYID_onkeyup,
	JSAPI_PROP_TINYID_onload,
	JSAPI_PROP_TINYID_onloadeddata,
	JSAPI_PROP_TINYID_onloadedmetadata,
	JSAPI_PROP_TINYID_onloadstart,
	JSAPI_PROP_TINYID_onmousedown,
	JSAPI_PROP_TINYID_onmousemove,
	JSAPI_PROP_TINYID_onmouseout,
	JSAPI_PROP_TINYID_onmouseover,
	JSAPI_PROP_TINYID_onmouseup,
	JSAPI_PROP_TINYID_onmousewheel,
	JSAPI_PROP_TINYID_onpause,
	JSAPI_PROP_TINYID_onplay,
	JSAPI_PROP_TINYID_onplaying,
	JSAPI_PROP_TINYID_onprogress,
	JSAPI_PROP_TINYID_onratechange,
	JSAPI_PROP_TINYID_onreset,
	JSAPI_PROP_TINYID_onscroll,
	JSAPI_PROP_TINYID_onseeked,
	JSAPI_PROP_TINYID_onseeking,
	JSAPI_PROP_TINYID_onselect,
	JSAPI_PROP_TINYID_onshow,
	JSAPI_PROP_TINYID_onstalled,
	JSAPI_PROP_TINYID_onsubmit,
	JSAPI_PROP_TINYID_onsuspend,
	JSAPI_PROP_TINYID_ontimeupdate,
	JSAPI_PROP_TINYID_onvolumechange,
	JSAPI_PROP_TINYID_onwaiting,
	/**** Element ****/
	JSAPI_PROP_TINYID_namespaceURI,
	JSAPI_PROP_TINYID_prefix,
	JSAPI_PROP_TINYID_localName,
	JSAPI_PROP_TINYID_tagName,
	JSAPI_PROP_TINYID_id,
	JSAPI_PROP_TINYID_className,
	JSAPI_PROP_TINYID_classList,
	JSAPI_PROP_TINYID_attributes,
	JSAPI_PROP_TINYID_children,
	JSAPI_PROP_TINYID_firstElementChild,
	JSAPI_PROP_TINYID_lastElementChild,
	JSAPI_PROP_TINYID_previousElementSibling,
	JSAPI_PROP_TINYID_nextElementSibling,
	JSAPI_PROP_TINYID_childElementCount,
	/**** Node ****/
	JSAPI_PROP_TINYID_nodeType,
	JSAPI_PROP_TINYID_nodeName,
	JSAPI_PROP_TINYID_baseURI,
	JSAPI_PROP_TINYID_ownerDocument,
	JSAPI_PROP_TINYID_parentNode,
	JSAPI_PROP_TINYID_parentElement,
	JSAPI_PROP_TINYID_childNodes,
	JSAPI_PROP_TINYID_firstChild,
	JSAPI_PROP_TINYID_lastChild,
	JSAPI_PROP_TINYID_previousSibling,
	JSAPI_PROP_TINYID_nextSibling,
	JSAPI_PROP_TINYID_nodeValue,
	JSAPI_PROP_TINYID_textContent,
	/**** EventTarget ****/
	JSAPI_PROP_TINYID_END,
};


/* CAUTION this expects all javascript Node objects private pointers
 * to have private->node in the same place.
 */
static struct dom_node *jsnode_to_domnode(JSContext *cx, JSObject *jsnode)
{
	struct jsclass_private *jsnode_private;

	if (jsnode == NULL) {
		return NULL;
	}

	/* element */
	jsnode_private = JS_GetInstancePrivate(cx,
					       jsnode,
					       &JSClass_HTMLElement,
					       NULL);
	if (jsnode_private != NULL) {
		return (struct dom_node *)jsnode_private->node;
	}

	/* text */
	jsnode_private = JS_GetInstancePrivate(cx,
					       jsnode,
					       &JSClass_Text,
					       NULL);
	if (jsnode_private != NULL) {
		return (struct dom_node *)jsnode_private->node;
	}

	/* comment */
	jsnode_private = JS_GetInstancePrivate(cx,
					       jsnode,
					       &JSClass_Comment,
					       NULL);
	if (jsnode_private != NULL) {
		return (struct dom_node *)jsnode_private->node;
	}

	return NULL;
}



/**** HTMLElement ****/
static JSBool JSAPI_FUNC(click, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation HTMLElement.click has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(focus, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation HTMLElement.focus has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(blur, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation HTMLElement.blur has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(forceSpellCheck, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation HTMLElement.forceSpellCheck has no implementation");
	return JS_TRUE;
}

/**** Element ****/
static JSBool JSAPI_FUNC(getAttribute, JSContext *cx, uintN argc, jsval *vp)
{
	JSString *jsret = NULL;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *name_jsstr = NULL;
	int name_len = 0;
	char *name = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		name_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		name_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (name_jsstr != NULL) {
		JSString_to_char(name_jsstr, name, name_len);
	}


	dom_string *value;
	dom_string *name_dom;
	dom_exception exc;

	exc = dom_string_create((unsigned char*)name, name_len, &name_dom);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	exc = dom_element_get_attribute(private->node, name_dom, &value);
	dom_string_unref(name_dom);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	if (value != NULL) {
		jsret = JS_NewStringCopyN(cx, dom_string_data(value), dom_string_length(value));
		dom_string_unref(value);
	}

	JSAPI_FUNC_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(getAttributeNS, JSContext *cx, uintN argc, jsval *vp)
{
	JSString *jsret = NULL;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *namespace_jsstr = NULL;
	int namespace_len = 0;
	char *namespace = NULL;
	JSString *localName_jsstr = NULL;
	int localName_len = 0;
	char *localName = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		namespace_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		namespace_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (namespace_jsstr != NULL) {
		JSString_to_char(namespace_jsstr, namespace, namespace_len);
	}

	if (argc > 1) {
		localName_jsstr = JS_ValueToString(cx, argv[1]);
	} else {
		localName_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (localName_jsstr != NULL) {
		JSString_to_char(localName_jsstr, localName, localName_len);
	}

	JSLOG("operation HTMLElement.getAttributeNS has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(setAttribute, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *name_jsstr = NULL;
	int name_len = 0;
	char *name = NULL;
	JSString *value_jsstr = NULL;
	int value_len = 0;
	char *value = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		name_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		name_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (name_jsstr != NULL) {
		JSString_to_char(name_jsstr, name, name_len);
	}

	if (argc > 1) {
		value_jsstr = JS_ValueToString(cx, argv[1]);
	} else {
		value_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (value_jsstr != NULL) {
		JSString_to_char(value_jsstr, value, value_len);
	}


	dom_string *value_dom;
	dom_string *name_dom;
	dom_exception exc;

	exc = dom_string_create((unsigned char*)name, name_len, &name_dom);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	exc = dom_string_create((unsigned char*)name, name_len, &value_dom);
	if (exc != DOM_NO_ERR) {
		dom_string_unref(name_dom);
		return JS_FALSE;
	}

	exc = dom_element_set_attribute(private->node, name_dom, value_dom);
	dom_string_unref(name_dom);
	dom_string_unref(value_dom);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	return JS_TRUE;
}

static JSBool JSAPI_FUNC(setAttributeNS, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *namespace_jsstr = NULL;
	int namespace_len = 0;
	char *namespace = NULL;
	JSString *name_jsstr = NULL;
	int name_len = 0;
	char *name = NULL;
	JSString *value_jsstr = NULL;
	int value_len = 0;
	char *value = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		namespace_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		namespace_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (namespace_jsstr != NULL) {
		JSString_to_char(namespace_jsstr, namespace, namespace_len);
	}

	if (argc > 1) {
		name_jsstr = JS_ValueToString(cx, argv[1]);
	} else {
		name_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (name_jsstr != NULL) {
		JSString_to_char(name_jsstr, name, name_len);
	}

	if (argc > 2) {
		value_jsstr = JS_ValueToString(cx, argv[2]);
	} else {
		value_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (value_jsstr != NULL) {
		JSString_to_char(value_jsstr, value, value_len);
	}

	JSLOG("operation HTMLElement.setAttributeNS has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(removeAttribute, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *name_jsstr = NULL;
	int name_len = 0;
	char *name = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		name_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		name_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (name_jsstr != NULL) {
		JSString_to_char(name_jsstr, name, name_len);
	}


	dom_string *name_dom;
	dom_exception exc;

	exc = dom_string_create((unsigned char*)name, name_len, &name_dom);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	exc = dom_element_remove_attribute(private->node, name_dom);
	dom_string_unref(name_dom);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	return JS_TRUE;
}

static JSBool JSAPI_FUNC(removeAttributeNS, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *namespace_jsstr = NULL;
	int namespace_len = 0;
	char *namespace = NULL;
	JSString *localName_jsstr = NULL;
	int localName_len = 0;
	char *localName = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		namespace_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		namespace_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (namespace_jsstr != NULL) {
		JSString_to_char(namespace_jsstr, namespace, namespace_len);
	}

	if (argc > 1) {
		localName_jsstr = JS_ValueToString(cx, argv[1]);
	} else {
		localName_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (localName_jsstr != NULL) {
		JSString_to_char(localName_jsstr, localName, localName_len);
	}

	JSLOG("operation HTMLElement.removeAttributeNS has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(hasAttribute, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *name_jsstr = NULL;
	int name_len = 0;
	char *name = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		name_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		name_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (name_jsstr != NULL) {
		JSString_to_char(name_jsstr, name, name_len);
	}


	bool result;
	dom_string *name_dom;
	dom_exception exc;

	exc = dom_string_create((unsigned char*)name, name_len, &name_dom);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	exc = dom_element_has_attribute(private->node, name_dom, &result);
	dom_string_unref(name_dom);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	if (result) {
		jsret = JS_TRUE;
	}

	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(hasAttributeNS, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *namespace_jsstr = NULL;
	int namespace_len = 0;
	char *namespace = NULL;
	JSString *localName_jsstr = NULL;
	int localName_len = 0;
	char *localName = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		namespace_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		namespace_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (namespace_jsstr != NULL) {
		JSString_to_char(namespace_jsstr, namespace, namespace_len);
	}

	if (argc > 1) {
		localName_jsstr = JS_ValueToString(cx, argv[1]);
	} else {
		localName_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (localName_jsstr != NULL) {
		JSString_to_char(localName_jsstr, localName, localName_len);
	}

	JSLOG("operation HTMLElement.hasAttributeNS has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(getElementsByTagName, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* HTMLCollection */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *localName_jsstr = NULL;
	int localName_len = 0;
	char *localName = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		localName_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		localName_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (localName_jsstr != NULL) {
		JSString_to_char(localName_jsstr, localName, localName_len);
	}


	dom_string *localName_dom;
	/* dom_html_collection *collection;*/
	dom_nodelist *nodelist;
	dom_exception exc;

	exc = dom_string_create((uint8_t *)localName, localName_len, &localName_dom);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	exc = dom_element_get_elements_by_tag_name(private->node, localName_dom, /*&collection*/&nodelist);
	dom_string_unref(localName_dom);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	if (/*collection*/nodelist != NULL) {
		/*jsret = jsapi_new_HTMLCollection(cx,
						 NULL,
						 NULL,
						 collection,
						 private->htmlc);*/
		jsret = jsapi_new_NodeList(cx,
						 NULL,
						 NULL,
						 nodelist,
						 private->htmlc);
	}


	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(getElementsByTagNameNS, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* HTMLCollection */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *namespace_jsstr = NULL;
	int namespace_len = 0;
	char *namespace = NULL;
	JSString *localName_jsstr = NULL;
	int localName_len = 0;
	char *localName = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		namespace_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		namespace_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (namespace_jsstr != NULL) {
		JSString_to_char(namespace_jsstr, namespace, namespace_len);
	}

	if (argc > 1) {
		localName_jsstr = JS_ValueToString(cx, argv[1]);
	} else {
		localName_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (localName_jsstr != NULL) {
		JSString_to_char(localName_jsstr, localName, localName_len);
	}

	JSLOG("operation HTMLElement.getElementsByTagNameNS has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(getElementsByClassName, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* HTMLCollection */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *classNames_jsstr = NULL;
	int classNames_len = 0;
	char *classNames = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		classNames_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		classNames_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (classNames_jsstr != NULL) {
		JSString_to_char(classNames_jsstr, classNames, classNames_len);
	}

	JSLOG("operation HTMLElement.getElementsByClassName has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(prepend, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation HTMLElement.prepend has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(append, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation HTMLElement.append has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(before, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation HTMLElement.before has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(after, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation HTMLElement.after has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(replace, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation HTMLElement.replace has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(remove, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation HTMLElement.remove has no implementation");
	return JS_TRUE;
}

/**** Node ****/
static JSBool JSAPI_FUNC(hasChildNodes, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation HTMLElement.hasChildNodes has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(insertBefore, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *node = NULL;
	JSObject *child = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	node = JSVAL_TO_OBJECT(argv[0]);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[1])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[1]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	child = JSVAL_TO_OBJECT(argv[1]);
	JSLOG("operation HTMLElement.insertBefore has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(appendChild, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *node = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	node = JSVAL_TO_OBJECT(argv[0]);

	struct dom_node *domnode; /* dom node from js input node */
	struct dom_node *result = NULL;
	dom_exception exc;
	dom_node_type node_type;

	domnode = jsnode_to_domnode(cx, node);
	if (domnode == NULL) {
		/* should cause Error: NOT_FOUND_ERR: DOM Exception 8 */
		JSLOG("Error: NOT_FOUND_ERR: DOM Exception 8");
		return JS_FALSE;
	}

	JSLOG("appending js node %p (dom %p)", node, domnode);

	/* append the found element */
	exc = dom_node_append_child(private->node, domnode, &result);
	if (exc != DOM_NO_ERR) {
		JSLOG("Error: DOM Exception (libdom append child)");
		return JS_FALSE;
	}

	if (result != NULL) {
		exc = dom_node_get_node_type(result, &node_type);
		if (exc != DOM_NO_ERR) {
			return JS_FALSE;
		}
		switch (node_type) {
		case DOM_ELEMENT_NODE:
			jsret = jsapi_new_HTMLElement(cx, NULL, NULL, (dom_element *)result, private->htmlc);
			break;

		case DOM_TEXT_NODE:
			jsret = jsapi_new_Text(cx, NULL, NULL, (dom_text *)result, private->htmlc);
			break;

		default:
			JSLOG("Unsupported result node type %d", node_type);
		}

	} else {
		JSLOG("No result");
	}

	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(replaceChild, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *node = NULL;
	JSObject *child = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	node = JSVAL_TO_OBJECT(argv[0]);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[1])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[1]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	child = JSVAL_TO_OBJECT(argv[1]);
	JSLOG("operation HTMLElement.replaceChild has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(removeChild, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *child = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	child = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation HTMLElement.removeChild has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(normalize, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation HTMLElement.normalize has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(cloneNode, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation HTMLElement.cloneNode has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(isEqualNode, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *node = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	node = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation HTMLElement.isEqualNode has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(compareDocumentPosition, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *other = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	other = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation HTMLElement.compareDocumentPosition has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(contains, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *other = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	other = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation HTMLElement.contains has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(lookupPrefix, JSContext *cx, uintN argc, jsval *vp)
{
	JSString *jsret = NULL;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *namespace_jsstr = NULL;
	int namespace_len = 0;
	char *namespace = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		namespace_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		namespace_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (namespace_jsstr != NULL) {
		JSString_to_char(namespace_jsstr, namespace, namespace_len);
	}

	JSLOG("operation HTMLElement.lookupPrefix has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(lookupNamespaceURI, JSContext *cx, uintN argc, jsval *vp)
{
	JSString *jsret = NULL;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *prefix_jsstr = NULL;
	int prefix_len = 0;
	char *prefix = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		prefix_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		prefix_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (prefix_jsstr != NULL) {
		JSString_to_char(prefix_jsstr, prefix, prefix_len);
	}

	JSLOG("operation HTMLElement.lookupNamespaceURI has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(isDefaultNamespace, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *namespace_jsstr = NULL;
	int namespace_len = 0;
	char *namespace = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		namespace_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		namespace_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (namespace_jsstr != NULL) {
		JSString_to_char(namespace_jsstr, namespace, namespace_len);
	}

	JSLOG("operation HTMLElement.isDefaultNamespace has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** EventTarget ****/
static JSBool JSAPI_FUNC(addEventListener, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *type_jsstr = NULL;
	int type_len = 0;
	char *type = NULL;
	JSObject *callback = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		type_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		type_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (type_jsstr != NULL) {
		JSString_to_char(type_jsstr, type, type_len);
	}

	if (!JSAPI_JSVAL_IS_OBJECT(argv[1])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[1]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	callback = JSVAL_TO_OBJECT(argv[1]);
	JSLOG("operation HTMLElement.addEventListener has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(removeEventListener, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *type_jsstr = NULL;
	int type_len = 0;
	char *type = NULL;
	JSObject *callback = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		type_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		type_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (type_jsstr != NULL) {
		JSString_to_char(type_jsstr, type, type_len);
	}

	if (!JSAPI_JSVAL_IS_OBJECT(argv[1])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[1]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	callback = JSVAL_TO_OBJECT(argv[1]);
	JSLOG("operation HTMLElement.removeEventListener has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(dispatchEvent, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *event = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLElement,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	event = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation HTMLElement.dispatchEvent has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** HTMLElement ****/
static JSBool JSAPI_STRICTPROP(title_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.title has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(title_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.title has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(lang_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.lang has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(lang_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.lang has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(translate_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.translate has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(translate_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.translate has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(dir_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.dir has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(dir_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.dir has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(dataset_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* DOMStringMap */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.dataset has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(itemScope_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.itemScope has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(itemScope_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.itemScope has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

/* PutForwards setter */
static JSBool JSAPI_STRICTPROP(itemType_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	jsval propval;
	if (JS_GetProperty(cx, obj, "itemType", &propval) == JS_TRUE) {
		JS_SetProperty(cx, JSVAL_TO_OBJECT(propval), "value", vp);
	}
	return JS_FALSE; /* disallow the asignment */
}

static JSBool JSAPI_PROP(itemType_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* DOMSettableTokenList */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.itemType has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(itemId_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.itemId has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(itemId_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.itemId has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

/* PutForwards setter */
static JSBool JSAPI_STRICTPROP(itemRef_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	jsval propval;
	if (JS_GetProperty(cx, obj, "itemRef", &propval) == JS_TRUE) {
		JS_SetProperty(cx, JSVAL_TO_OBJECT(propval), "value", vp);
	}
	return JS_FALSE; /* disallow the asignment */
}

static JSBool JSAPI_PROP(itemRef_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* DOMSettableTokenList */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.itemRef has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

/* PutForwards setter */
static JSBool JSAPI_STRICTPROP(itemProp_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	jsval propval;
	if (JS_GetProperty(cx, obj, "itemProp", &propval) == JS_TRUE) {
		JS_SetProperty(cx, JSVAL_TO_OBJECT(propval), "value", vp);
	}
	return JS_FALSE; /* disallow the asignment */
}

static JSBool JSAPI_PROP(itemProp_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* DOMSettableTokenList */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.itemProp has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(properties_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* HTMLPropertiesCollection */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.properties has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(itemValue_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.itemValue has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(itemValue_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.itemValue has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(hidden_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.hidden has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(hidden_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.hidden has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(tabIndex_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.tabIndex has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(tabIndex_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	int32_t jsret = 0;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.tabIndex has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, INT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(accessKey_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.accessKey has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(accessKey_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.accessKey has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(accessKeyLabel_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.accessKeyLabel has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(draggable_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.draggable has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(draggable_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.draggable has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

/* PutForwards setter */
static JSBool JSAPI_STRICTPROP(dropzone_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	jsval propval;
	if (JS_GetProperty(cx, obj, "dropzone", &propval) == JS_TRUE) {
		JS_SetProperty(cx, JSVAL_TO_OBJECT(propval), "value", vp);
	}
	return JS_FALSE; /* disallow the asignment */
}

static JSBool JSAPI_PROP(dropzone_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* DOMSettableTokenList */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.dropzone has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(contentEditable_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.contentEditable has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(contentEditable_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.contentEditable has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(isContentEditable_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.isContentEditable has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(contextMenu_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.contextMenu has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(contextMenu_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* HTMLMenuElement */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.contextMenu has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(spellcheck_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.spellcheck has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(spellcheck_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.spellcheck has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(commandType_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.commandType has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(commandLabel_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.commandLabel has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(commandIcon_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.commandIcon has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(commandHidden_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.commandHidden has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(commandDisabled_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.commandDisabled has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(commandChecked_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.commandChecked has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(style_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* CSSStyleDeclaration */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.style has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(onerror_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.onerror has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(onerror_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* OnErrorEventHandler */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.onerror has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** Element ****/
static JSBool JSAPI_PROP(namespaceURI_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.namespaceURI has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(prefix_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.prefix has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(localName_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.localName has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(tagName_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	if (!JSVAL_IS_VOID(JSAPI_PROP_RVAL(cx, vp))) {
		/* already created - return it */
		return JS_TRUE;
	}

	dom_exception exc;
	dom_string *name;

	exc = dom_element_get_tag_name(private->node, &name);
	if (name != NULL) {
		jsret = JS_NewStringCopyN(cx, dom_string_data(name), dom_string_length(name));
		dom_string_unref(name);
	}

	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(id_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.id has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(id_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	dom_string *value;
	dom_exception exc;

	exc = dom_element_get_attribute(private->node, corestring_dom_id, &value);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	if (value != NULL) {
		jsret = JS_NewStringCopyN(cx, dom_string_data(value), dom_string_length(value));
		dom_string_unref(value);
	}

	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(className_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.className has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(className_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	dom_string *value;
	dom_exception exc;

	exc = dom_element_get_attribute(private->node, corestring_dom_class, &value);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	if (value != NULL) {
		jsret = JS_NewStringCopyN(cx, dom_string_data(value), dom_string_length(value));
		dom_string_unref(value);
	}

	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(classList_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* DOMTokenList */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.classList has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(attributes_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Attr */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.attributes has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(children_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* HTMLCollection */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.children has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(firstElementChild_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Element */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	dom_node *element;
	dom_exception exc;
	dom_node_type node_type;
	dom_node *next_node;

	exc = dom_node_get_first_child(private->node, &element);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	while (element != NULL) {
		exc = dom_node_get_node_type(element, &node_type);
		if ((exc == DOM_NO_ERR) && (node_type == DOM_ELEMENT_NODE)) {
			/* found it */
			jsret = jsapi_new_HTMLElement(cx,
						      NULL,
						      NULL,
						      (dom_element *)element,
						      private->htmlc);
			break;
		}

		exc = dom_node_get_next_sibling(element, &next_node);
		dom_node_unref(element);
		if (exc == DOM_NO_ERR) {
			element = next_node;
		} else {
			element = NULL;
		}

	}


	
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(lastElementChild_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Element */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	dom_node *element;
	dom_exception exc;
	dom_node_type node_type;
	dom_node *sib_node;

	exc = dom_node_get_last_child(private->node, &element);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	while (element != NULL) {
		exc = dom_node_get_node_type(element, &node_type);
		if ((exc == DOM_NO_ERR) && (node_type == DOM_ELEMENT_NODE)) {
			/* found it */
			jsret = jsapi_new_HTMLElement(cx,
						      NULL,
						      NULL,
						      (dom_element *)element,
						      private->htmlc);
			break;
		}

		exc = dom_node_get_previous_sibling(element, &sib_node);
		dom_node_unref(element);
		if (exc == DOM_NO_ERR) {
			element = sib_node;
		} else {
			element = NULL;
		}

	}
	
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(previousElementSibling_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Element */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	dom_node *element;
	dom_exception exc;
	dom_node_type node_type;
	dom_node *sib_node;

	exc = dom_node_get_previous_sibling(private->node, &element);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	while (element != NULL) {
		exc = dom_node_get_node_type(element, &node_type);
		if ((exc == DOM_NO_ERR) && (node_type == DOM_ELEMENT_NODE)) {
			/* found it */
			jsret = jsapi_new_HTMLElement(cx,
						      NULL,
						      NULL,
						      (dom_element *)element,
						      private->htmlc);
			break;
		}

		exc = dom_node_get_previous_sibling(element, &sib_node);
		dom_node_unref(element);
		if (exc == DOM_NO_ERR) {
			element = sib_node;
		} else {
			element = NULL;
		}
	}

	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(nextElementSibling_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Element */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	dom_node *element;
	dom_exception exc;
	dom_node_type node_type;
	dom_node *sib_node;

	exc = dom_node_get_next_sibling(private->node, &element);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	while (element != NULL) {
		exc = dom_node_get_node_type(element, &node_type);
		if ((exc == DOM_NO_ERR) && (node_type == DOM_ELEMENT_NODE)) {
			/* found it */
			jsret = jsapi_new_HTMLElement(cx,
						      NULL,
						      NULL,
						      (dom_element *)element,
						      private->htmlc);
			break;
		}

		exc = dom_node_get_next_sibling(element, &sib_node);
		dom_node_unref(element);
		if (exc == DOM_NO_ERR) {
			element = sib_node;
		} else {
			element = NULL;
		}
	}

	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(childElementCount_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	uint32_t jsret = 0;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	dom_node *element;
	dom_exception exc;
	dom_node_type node_type;
	dom_node *next_node;

	exc = dom_node_get_first_child(private->node, &element);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	while (element != NULL) {
		exc = dom_node_get_node_type(element, &node_type);
		if ((exc == DOM_NO_ERR) && (node_type == DOM_ELEMENT_NODE)) {
			jsret += 1;
		}

		exc = dom_node_get_next_sibling(element, &next_node);
		dom_node_unref(element);
		if (exc == DOM_NO_ERR) {
			element = next_node;
		} else {
			element = NULL;
		}
	}

	JSAPI_PROP_SET_RVAL(cx, vp, INT_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** Node ****/
static JSBool JSAPI_PROP(nodeType_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	uint16_t jsret = 0;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	dom_exception exc;
	dom_node_type node_type;

	exc = dom_node_get_node_type(private->node, &node_type);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}
	jsret = node_type;

	JSAPI_PROP_SET_RVAL(cx, vp, INT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(nodeName_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	dom_exception exc;
	dom_string *name;

	exc = dom_node_get_node_name(private->node, &name);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	if (name != NULL) {
		jsret = JS_NewStringCopyN(cx,
					  dom_string_data(name),
					  dom_string_length(name));
		dom_string_unref(name);
	}

	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(baseURI_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.baseURI has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(ownerDocument_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Document */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.ownerDocument has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(parentNode_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.parentNode has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(parentElement_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Element */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.parentElement has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(childNodes_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* NodeList */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.childNodes has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(firstChild_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.firstChild has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(lastChild_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.lastChild has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(previousSibling_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.previousSibling has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(nextSibling_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.nextSibling has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(nodeValue_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.nodeValue has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(nodeValue_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	dom_exception exc;
	dom_string *value;

	exc = dom_node_get_node_value(private->node, &value);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	if (value != NULL) {
		jsret = JS_NewStringCopyN(cx,
					  dom_string_data(value),
					  dom_string_length(value));
		dom_string_unref(value);
	}

	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(textContent_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property HTMLElement.textContent has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(textContent_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	dom_exception exc;
	dom_string *content;

	exc = dom_node_get_text_content(private->node, &content);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	if (content != NULL) {
		jsret = JS_NewStringCopyN(cx, dom_string_data(content), dom_string_length(content));
		dom_string_unref(content);

	}

	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** EventTarget ****/
static JSBool
JSAPI_STRICTPROP(EventHandler_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	jsval tinyid_jsval;
	int8_t tinyid = JSAPI_PROP_TINYID_END;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	 /* obtain property tinyid */
	JSAPI_PROP_IDVAL(cx, &tinyid_jsval);
	tinyid = JSVAL_TO_INT(tinyid_jsval);


	dom_string *event_type_dom;

	JSLOG("propname[%d].name=\"%s\"",
	      tinyid,
	      jsclass_properties[tinyid].name);

	switch (tinyid) {
	case JSAPI_PROP_TINYID_onabort:
		event_type_dom = corestring_dom_abort;
		break;

	case JSAPI_PROP_TINYID_onblur:
		event_type_dom = corestring_dom_blur;
		break;

	case JSAPI_PROP_TINYID_oncancel:
		event_type_dom = corestring_dom_cancel;
		break;

	case JSAPI_PROP_TINYID_oncanplay:
		event_type_dom = corestring_dom_canplay;
		break;

	case JSAPI_PROP_TINYID_oncanplaythrough:
		event_type_dom = corestring_dom_canplaythrough;
		break;

	case JSAPI_PROP_TINYID_onchange:
		event_type_dom = corestring_dom_change;
		break;

	case JSAPI_PROP_TINYID_onclick:
		event_type_dom = corestring_dom_click;
		break;

	case JSAPI_PROP_TINYID_onclose:
		event_type_dom = corestring_dom_close;
		break;

	case JSAPI_PROP_TINYID_oncontextmenu:
		event_type_dom = corestring_dom_contextmenu;
		break;

	case JSAPI_PROP_TINYID_oncuechange:
		event_type_dom = corestring_dom_cuechange;
		break;

	case JSAPI_PROP_TINYID_ondblclick:
		event_type_dom = corestring_dom_dblclick;
		break;

	case JSAPI_PROP_TINYID_ondrag:
		event_type_dom = corestring_dom_drag;
		break;

	case JSAPI_PROP_TINYID_ondragend:
		event_type_dom = corestring_dom_dragend;
		break;

	case JSAPI_PROP_TINYID_ondragenter:
		event_type_dom = corestring_dom_dragenter;
		break;

	case JSAPI_PROP_TINYID_ondragleave:
		event_type_dom = corestring_dom_dragleave;
		break;

	case JSAPI_PROP_TINYID_ondragover:
		event_type_dom = corestring_dom_dragover;
		break;

	case JSAPI_PROP_TINYID_ondragstart:
		event_type_dom = corestring_dom_dragstart;
		break;

	case JSAPI_PROP_TINYID_ondrop:
		event_type_dom = corestring_dom_drop;
		break;

	case JSAPI_PROP_TINYID_ondurationchange:
		event_type_dom = corestring_dom_durationchange;
		break;

	case JSAPI_PROP_TINYID_onemptied:
		event_type_dom = corestring_dom_emptied;
		break;

	case JSAPI_PROP_TINYID_onended:
		event_type_dom = corestring_dom_ended;
		break;

	case JSAPI_PROP_TINYID_onerror:
		event_type_dom = corestring_dom_error;
		break;

	case JSAPI_PROP_TINYID_onfocus:
		event_type_dom = corestring_dom_focus;
		break;

	case JSAPI_PROP_TINYID_oninput:
		event_type_dom = corestring_dom_input;
		break;

	case JSAPI_PROP_TINYID_oninvalid:
		event_type_dom = corestring_dom_invalid;
		break;

	case JSAPI_PROP_TINYID_onkeydown:
		event_type_dom = corestring_dom_keydown;
		break;

	case JSAPI_PROP_TINYID_onkeypress:
		event_type_dom = corestring_dom_keypress;
		break;

	case JSAPI_PROP_TINYID_onkeyup:
		event_type_dom = corestring_dom_keyup;
		break;

	case JSAPI_PROP_TINYID_onload:
		event_type_dom = corestring_dom_load;
		break;

	case JSAPI_PROP_TINYID_onloadeddata:
		event_type_dom = corestring_dom_loadeddata;
		break;

	case JSAPI_PROP_TINYID_onloadedmetadata:
		event_type_dom = corestring_dom_loadedmetadata;
		break;

	case JSAPI_PROP_TINYID_onloadstart:
		event_type_dom = corestring_dom_loadstart;
		break;

	case JSAPI_PROP_TINYID_onmousedown:
		event_type_dom = corestring_dom_mousedown;
		break;

	case JSAPI_PROP_TINYID_onmousemove:
		event_type_dom = corestring_dom_mousemove;
		break;

	case JSAPI_PROP_TINYID_onmouseout:
		event_type_dom = corestring_dom_mouseout;
		break;

	case JSAPI_PROP_TINYID_onmouseover:
		event_type_dom = corestring_dom_mouseover;
		break;

	case JSAPI_PROP_TINYID_onmouseup:
		event_type_dom = corestring_dom_mouseup;
		break;

	case JSAPI_PROP_TINYID_onmousewheel:
		event_type_dom = corestring_dom_mousewheel;
		break;

	case JSAPI_PROP_TINYID_onpause:
		event_type_dom = corestring_dom_pause;
		break;

	case JSAPI_PROP_TINYID_onplay:
		event_type_dom = corestring_dom_play;
		break;

	case JSAPI_PROP_TINYID_onplaying:
		event_type_dom = corestring_dom_playing;
		break;

	case JSAPI_PROP_TINYID_onprogress:
		event_type_dom = corestring_dom_progress;
		break;

	case JSAPI_PROP_TINYID_onratechange:
		event_type_dom = corestring_dom_ratechange;
		break;

	case JSAPI_PROP_TINYID_onreset:
		event_type_dom = corestring_dom_reset;
		break;

	case JSAPI_PROP_TINYID_onscroll:
		event_type_dom = corestring_dom_scroll;
		break;

	case JSAPI_PROP_TINYID_onseeked:
		event_type_dom = corestring_dom_seeked;
		break;

	case JSAPI_PROP_TINYID_onseeking:
		event_type_dom = corestring_dom_seeking;
		break;

	case JSAPI_PROP_TINYID_onselect:
		event_type_dom = corestring_dom_select;
		break;

	case JSAPI_PROP_TINYID_onshow:
		event_type_dom = corestring_dom_show;
		break;

	case JSAPI_PROP_TINYID_onstalled:
		event_type_dom = corestring_dom_stalled;
		break;

	case JSAPI_PROP_TINYID_onsubmit:
		event_type_dom = corestring_dom_submit;
		break;

	case JSAPI_PROP_TINYID_onsuspend:
		event_type_dom = corestring_dom_suspend;
		break;

	case JSAPI_PROP_TINYID_ontimeupdate:
		event_type_dom = corestring_dom_timeupdate;
		break;

	case JSAPI_PROP_TINYID_onvolumechange:
		event_type_dom = corestring_dom_volumechange;
		break;

	case JSAPI_PROP_TINYID_onwaiting:
		event_type_dom = corestring_dom_waiting;
		break;

	default:
		JSLOG("called with unknown tinyid");
		return JS_TRUE;
	}

	js_dom_event_add_listener((struct jscontext *)cx,
				  private->htmlc->document,
				  (dom_node *)private->node,
				  event_type_dom,
				  vp);

	return JS_TRUE;
}

static JSBool JSAPI_PROP(EventHandler_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	jsval tinyid_jsval;
	int8_t tinyid = JSAPI_PROP_TINYID_END;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	 /* obtain property tinyid */
	JSAPI_PROP_IDVAL(cx, &tinyid_jsval);
	tinyid = JSVAL_TO_INT(tinyid_jsval);


	JSLOG("propname[%d].name=\"%s\"",
	      tinyid,
	      jsclass_properties[tinyid].name);

        return JS_TRUE;
}

static JSFunctionSpec jsclass_functions[] = {
	/**** HTMLElement ****/
	JSAPI_FS(click, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(focus, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(blur, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(forceSpellCheck, 0, JSPROP_ENUMERATE ),
	/**** Element ****/
	JSAPI_FS(getAttribute, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(getAttributeNS, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(setAttribute, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(setAttributeNS, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(removeAttribute, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(removeAttributeNS, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(hasAttribute, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(hasAttributeNS, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(getElementsByTagName, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(getElementsByTagNameNS, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(getElementsByClassName, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(prepend, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(append, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(before, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(after, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(replace, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(remove, 0, JSPROP_ENUMERATE ),
	/**** Node ****/
	JSAPI_FS(hasChildNodes, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(insertBefore, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(appendChild, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(replaceChild, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(removeChild, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(normalize, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(cloneNode, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(isEqualNode, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(compareDocumentPosition, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(contains, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(lookupPrefix, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(lookupNamespaceURI, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(isDefaultNamespace, 0, JSPROP_ENUMERATE ),
	/**** EventTarget ****/
	JSAPI_FS(addEventListener, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(removeEventListener, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(dispatchEvent, 0, JSPROP_ENUMERATE ),
	JSAPI_FS_END
};

static JSPropertySpec jsclass_properties[] = {
	/**** HTMLElement ****/
	JSAPI_PS("title",
		title,
		JSAPI_PROP_TINYID_title,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("lang",
		lang,
		JSAPI_PROP_TINYID_lang,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("translate",
		translate,
		JSAPI_PROP_TINYID_translate,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("dir",
		dir,
		JSAPI_PROP_TINYID_dir,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("dataset",
		dataset,
		JSAPI_PROP_TINYID_dataset,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("itemScope",
		itemScope,
		JSAPI_PROP_TINYID_itemScope,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("itemType",
		itemType,
		JSAPI_PROP_TINYID_itemType,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("itemId",
		itemId,
		JSAPI_PROP_TINYID_itemId,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("itemRef",
		itemRef,
		JSAPI_PROP_TINYID_itemRef,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("itemProp",
		itemProp,
		JSAPI_PROP_TINYID_itemProp,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("properties",
		properties,
		JSAPI_PROP_TINYID_properties,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("itemValue",
		itemValue,
		JSAPI_PROP_TINYID_itemValue,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("hidden",
		hidden,
		JSAPI_PROP_TINYID_hidden,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("tabIndex",
		tabIndex,
		JSAPI_PROP_TINYID_tabIndex,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("accessKey",
		accessKey,
		JSAPI_PROP_TINYID_accessKey,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("accessKeyLabel",
		accessKeyLabel,
		JSAPI_PROP_TINYID_accessKeyLabel,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("draggable",
		draggable,
		JSAPI_PROP_TINYID_draggable,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("dropzone",
		dropzone,
		JSAPI_PROP_TINYID_dropzone,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("contentEditable",
		contentEditable,
		JSAPI_PROP_TINYID_contentEditable,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("isContentEditable",
		isContentEditable,
		JSAPI_PROP_TINYID_isContentEditable,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("contextMenu",
		contextMenu,
		JSAPI_PROP_TINYID_contextMenu,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("spellcheck",
		spellcheck,
		JSAPI_PROP_TINYID_spellcheck,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("commandType",
		commandType,
		JSAPI_PROP_TINYID_commandType,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("commandLabel",
		commandLabel,
		JSAPI_PROP_TINYID_commandLabel,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("commandIcon",
		commandIcon,
		JSAPI_PROP_TINYID_commandIcon,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("commandHidden",
		commandHidden,
		JSAPI_PROP_TINYID_commandHidden,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("commandDisabled",
		commandDisabled,
		JSAPI_PROP_TINYID_commandDisabled,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("commandChecked",
		commandChecked,
		JSAPI_PROP_TINYID_commandChecked,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("style",
		style,
		JSAPI_PROP_TINYID_style,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("onabort",
		EventHandler,
		JSAPI_PROP_TINYID_onabort,
		JSPROP_ENUMERATE),
	JSAPI_PS("onblur",
		EventHandler,
		JSAPI_PROP_TINYID_onblur,
		JSPROP_ENUMERATE),
	JSAPI_PS("oncancel",
		EventHandler,
		JSAPI_PROP_TINYID_oncancel,
		JSPROP_ENUMERATE),
	JSAPI_PS("oncanplay",
		EventHandler,
		JSAPI_PROP_TINYID_oncanplay,
		JSPROP_ENUMERATE),
	JSAPI_PS("oncanplaythrough",
		EventHandler,
		JSAPI_PROP_TINYID_oncanplaythrough,
		JSPROP_ENUMERATE),
	JSAPI_PS("onchange",
		EventHandler,
		JSAPI_PROP_TINYID_onchange,
		JSPROP_ENUMERATE),
	JSAPI_PS("onclick",
		EventHandler,
		JSAPI_PROP_TINYID_onclick,
		JSPROP_ENUMERATE),
	JSAPI_PS("onclose",
		EventHandler,
		JSAPI_PROP_TINYID_onclose,
		JSPROP_ENUMERATE),
	JSAPI_PS("oncontextmenu",
		EventHandler,
		JSAPI_PROP_TINYID_oncontextmenu,
		JSPROP_ENUMERATE),
	JSAPI_PS("oncuechange",
		EventHandler,
		JSAPI_PROP_TINYID_oncuechange,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondblclick",
		EventHandler,
		JSAPI_PROP_TINYID_ondblclick,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondrag",
		EventHandler,
		JSAPI_PROP_TINYID_ondrag,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondragend",
		EventHandler,
		JSAPI_PROP_TINYID_ondragend,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondragenter",
		EventHandler,
		JSAPI_PROP_TINYID_ondragenter,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondragleave",
		EventHandler,
		JSAPI_PROP_TINYID_ondragleave,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondragover",
		EventHandler,
		JSAPI_PROP_TINYID_ondragover,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondragstart",
		EventHandler,
		JSAPI_PROP_TINYID_ondragstart,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondrop",
		EventHandler,
		JSAPI_PROP_TINYID_ondrop,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondurationchange",
		EventHandler,
		JSAPI_PROP_TINYID_ondurationchange,
		JSPROP_ENUMERATE),
	JSAPI_PS("onemptied",
		EventHandler,
		JSAPI_PROP_TINYID_onemptied,
		JSPROP_ENUMERATE),
	JSAPI_PS("onended",
		EventHandler,
		JSAPI_PROP_TINYID_onended,
		JSPROP_ENUMERATE),
	JSAPI_PS("onerror",
		onerror,
		JSAPI_PROP_TINYID_onerror,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("onfocus",
		EventHandler,
		JSAPI_PROP_TINYID_onfocus,
		JSPROP_ENUMERATE),
	JSAPI_PS("oninput",
		EventHandler,
		JSAPI_PROP_TINYID_oninput,
		JSPROP_ENUMERATE),
	JSAPI_PS("oninvalid",
		EventHandler,
		JSAPI_PROP_TINYID_oninvalid,
		JSPROP_ENUMERATE),
	JSAPI_PS("onkeydown",
		EventHandler,
		JSAPI_PROP_TINYID_onkeydown,
		JSPROP_ENUMERATE),
	JSAPI_PS("onkeypress",
		EventHandler,
		JSAPI_PROP_TINYID_onkeypress,
		JSPROP_ENUMERATE),
	JSAPI_PS("onkeyup",
		EventHandler,
		JSAPI_PROP_TINYID_onkeyup,
		JSPROP_ENUMERATE),
	JSAPI_PS("onload",
		EventHandler,
		JSAPI_PROP_TINYID_onload,
		JSPROP_ENUMERATE),
	JSAPI_PS("onloadeddata",
		EventHandler,
		JSAPI_PROP_TINYID_onloadeddata,
		JSPROP_ENUMERATE),
	JSAPI_PS("onloadedmetadata",
		EventHandler,
		JSAPI_PROP_TINYID_onloadedmetadata,
		JSPROP_ENUMERATE),
	JSAPI_PS("onloadstart",
		EventHandler,
		JSAPI_PROP_TINYID_onloadstart,
		JSPROP_ENUMERATE),
	JSAPI_PS("onmousedown",
		EventHandler,
		JSAPI_PROP_TINYID_onmousedown,
		JSPROP_ENUMERATE),
	JSAPI_PS("onmousemove",
		EventHandler,
		JSAPI_PROP_TINYID_onmousemove,
		JSPROP_ENUMERATE),
	JSAPI_PS("onmouseout",
		EventHandler,
		JSAPI_PROP_TINYID_onmouseout,
		JSPROP_ENUMERATE),
	JSAPI_PS("onmouseover",
		EventHandler,
		JSAPI_PROP_TINYID_onmouseover,
		JSPROP_ENUMERATE),
	JSAPI_PS("onmouseup",
		EventHandler,
		JSAPI_PROP_TINYID_onmouseup,
		JSPROP_ENUMERATE),
	JSAPI_PS("onmousewheel",
		EventHandler,
		JSAPI_PROP_TINYID_onmousewheel,
		JSPROP_ENUMERATE),
	JSAPI_PS("onpause",
		EventHandler,
		JSAPI_PROP_TINYID_onpause,
		JSPROP_ENUMERATE),
	JSAPI_PS("onplay",
		EventHandler,
		JSAPI_PROP_TINYID_onplay,
		JSPROP_ENUMERATE),
	JSAPI_PS("onplaying",
		EventHandler,
		JSAPI_PROP_TINYID_onplaying,
		JSPROP_ENUMERATE),
	JSAPI_PS("onprogress",
		EventHandler,
		JSAPI_PROP_TINYID_onprogress,
		JSPROP_ENUMERATE),
	JSAPI_PS("onratechange",
		EventHandler,
		JSAPI_PROP_TINYID_onratechange,
		JSPROP_ENUMERATE),
	JSAPI_PS("onreset",
		EventHandler,
		JSAPI_PROP_TINYID_onreset,
		JSPROP_ENUMERATE),
	JSAPI_PS("onscroll",
		EventHandler,
		JSAPI_PROP_TINYID_onscroll,
		JSPROP_ENUMERATE),
	JSAPI_PS("onseeked",
		EventHandler,
		JSAPI_PROP_TINYID_onseeked,
		JSPROP_ENUMERATE),
	JSAPI_PS("onseeking",
		EventHandler,
		JSAPI_PROP_TINYID_onseeking,
		JSPROP_ENUMERATE),
	JSAPI_PS("onselect",
		EventHandler,
		JSAPI_PROP_TINYID_onselect,
		JSPROP_ENUMERATE),
	JSAPI_PS("onshow",
		EventHandler,
		JSAPI_PROP_TINYID_onshow,
		JSPROP_ENUMERATE),
	JSAPI_PS("onstalled",
		EventHandler,
		JSAPI_PROP_TINYID_onstalled,
		JSPROP_ENUMERATE),
	JSAPI_PS("onsubmit",
		EventHandler,
		JSAPI_PROP_TINYID_onsubmit,
		JSPROP_ENUMERATE),
	JSAPI_PS("onsuspend",
		EventHandler,
		JSAPI_PROP_TINYID_onsuspend,
		JSPROP_ENUMERATE),
	JSAPI_PS("ontimeupdate",
		EventHandler,
		JSAPI_PROP_TINYID_ontimeupdate,
		JSPROP_ENUMERATE),
	JSAPI_PS("onvolumechange",
		EventHandler,
		JSAPI_PROP_TINYID_onvolumechange,
		JSPROP_ENUMERATE),
	JSAPI_PS("onwaiting",
		EventHandler,
		JSAPI_PROP_TINYID_onwaiting,
		JSPROP_ENUMERATE),
	/**** Element ****/
	JSAPI_PS_RO("namespaceURI",
		namespaceURI,
		JSAPI_PROP_TINYID_namespaceURI,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("prefix",
		prefix,
		JSAPI_PROP_TINYID_prefix,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("localName",
		localName,
		JSAPI_PROP_TINYID_localName,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("tagName",
		tagName,
		JSAPI_PROP_TINYID_tagName,
		JSPROP_ENUMERATE),
	JSAPI_PS("id",
		id,
		JSAPI_PROP_TINYID_id,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("className",
		className,
		JSAPI_PROP_TINYID_className,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("classList",
		classList,
		JSAPI_PROP_TINYID_classList,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("attributes",
		attributes,
		JSAPI_PROP_TINYID_attributes,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("children",
		children,
		JSAPI_PROP_TINYID_children,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("firstElementChild",
		firstElementChild,
		JSAPI_PROP_TINYID_firstElementChild,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("lastElementChild",
		lastElementChild,
		JSAPI_PROP_TINYID_lastElementChild,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("previousElementSibling",
		previousElementSibling,
		JSAPI_PROP_TINYID_previousElementSibling,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("nextElementSibling",
		nextElementSibling,
		JSAPI_PROP_TINYID_nextElementSibling,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("childElementCount",
		childElementCount,
		JSAPI_PROP_TINYID_childElementCount,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	/**** Node ****/
	JSAPI_PS_RO("nodeType",
		nodeType,
		JSAPI_PROP_TINYID_nodeType,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("nodeName",
		nodeName,
		JSAPI_PROP_TINYID_nodeName,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("baseURI",
		baseURI,
		JSAPI_PROP_TINYID_baseURI,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("ownerDocument",
		ownerDocument,
		JSAPI_PROP_TINYID_ownerDocument,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("parentNode",
		parentNode,
		JSAPI_PROP_TINYID_parentNode,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("parentElement",
		parentElement,
		JSAPI_PROP_TINYID_parentElement,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("childNodes",
		childNodes,
		JSAPI_PROP_TINYID_childNodes,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("firstChild",
		firstChild,
		JSAPI_PROP_TINYID_firstChild,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("lastChild",
		lastChild,
		JSAPI_PROP_TINYID_lastChild,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("previousSibling",
		previousSibling,
		JSAPI_PROP_TINYID_previousSibling,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("nextSibling",
		nextSibling,
		JSAPI_PROP_TINYID_nextSibling,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("nodeValue",
		nodeValue,
		JSAPI_PROP_TINYID_nodeValue,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("textContent",
		textContent,
		JSAPI_PROP_TINYID_textContent,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	/**** EventTarget ****/
	JSAPI_PS_END
};

static void jsclass_finalize(JSContext *cx, JSObject *obj)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLElement, NULL);
	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	if (private != NULL) {
		dom_node_unref(private->node);
	}

	if (private != NULL) {
		free(private);
	}
}

JSObject *jsapi_InitClass_HTMLElement(JSContext *cx, JSObject *parent)
{
	JSObject *prototype;

	prototype = JS_InitClass(cx,
		parent,
		NULL,
		&JSClass_HTMLElement,
		NULL,
		0,
		NULL,
		NULL, 
		NULL, 
		NULL);
	/**** HTMLElement ****/
	/**** Element ****/
	/**** Node ****/
	JS_DefineProperty(cx,
		prototype,
		"ELEMENT_NODE",
		INT_TO_JSVAL(1),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"ATTRIBUTE_NODE",
		INT_TO_JSVAL(2),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"TEXT_NODE",
		INT_TO_JSVAL(3),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"CDATA_SECTION_NODE",
		INT_TO_JSVAL(4),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"ENTITY_REFERENCE_NODE",
		INT_TO_JSVAL(5),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"ENTITY_NODE",
		INT_TO_JSVAL(6),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"PROCESSING_INSTRUCTION_NODE",
		INT_TO_JSVAL(7),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"COMMENT_NODE",
		INT_TO_JSVAL(8),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_NODE",
		INT_TO_JSVAL(9),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_TYPE_NODE",
		INT_TO_JSVAL(10),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_FRAGMENT_NODE",
		INT_TO_JSVAL(11),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"NOTATION_NODE",
		INT_TO_JSVAL(12),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_POSITION_DISCONNECTED",
		INT_TO_JSVAL(1),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_POSITION_PRECEDING",
		INT_TO_JSVAL(2),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_POSITION_FOLLOWING",
		INT_TO_JSVAL(4),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_POSITION_CONTAINS",
		INT_TO_JSVAL(8),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_POSITION_CONTAINED_BY",
		INT_TO_JSVAL(16),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC",
		INT_TO_JSVAL(32),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	/**** EventTarget ****/
	return prototype;
}

JSObject *jsapi_new_HTMLElement(JSContext *cx,
		JSObject *prototype,
		JSObject *parent,
		dom_element *node,
		struct html_content *htmlc)
{
	JSObject *newobject;
	struct jsclass_private *private;

	private = malloc(sizeof(struct jsclass_private));
	if (private == NULL) {
		return NULL;
	}
	private->node = node;
	private->htmlc = htmlc;

	newobject = JS_NewObject(cx, &JSClass_HTMLElement, prototype, parent);
	if (newobject == NULL) {
		free(private);
		return NULL;
	}

	if (JSAPI_ADD_OBJECT_ROOT(cx, &newobject) != JS_TRUE) {
		free(private);
		return NULL;
	}


	/* attach private pointer */
	if (JS_SetPrivate(cx, newobject, private) != JS_TRUE) {
		free(private);
		return NULL;
	}

	if (JS_DefineFunctions(cx, newobject, jsclass_functions) != JS_TRUE) {
		free(private);
		return NULL;
	}

	if (JS_DefineProperties(cx, newobject, jsclass_properties) != JS_TRUE) {
		free(private);
		return NULL;
	}

	JSAPI_REMOVE_OBJECT_ROOT(cx, &newobject);

	return newobject;
}


