/* Generated by nsgenbind from javascript/jsapi/location.bnd
 *
 * nsgenbind is published under the MIT Licence.
 * nsgenbind is similar to a compiler is a purely transformative tool which
 * explicitly makes no copyright claim on this generated output
 * 
 * Copyright 2012 Vincent Sanders <vince@netsurf-browser.org>
 * 
 * This file is part of NetSurf, http://www.netsurf-browser.org/
 * 
 * Released under the terms of the MIT License,
 * 
 *         http://www.opensource.org/licenses/mit-license
 */



#include "desktop/browser.h"
        
#include "utils/config.h"
#include "utils/log.h"
#include "javascript/jsapi.h"
#include "render/html_internal.h"

#include "location.h"

struct browser_window *jsapi_get_browser_window(JSContext *cx);



struct jsclass_private {
        nsurl *url;
};

static void jsclass_finalize(JSContext *cx, JSObject *obj);

static JSPropertySpec jsclass_properties[];

JSClass JSClass_Location = {
	"Location",
	0 | JSCLASS_HAS_PRIVATE,
	JS_PropertyStub,	/* addProperty */
	JS_PropertyStub,	/* delProperty */
	JS_PropertyStub,	/* getProperty */
	JS_StrictPropertyStub,	/* setProperty */
	JS_EnumerateStub,	/* enumerate */
	JS_ResolveStub,
	JS_ConvertStub,	/* convert */
	jsclass_finalize,
	0,	/* reserved */
	NULL,	/* checkAccess */
	NULL,	/* call */
	NULL,	/* construct */
	NULL,	/* xdr Object */
	NULL,	/* hasInstance */
	NULL, /* trace/mark */
	JSAPI_CLASS_NO_INTERNAL_MEMBERS
};

enum property_tinyid {
	/**** Location ****/
	JSAPI_PROP_TINYID_href,
	JSAPI_PROP_TINYID_protocol,
	JSAPI_PROP_TINYID_host,
	JSAPI_PROP_TINYID_hostname,
	JSAPI_PROP_TINYID_port,
	JSAPI_PROP_TINYID_pathname,
	JSAPI_PROP_TINYID_search,
	JSAPI_PROP_TINYID_hash,
	JSAPI_PROP_TINYID_END,
};



/**** Location ****/
static JSBool JSAPI_FUNC(assign, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *url_jsstr = NULL;
	int url_len = 0;
	char *url = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Location,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		url_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		url_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (url_jsstr != NULL) {
		JSString_to_char(url_jsstr, url, url_len);
	}


	nsurl *joined;
	struct browser_window *bw;

	bw = jsapi_get_browser_window(cx);
	if (bw != NULL) {
		nsurl_join(private->url, url, &joined);
		browser_window_navigate(bw,
					joined,
					NULL,
					BW_NAVIGATE_HISTORY,
					NULL,
					NULL,
					NULL);
		nsurl_unref(joined);
	} else {
		JSLOG("failed to get browser context");
	}

	return JS_TRUE;
}

static JSBool JSAPI_FUNC(replace, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *url_jsstr = NULL;
	int url_len = 0;
	char *url = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Location,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		url_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		url_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (url_jsstr != NULL) {
		JSString_to_char(url_jsstr, url, url_len);
	}


	nsurl *joined;
	struct browser_window *bw;

	bw = jsapi_get_browser_window(cx);
	if (bw != NULL) {
		nsurl_join(private->url, url, &joined);
		browser_window_navigate(bw,
					joined,
					NULL,
					BW_NAVIGATE_NONE,
					NULL,
					NULL,
					NULL);
		nsurl_unref(joined);
	} else {
		JSLOG("failed to get browser context");
	}

	return JS_TRUE;
}

static JSBool JSAPI_FUNC(reload, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Location,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);

	struct browser_window *bw;
	bw = jsapi_get_browser_window(cx);
	if (bw != NULL) {
		browser_window_reload(bw, false);
	} else {
		JSLOG("failed to get browser context");
	}

	return JS_TRUE;
}

/**** Location ****/
static JSBool JSAPI_STRICTPROP(href_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Location, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	JSString *url_jsstr = NULL;
	int url_len = 0;
	char *url = NULL;
	struct browser_window *bw;
	nsurl *joined;

	bw = jsapi_get_browser_window(cx);

	if (bw != NULL) {
		url_jsstr = JS_ValueToString(cx, *vp);
		if (url_jsstr != NULL) {
			JSString_to_char(url_jsstr, url, url_len);

			nsurl_join(private->url, url, &joined);

			browser_window_navigate(bw,
						joined,
						NULL,
						BW_NAVIGATE_NONE,
						NULL,
						NULL,
						NULL);

			nsurl_unref(joined);
		} else {
			JSLOG("failed to convert string value");
		}
	} else {
		JSLOG("failed to get browser context");
	}

        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(href_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Location, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	char *url_s = NULL;
	size_t url_l;

	if (!JSVAL_IS_VOID(JSAPI_PROP_RVAL(cx,vp))) {
		/* already created - return it */
		return JS_TRUE;
	}

	nsurl_get(private->url, NSURL_COMPLETE, &url_s, &url_l);
	if (url_s != NULL) {
		jsret = JS_NewStringCopyN(cx, url_s, url_l);
		free(url_s);		
	}

	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(protocol_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Location, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Location.protocol has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(protocol_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Location, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	lwc_string *component;
	component = nsurl_get_component(private->url, NSURL_SCHEME);
	if (component != NULL) {
		jsret = JS_NewStringCopyN(cx,
					  lwc_string_data(component),
					  lwc_string_length(component));
		lwc_string_unref(component);
	}

	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(host_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Location, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Location.host has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(host_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Location, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	lwc_string *component;
	component = nsurl_get_component(private->url, NSURL_HOST);
	if (component != NULL) {
		jsret = JS_NewStringCopyN(cx,
					  lwc_string_data(component),
					  lwc_string_length(component));
		lwc_string_unref(component);
	}

	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(hostname_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Location, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Location.hostname has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(hostname_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Location, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	lwc_string *component;
	component = nsurl_get_component(private->url, NSURL_HOST);
	if (component != NULL) {
		jsret = JS_NewStringCopyN(cx,
					  lwc_string_data(component),
					  lwc_string_length(component));
		lwc_string_unref(component);
	}


	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(port_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Location, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Location.port has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(port_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Location, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	lwc_string *component;
	component = nsurl_get_component(private->url, NSURL_PORT);
	if (component != NULL) {
		jsret = JS_NewStringCopyN(cx,
					  lwc_string_data(component),
					  lwc_string_length(component));
		lwc_string_unref(component);
	}


	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(pathname_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Location, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Location.pathname has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(pathname_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Location, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	lwc_string *component;
	component = nsurl_get_component(private->url, NSURL_PATH);
	if (component != NULL) {
		jsret = JS_NewStringCopyN(cx,
					  lwc_string_data(component),
					  lwc_string_length(component));
		lwc_string_unref(component);
	}


	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(search_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Location, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Location.search has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(search_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Location, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	lwc_string *component;
	component = nsurl_get_component(private->url, NSURL_QUERY);
	if (component != NULL) {
		jsret = JS_NewStringCopyN(cx,
					  lwc_string_data(component),
					  lwc_string_length(component));
		lwc_string_unref(component);
	}


	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(hash_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Location, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Location.hash has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(hash_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Location, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	lwc_string *component;
	component = nsurl_get_component(private->url, NSURL_FRAGMENT);
	if (component != NULL) {
		jsret = JS_NewStringCopyN(cx,
					  lwc_string_data(component),
					  lwc_string_length(component));
		lwc_string_unref(component);
	}

	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSFunctionSpec jsclass_functions[] = {
	/**** Location ****/
	JSAPI_FS(assign, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(replace, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(reload, 0, JSPROP_ENUMERATE ),
	JSAPI_FS_END
};

static JSPropertySpec jsclass_properties[] = {
	/**** Location ****/
	JSAPI_PS("href",
		href,
		JSAPI_PROP_TINYID_href,
		JSPROP_ENUMERATE),
	JSAPI_PS("protocol",
		protocol,
		JSAPI_PROP_TINYID_protocol,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("host",
		host,
		JSAPI_PROP_TINYID_host,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("hostname",
		hostname,
		JSAPI_PROP_TINYID_hostname,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("port",
		port,
		JSAPI_PROP_TINYID_port,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("pathname",
		pathname,
		JSAPI_PROP_TINYID_pathname,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("search",
		search,
		JSAPI_PROP_TINYID_search,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("hash",
		hash,
		JSAPI_PROP_TINYID_hash,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_END
};

static void jsclass_finalize(JSContext *cx, JSObject *obj)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Location, NULL);
	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	if (private != NULL) {
		free(private);
	}
}

JSObject *jsapi_InitClass_Location(JSContext *cx, JSObject *parent)
{
	JSObject *prototype;

	prototype = JS_InitClass(cx,
		parent,
		NULL,
		&JSClass_Location,
		NULL,
		0,
		NULL,
		NULL, 
		NULL, 
		NULL);
	/**** Location ****/
	return prototype;
}

JSObject *jsapi_new_Location(JSContext *cx,
		JSObject *prototype,
		JSObject *parent,
		nsurl *url)
{
	JSObject *newobject;
	struct jsclass_private *private;

	private = malloc(sizeof(struct jsclass_private));
	if (private == NULL) {
		return NULL;
	}
	private->url = url;

	newobject = JS_NewObject(cx, &JSClass_Location, prototype, parent);
	if (newobject == NULL) {
		free(private);
		return NULL;
	}

	if (JSAPI_ADD_OBJECT_ROOT(cx, &newobject) != JS_TRUE) {
		free(private);
		return NULL;
	}


	/* attach private pointer */
	if (JS_SetPrivate(cx, newobject, private) != JS_TRUE) {
		free(private);
		return NULL;
	}

	if (JS_DefineFunctions(cx, newobject, jsclass_functions) != JS_TRUE) {
		free(private);
		return NULL;
	}

	if (JS_DefineProperties(cx, newobject, jsclass_properties) != JS_TRUE) {
		free(private);
		return NULL;
	}

	JSAPI_REMOVE_OBJECT_ROOT(cx, &newobject);

	return newobject;
}


