/* Generated by nsgenbind from javascript/jsapi/navigator.bnd
 *
 * nsgenbind is published under the MIT Licence.
 * nsgenbind is similar to a compiler is a purely transformative tool which
 * explicitly makes no copyright claim on this generated output
 * 
 * Copyright 2012 Vincent Sanders <vince@netsurf-browser.org>
 * 
 * This file is part of NetSurf, http://www.netsurf-browser.org/
 * 
 * Released under the terms of the MIT License,
 * 
 *         http://www.opensource.org/licenses/mit-license
 */



#include <assert.h>
#include <stdlib.h>

#include "desktop/version.h"
#include "utils/config.h"
#include "utils/nsoption.h"
#include "utils/useragent.h"
#include "utils/log.h"
#include "utils/utsname.h"
#include "javascript/jsapi.h"

#include "navigator.h"

/*
 * navigator properties for netsurf
 * 
 * Property    | Everyone else   | NetSurf      | Notes
 * ------------+-----------------+--------------+------------------------------
 * appCodeName | "Mozilla"       | "NetSurf"    | This is kinda a pointless 
 *             |                 |              |  constant as everyone returns 
 *             |                 |              |  "Mozilla" which is dumb
 * ------------+-----------------+--------------+------------------------------
 * appName     | "<Browsername>" | "NetSurf"    | Browsers named other than 
 *             |                 |              | "Netscape", "Mozilla", 
 *             |                 |              | "Netscape Navigator", 
 *             |                 |              | "Microsoft Internet Explorer" 
 *             |                 |              |  often other browser have 
 *             |                 |              | "(compatible with Netscape)" 
 *             |                 |              |  append.
 * ------------+-----------------+--------------+------------------------------
 * appVersion  | "<ver> (<type>)"| "<ver>"      | Actually just the version 
 *             |                 |              |  number e.g "3.0".
 * ------------+-----------------+--------------+------------------------------
 * language    | "<lang>"        | "<lang>"     | The language the frontend is 
 *             |                 |              |  configured for
 * ------------+-----------------+--------------+------------------------------
 * platform    | "<krn> <hw>"    | "<krn> <hw>" | Efectively uname -s -i, 
 *             |                 |              |   eg "Linux x86_64"
 * ------------+-----------------+--------------+------------------------------
 * userAgent   | "Mozilla/5.0 (" | "NetSurf"    | The usual useragent string  
 *             |                 |              |  with excessive lies
 * ------------+-----------------+--------------+------------------------------
 */

#define NAVIGATOR_APPNAME "NetSurf"
#define NAVIGATOR_APPCODENAME "NetSurf"


static JSPropertySpec jsclass_properties[];

JSClass JSClass_Navigator = {
	"Navigator",
	0,
	JS_PropertyStub,	/* addProperty */
	JS_PropertyStub,	/* delProperty */
	JS_PropertyStub,	/* getProperty */
	JS_StrictPropertyStub,	/* setProperty */
	JS_EnumerateStub,	/* enumerate */
	JS_ResolveStub,
	JS_ConvertStub,	/* convert */
	JS_FinalizeStub,
	0,	/* reserved */
	NULL,	/* checkAccess */
	NULL,	/* call */
	NULL,	/* construct */
	NULL,	/* xdr Object */
	NULL,	/* hasInstance */
	NULL, /* trace/mark */
	JSAPI_CLASS_NO_INTERNAL_MEMBERS
};

enum property_tinyid {
	/**** Navigator ****/
	/**** NavigatorID ****/
	JSAPI_PROP_TINYID_appName,
	JSAPI_PROP_TINYID_appVersion,
	JSAPI_PROP_TINYID_platform,
	JSAPI_PROP_TINYID_userAgent,
	/**** NavigatorOnLine ****/
	JSAPI_PROP_TINYID_onLine,
	/**** NavigatorContentUtils ****/
	/**** NavigatorStorageUtils ****/
	JSAPI_PROP_TINYID_END,
};



/**** Navigator ****/
/**** NavigatorID ****/
/**** NavigatorOnLine ****/
/**** NavigatorContentUtils ****/
static JSBool JSAPI_FUNC(registerProtocolHandler, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *scheme_jsstr = NULL;
	int scheme_len = 0;
	char *scheme = NULL;
	JSString *url_jsstr = NULL;
	int url_len = 0;
	char *url = NULL;
	JSString *title_jsstr = NULL;
	int title_len = 0;
	char *title = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (argc > 0) {
		scheme_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		scheme_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (scheme_jsstr != NULL) {
		JSString_to_char(scheme_jsstr, scheme, scheme_len);
	}

	if (argc > 1) {
		url_jsstr = JS_ValueToString(cx, argv[1]);
	} else {
		url_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (url_jsstr != NULL) {
		JSString_to_char(url_jsstr, url, url_len);
	}

	if (argc > 2) {
		title_jsstr = JS_ValueToString(cx, argv[2]);
	} else {
		title_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (title_jsstr != NULL) {
		JSString_to_char(title_jsstr, title, title_len);
	}

	JSLOG("operation Navigator.registerProtocolHandler has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(registerContentHandler, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *mimeType_jsstr = NULL;
	int mimeType_len = 0;
	char *mimeType = NULL;
	JSString *url_jsstr = NULL;
	int url_len = 0;
	char *url = NULL;
	JSString *title_jsstr = NULL;
	int title_len = 0;
	char *title = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (argc > 0) {
		mimeType_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		mimeType_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (mimeType_jsstr != NULL) {
		JSString_to_char(mimeType_jsstr, mimeType, mimeType_len);
	}

	if (argc > 1) {
		url_jsstr = JS_ValueToString(cx, argv[1]);
	} else {
		url_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (url_jsstr != NULL) {
		JSString_to_char(url_jsstr, url, url_len);
	}

	if (argc > 2) {
		title_jsstr = JS_ValueToString(cx, argv[2]);
	} else {
		title_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (title_jsstr != NULL) {
		JSString_to_char(title_jsstr, title, title_len);
	}

	JSLOG("operation Navigator.registerContentHandler has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(isProtocolHandlerRegistered, JSContext *cx, uintN argc, jsval *vp)
{
	JSString *jsret = NULL;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *scheme_jsstr = NULL;
	int scheme_len = 0;
	char *scheme = NULL;
	JSString *url_jsstr = NULL;
	int url_len = 0;
	char *url = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (argc > 0) {
		scheme_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		scheme_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (scheme_jsstr != NULL) {
		JSString_to_char(scheme_jsstr, scheme, scheme_len);
	}

	if (argc > 1) {
		url_jsstr = JS_ValueToString(cx, argv[1]);
	} else {
		url_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (url_jsstr != NULL) {
		JSString_to_char(url_jsstr, url, url_len);
	}

	JSLOG("operation Navigator.isProtocolHandlerRegistered has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(isContentHandlerRegistered, JSContext *cx, uintN argc, jsval *vp)
{
	JSString *jsret = NULL;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *mimeType_jsstr = NULL;
	int mimeType_len = 0;
	char *mimeType = NULL;
	JSString *url_jsstr = NULL;
	int url_len = 0;
	char *url = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (argc > 0) {
		mimeType_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		mimeType_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (mimeType_jsstr != NULL) {
		JSString_to_char(mimeType_jsstr, mimeType, mimeType_len);
	}

	if (argc > 1) {
		url_jsstr = JS_ValueToString(cx, argv[1]);
	} else {
		url_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (url_jsstr != NULL) {
		JSString_to_char(url_jsstr, url, url_len);
	}

	JSLOG("operation Navigator.isContentHandlerRegistered has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(unregisterProtocolHandler, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *scheme_jsstr = NULL;
	int scheme_len = 0;
	char *scheme = NULL;
	JSString *url_jsstr = NULL;
	int url_len = 0;
	char *url = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (argc > 0) {
		scheme_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		scheme_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (scheme_jsstr != NULL) {
		JSString_to_char(scheme_jsstr, scheme, scheme_len);
	}

	if (argc > 1) {
		url_jsstr = JS_ValueToString(cx, argv[1]);
	} else {
		url_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (url_jsstr != NULL) {
		JSString_to_char(url_jsstr, url, url_len);
	}

	JSLOG("operation Navigator.unregisterProtocolHandler has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(unregisterContentHandler, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *mimeType_jsstr = NULL;
	int mimeType_len = 0;
	char *mimeType = NULL;
	JSString *url_jsstr = NULL;
	int url_len = 0;
	char *url = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (argc > 0) {
		mimeType_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		mimeType_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (mimeType_jsstr != NULL) {
		JSString_to_char(mimeType_jsstr, mimeType, mimeType_len);
	}

	if (argc > 1) {
		url_jsstr = JS_ValueToString(cx, argv[1]);
	} else {
		url_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (url_jsstr != NULL) {
		JSString_to_char(url_jsstr, url, url_len);
	}

	JSLOG("operation Navigator.unregisterContentHandler has no implementation");
	return JS_TRUE;
}

/**** NavigatorStorageUtils ****/
static JSBool JSAPI_FUNC(yieldForStorageUpdates, JSContext *cx, uintN argc, jsval *vp)
{
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	JSLOG("operation Navigator.yieldForStorageUpdates has no implementation");
	return JS_TRUE;
}

/**** Navigator ****/
/**** NavigatorID ****/
static JSBool JSAPI_PROP(appName_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, obj);

  jsret = JS_NewStringCopyZ(cx, NAVIGATOR_APPNAME);

	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(appVersion_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, obj);

   jsret = JS_NewStringCopyZ(cx, netsurf_version);

	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(platform_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, obj);

	struct utsname *cutsname;

	cutsname = malloc(sizeof(struct utsname));

	if (cutsname != NULL) {
		if (uname(cutsname) >= 0) {
			char *platstr;
			int platstrlen;

			platstrlen = strlen(cutsname->sysname) + strlen(cutsname->machine) + 2;
			platstr = malloc(platstrlen);
			if (platstr != NULL) {
				snprintf(platstr, platstrlen, "%s %s", cutsname->sysname, cutsname->machine);
				jsret = JS_NewStringCopyN(cx, platstr, platstrlen - 1);
				free(platstr);
			} 
		}
		free(cutsname);
	}

	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(userAgent_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, obj);

  jsret = JS_NewStringCopyZ(cx, user_agent_string());

	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** NavigatorOnLine ****/
static JSBool JSAPI_PROP(onLine_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	JSLOG("jscontext:%p jsobject:%p", cx, obj);
	JSLOG("property Navigator.onLine has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** NavigatorContentUtils ****/
/**** NavigatorStorageUtils ****/
static JSFunctionSpec jsclass_functions[] = {
	/**** Navigator ****/
	/**** NavigatorID ****/
	/**** NavigatorOnLine ****/
	/**** NavigatorContentUtils ****/
	JSAPI_FS(registerProtocolHandler, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(registerContentHandler, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(isProtocolHandlerRegistered, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(isContentHandlerRegistered, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(unregisterProtocolHandler, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(unregisterContentHandler, 0, JSPROP_ENUMERATE ),
	/**** NavigatorStorageUtils ****/
	JSAPI_FS(yieldForStorageUpdates, 0, JSPROP_ENUMERATE ),
	JSAPI_FS_END
};

static JSPropertySpec jsclass_properties[] = {
	/**** Navigator ****/
	/**** NavigatorID ****/
	JSAPI_PS_RO("appName",
		appName,
		JSAPI_PROP_TINYID_appName,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("appVersion",
		appVersion,
		JSAPI_PROP_TINYID_appVersion,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("platform",
		platform,
		JSAPI_PROP_TINYID_platform,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("userAgent",
		userAgent,
		JSAPI_PROP_TINYID_userAgent,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	/**** NavigatorOnLine ****/
	JSAPI_PS_RO("onLine",
		onLine,
		JSAPI_PROP_TINYID_onLine,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	/**** NavigatorContentUtils ****/
	/**** NavigatorStorageUtils ****/
	JSAPI_PS_END
};

JSObject *jsapi_InitClass_Navigator(JSContext *cx, JSObject *parent)
{
	JSObject *prototype;

	prototype = JS_InitClass(cx,
		parent,
		NULL,
		&JSClass_Navigator,
		NULL,
		0,
		NULL,
		NULL, 
		NULL, 
		NULL);
	/**** Navigator ****/
	/**** NavigatorID ****/
	/**** NavigatorOnLine ****/
	/**** NavigatorContentUtils ****/
	/**** NavigatorStorageUtils ****/
	return prototype;
}

JSObject *jsapi_new_Navigator(JSContext *cx,
		JSObject *prototype,
		JSObject *parent)
{
	JSObject *newobject;

	newobject = JS_NewObject(cx, &JSClass_Navigator, prototype, parent);
	if (newobject == NULL) {
		return NULL;
	}
	if (JSAPI_ADD_OBJECT_ROOT(cx, &newobject) != JS_TRUE) {
		return NULL;
	}

	if (JS_DefineFunctions(cx, newobject, jsclass_functions) != JS_TRUE) {
		return NULL;
	}

	if (JS_DefineProperties(cx, newobject, jsclass_properties) != JS_TRUE) {
		return NULL;
	}

	JSAPI_REMOVE_OBJECT_ROOT(cx, &newobject);

	return newobject;
}


