/* Generated by nsgenbind from javascript/jsapi/nodelist.bnd
 *
 * nsgenbind is published under the MIT Licence.
 * nsgenbind is similar to a compiler is a purely transformative tool which
 * explicitly makes no copyright claim on this generated output
 * 
 * Copyright 2012 Vincent Sanders <vince@netsurf-browser.org>
 * 
 * This file is part of NetSurf, http://www.netsurf-browser.org/
 * 
 * Released under the terms of the MIT License,
 * 
 *         http://www.opensource.org/licenses/mit-license
 */



#include <dom/dom.h>
        
#include "utils/config.h"
#include "utils/log.h"
#include "javascript/jsapi.h"
#include "render/html_internal.h"

#include "nodelist.h"
#include "htmlelement.h"



struct jsclass_private {
        dom_nodelist *nodelist;
        struct html_content *htmlc;
};

static JSBool JSAPI_PROP(get, JSContext *cx, JSObject *obj, jsval *vp);

static void jsclass_finalize(JSContext *cx, JSObject *obj);

static JSPropertySpec jsclass_properties[];

JSClass JSClass_NodeList = {
	"NodeList",
	0 | JSCLASS_HAS_PRIVATE,
	JS_PropertyStub,	/* addProperty */
	JS_PropertyStub,	/* delProperty */
	jsapi_property_get,	/* getProperty */
	JS_StrictPropertyStub,	/* setProperty */
	JS_EnumerateStub,	/* enumerate */
	JS_ResolveStub,
	JS_ConvertStub,	/* convert */
	jsclass_finalize,
	0,	/* reserved */
	NULL,	/* checkAccess */
	NULL,	/* call */
	NULL,	/* construct */
	NULL,	/* xdr Object */
	NULL,	/* hasInstance */
	NULL, /* trace/mark */
	JSAPI_CLASS_NO_INTERNAL_MEMBERS
};

enum property_tinyid {
	/**** NodeList ****/
	JSAPI_PROP_TINYID_length,
	JSAPI_PROP_TINYID_END,
};



/**** NodeList ****/
static JSBool JSAPI_FUNC(item, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	uint32_t index = 0;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_NodeList,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JS_ValueToECMAUint32(cx, argv[0], &index);

        dom_exception err;
        dom_node *domnode;

        err = dom_nodelist_item(private->nodelist, index, &domnode);
        if (err != DOM_NO_ERR)  {
                return JS_FALSE;
        }

        if (domnode != NULL) {
                jsret = jsapi_new_HTMLElement(cx, NULL, NULL, (dom_element *)domnode, private->htmlc);
        }

	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** NodeList ****/
static JSBool JSAPI_PROP(length_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	uint32_t jsret = 0;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_NodeList, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

        dom_exception err;

        err = dom_nodelist_get_length(private->nodelist, &jsret);
        if (err != DOM_NO_ERR) {
                return JS_FALSE;
        }

	JSAPI_PROP_SET_RVAL(cx, vp, INT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSFunctionSpec jsclass_functions[] = {
	/**** NodeList ****/
	JSAPI_FS(item, 0, JSPROP_ENUMERATE ),
	JSAPI_FS_END
};

static JSPropertySpec jsclass_properties[] = {
	/**** NodeList ****/
	JSAPI_PS_RO("length",
		length,
		JSAPI_PROP_TINYID_length,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_END
};

static void jsclass_finalize(JSContext *cx, JSObject *obj)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_NodeList, NULL);
	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

        if (private != NULL) {
                dom_nodelist_unref(private->nodelist);
        }

	if (private != NULL) {
		free(private);
	}
}

static JSBool JSAPI_PROP(get, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_NodeList, NULL);
	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	jsval queryprop;
	int idx;
	JSObject *jsret = NULL; /* Node */
        dom_exception err;
        dom_node *domnode;

	JSAPI_PROP_IDVAL(cx, &queryprop);
	if (JSVAL_IS_INT(queryprop)) {
		idx = JSVAL_TO_INT(queryprop);
		JSDBG("Index was %d", idx);


		err = dom_nodelist_item(private->nodelist, idx, &domnode);
		if (err != DOM_NO_ERR)  {
			return JS_FALSE;
		}

		if (domnode != NULL) {
			jsret = jsapi_new_HTMLElement(cx, NULL, NULL, (dom_element *)domnode, private->htmlc);

			JSDBG("return object:%p", jsret);

			JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
		}
	}

	return JS_TRUE;
}

JSObject *jsapi_InitClass_NodeList(JSContext *cx, JSObject *parent)
{
	JSObject *prototype;

	prototype = JS_InitClass(cx,
		parent,
		NULL,
		&JSClass_NodeList,
		NULL,
		0,
		NULL,
		NULL, 
		NULL, 
		NULL);
	/**** NodeList ****/
	return prototype;
}

JSObject *jsapi_new_NodeList(JSContext *cx,
		JSObject *prototype,
		JSObject *parent,
		dom_nodelist *nodelist,
		struct html_content *htmlc)
{
	JSObject *newobject;
	struct jsclass_private *private;

	private = malloc(sizeof(struct jsclass_private));
	if (private == NULL) {
		return NULL;
	}
	private->nodelist = nodelist;
	private->htmlc = htmlc;

	newobject = JS_NewObject(cx, &JSClass_NodeList, prototype, parent);
	if (newobject == NULL) {
		free(private);
		return NULL;
	}

	if (JSAPI_ADD_OBJECT_ROOT(cx, &newobject) != JS_TRUE) {
		free(private);
		return NULL;
	}


	/* attach private pointer */
	if (JS_SetPrivate(cx, newobject, private) != JS_TRUE) {
		free(private);
		return NULL;
	}

	if (JS_DefineFunctions(cx, newobject, jsclass_functions) != JS_TRUE) {
		free(private);
		return NULL;
	}

	if (JS_DefineProperties(cx, newobject, jsclass_properties) != JS_TRUE) {
		free(private);
		return NULL;
	}

	JSAPI_REMOVE_OBJECT_ROOT(cx, &newobject);

	return newobject;
}


