/* Generated by nsgenbind from javascript/jsapi/console.bnd
 *
 * nsgenbind is published under the MIT Licence.
 * nsgenbind is similar to a compiler is a purely transformative tool which
 * explicitly makes no copyright claim on this generated output
 * 
 * Copyright 2012 Vincent Sanders <vince@netsurf-browser.org>
 * 
 * This file is part of NetSurf, http://www.netsurf-browser.org/
 * 
 * Released under the terms of the MIT License,
 * 
 *         http://www.opensource.org/licenses/mit-license
 */



#include "utils/config.h"
#include "utils/log.h"
#include "javascript/jsapi.h"

#include "console.h"



static JSPropertySpec jsclass_properties[];

JSClass JSClass_Console = {
	"Console",
	0,
	JS_PropertyStub,	/* addProperty */
	JS_PropertyStub,	/* delProperty */
	JS_PropertyStub,	/* getProperty */
	JS_StrictPropertyStub,	/* setProperty */
	JS_EnumerateStub,	/* enumerate */
	JS_ResolveStub,
	JS_ConvertStub,	/* convert */
	JS_FinalizeStub,
	0,	/* reserved */
	NULL,	/* checkAccess */
	NULL,	/* call */
	NULL,	/* construct */
	NULL,	/* xdr Object */
	NULL,	/* hasInstance */
	NULL, /* trace/mark */
	JSAPI_CLASS_NO_INTERNAL_MEMBERS
};

enum property_tinyid {
	/**** Console ****/
	JSAPI_PROP_TINYID_END,
};



/**** Console ****/
static JSBool JSAPI_FUNC(debug, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *msg_jsstr = NULL;
	int msg_len = 0;
	char *msg = NULL;
	JSObject *subst = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (argc > 0) {
		msg_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		msg_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (msg_jsstr != NULL) {
		JSString_to_char(msg_jsstr, msg, msg_len);
	}

	if (!JSAPI_JSVAL_IS_OBJECT(argv[1])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[1]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	subst = JSVAL_TO_OBJECT(argv[1]);
	JSLOG("operation Console.debug has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(dir, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *object = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	object = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation Console.dir has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(error, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *msg_jsstr = NULL;
	int msg_len = 0;
	char *msg = NULL;
	JSObject *subst = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (argc > 0) {
		msg_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		msg_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (msg_jsstr != NULL) {
		JSString_to_char(msg_jsstr, msg, msg_len);
	}

	if (!JSAPI_JSVAL_IS_OBJECT(argv[1])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[1]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	subst = JSVAL_TO_OBJECT(argv[1]);
	JSLOG("operation Console.error has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(group, JSContext *cx, uintN argc, jsval *vp)
{
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	JSLOG("operation Console.group has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(groupCollapsed, JSContext *cx, uintN argc, jsval *vp)
{
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	JSLOG("operation Console.groupCollapsed has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(groupEnd, JSContext *cx, uintN argc, jsval *vp)
{
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	JSLOG("operation Console.groupEnd has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(info, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *msg_jsstr = NULL;
	int msg_len = 0;
	char *msg = NULL;
	JSObject *subst = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (argc > 0) {
		msg_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		msg_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (msg_jsstr != NULL) {
		JSString_to_char(msg_jsstr, msg, msg_len);
	}

	if (!JSAPI_JSVAL_IS_OBJECT(argv[1])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[1]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	subst = JSVAL_TO_OBJECT(argv[1]);
	JSLOG("operation Console.info has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(log, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *msg_jsstr = NULL;
	int msg_len = 0;
	char *msg = NULL;
	JSObject *subst = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (argc > 0) {
		msg_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		msg_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (msg_jsstr != NULL) {
		JSString_to_char(msg_jsstr, msg, msg_len);
	}

	if (!JSAPI_JSVAL_IS_OBJECT(argv[1])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[1]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	subst = JSVAL_TO_OBJECT(argv[1]);

	unsigned int argloop;
	JSString *jsstr;
	unsigned long jsstrlen;
	char *txt;

	for (argloop = 0; argloop < argc; argloop++) {
		jsstr = JS_ValueToString(cx, argv[argloop]);

		JSString_to_char(jsstr, txt, jsstrlen);
		LOG(("%s", txt));
	}

	return JS_TRUE;
}

static JSBool JSAPI_FUNC(time, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *timerName_jsstr = NULL;
	int timerName_len = 0;
	char *timerName = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (argc > 0) {
		timerName_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		timerName_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (timerName_jsstr != NULL) {
		JSString_to_char(timerName_jsstr, timerName, timerName_len);
	}

	JSLOG("operation Console.time has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(timeEnd, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *timerName_jsstr = NULL;
	int timerName_len = 0;
	char *timerName = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (argc > 0) {
		timerName_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		timerName_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (timerName_jsstr != NULL) {
		JSString_to_char(timerName_jsstr, timerName, timerName_len);
	}

	JSLOG("operation Console.timeEnd has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(trace, JSContext *cx, uintN argc, jsval *vp)
{
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	JSLOG("operation Console.trace has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(warn, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *msg_jsstr = NULL;
	int msg_len = 0;
	char *msg = NULL;
	JSObject *subst = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (argc > 0) {
		msg_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		msg_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (msg_jsstr != NULL) {
		JSString_to_char(msg_jsstr, msg, msg_len);
	}

	if (!JSAPI_JSVAL_IS_OBJECT(argv[1])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[1]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	subst = JSVAL_TO_OBJECT(argv[1]);
	JSLOG("operation Console.warn has no implementation");
	return JS_TRUE;
}

/**** Console ****/
static JSFunctionSpec jsclass_functions[] = {
	/**** Console ****/
	JSAPI_FS(debug, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(dir, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(error, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(group, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(groupCollapsed, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(groupEnd, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(info, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(log, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(time, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(timeEnd, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(trace, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(warn, 0, JSPROP_ENUMERATE ),
	JSAPI_FS_END
};

static JSPropertySpec jsclass_properties[] = {
	/**** Console ****/
	JSAPI_PS_END
};

JSObject *jsapi_InitClass_Console(JSContext *cx, JSObject *parent)
{
	JSObject *prototype;

	prototype = JS_InitClass(cx,
		parent,
		NULL,
		&JSClass_Console,
		NULL,
		0,
		NULL,
		NULL, 
		NULL, 
		NULL);
	/**** Console ****/
	return prototype;
}

JSObject *jsapi_new_Console(JSContext *cx,
		JSObject *prototype,
		JSObject *parent)
{
	JSObject *newobject;

	newobject = JS_NewObject(cx, &JSClass_Console, prototype, parent);
	if (newobject == NULL) {
		return NULL;
	}
	if (JSAPI_ADD_OBJECT_ROOT(cx, &newobject) != JS_TRUE) {
		return NULL;
	}

	if (JS_DefineFunctions(cx, newobject, jsclass_functions) != JS_TRUE) {
		return NULL;
	}

	if (JS_DefineProperties(cx, newobject, jsclass_properties) != JS_TRUE) {
		return NULL;
	}

	JSAPI_REMOVE_OBJECT_ROOT(cx, &newobject);

	return newobject;
}


