/* Generated by nsgenbind from javascript/jsapi/event.bnd
 *
 * nsgenbind is published under the MIT Licence.
 * nsgenbind is similar to a compiler is a purely transformative tool which
 * explicitly makes no copyright claim on this generated output
 * 
 * Copyright 2012 Vincent Sanders <vince@netsurf-browser.org>
 * 
 * This file is part of NetSurf, http://www.netsurf-browser.org/
 * 
 * Released under the terms of the MIT License,
 * 
 *         http://www.opensource.org/licenses/mit-license
 */


#include <stdlib.h>

#include <dom/dom.h>
        
#include "utils/config.h"
#include "utils/log.h"
#include "javascript/jsapi.h"

#include "event.h"



struct jsclass_private {
        dom_event *event;
};

static void jsclass_finalize(JSContext *cx, JSObject *obj);

static JSPropertySpec jsclass_properties[];

JSClass JSClass_Event = {
	"Event",
	0 | JSCLASS_HAS_PRIVATE,
	JS_PropertyStub,	/* addProperty */
	JS_PropertyStub,	/* delProperty */
	JS_PropertyStub,	/* getProperty */
	JS_StrictPropertyStub,	/* setProperty */
	JS_EnumerateStub,	/* enumerate */
	JS_ResolveStub,
	JS_ConvertStub,	/* convert */
	jsclass_finalize,
	0,	/* reserved */
	NULL,	/* checkAccess */
	NULL,	/* call */
	NULL,	/* construct */
	NULL,	/* xdr Object */
	NULL,	/* hasInstance */
	NULL, /* trace/mark */
	JSAPI_CLASS_NO_INTERNAL_MEMBERS
};

enum property_tinyid {
	/**** Event ****/
	JSAPI_PROP_TINYID_type,
	JSAPI_PROP_TINYID_target,
	JSAPI_PROP_TINYID_currentTarget,
	JSAPI_PROP_TINYID_eventPhase,
	JSAPI_PROP_TINYID_bubbles,
	JSAPI_PROP_TINYID_cancelable,
	JSAPI_PROP_TINYID_defaultPrevented,
	JSAPI_PROP_TINYID_isTrusted,
	JSAPI_PROP_TINYID_timeStamp,
	JSAPI_PROP_TINYID_END,
};



/**** Event ****/
static JSBool JSAPI_FUNC(stopPropagation, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Event,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Event.stopPropagation has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(stopImmediatePropagation, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Event,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Event.stopImmediatePropagation has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(preventDefault, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Event,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Event.preventDefault has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(initEvent, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *type_jsstr = NULL;
	int type_len = 0;
	char *type = NULL;
	JSBool bubbles = JS_FALSE;
	JSBool cancelable = JS_FALSE;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Event,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		type_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		type_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (type_jsstr != NULL) {
		JSString_to_char(type_jsstr, type, type_len);
	}

	if (!JS_ValueToBoolean(cx, argv[1], &bubbles)) {
		return JS_FALSE;
	}
	if (!JS_ValueToBoolean(cx, argv[2], &cancelable)) {
		return JS_FALSE;
	}
	JSLOG("operation Event.initEvent has no implementation");
	return JS_TRUE;
}

/**** Event ****/
static JSBool JSAPI_PROP(type_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Event, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Event.type has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(target_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* EventTarget */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Event, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Event.target has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(currentTarget_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* EventTarget */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Event, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Event.currentTarget has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(eventPhase_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	uint16_t jsret = 0;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Event, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Event.eventPhase has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, INT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(bubbles_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Event, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Event.bubbles has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(cancelable_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Event, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Event.cancelable has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(defaultPrevented_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Event, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Event.defaultPrevented has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(isTrusted_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Event, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Event.isTrusted has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(timeStamp_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* DOMTimeStamp */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Event, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Event.timeStamp has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSFunctionSpec jsclass_functions[] = {
	/**** Event ****/
	JSAPI_FS(stopPropagation, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(stopImmediatePropagation, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(preventDefault, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(initEvent, 0, JSPROP_ENUMERATE ),
	JSAPI_FS_END
};

static JSPropertySpec jsclass_properties[] = {
	/**** Event ****/
	JSAPI_PS_RO("type",
		type,
		JSAPI_PROP_TINYID_type,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("target",
		target,
		JSAPI_PROP_TINYID_target,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("currentTarget",
		currentTarget,
		JSAPI_PROP_TINYID_currentTarget,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("eventPhase",
		eventPhase,
		JSAPI_PROP_TINYID_eventPhase,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("bubbles",
		bubbles,
		JSAPI_PROP_TINYID_bubbles,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("cancelable",
		cancelable,
		JSAPI_PROP_TINYID_cancelable,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("defaultPrevented",
		defaultPrevented,
		JSAPI_PROP_TINYID_defaultPrevented,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("isTrusted",
		isTrusted,
		JSAPI_PROP_TINYID_isTrusted,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("timeStamp",
		timeStamp,
		JSAPI_PROP_TINYID_timeStamp,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_END
};

static void jsclass_finalize(JSContext *cx, JSObject *obj)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Event, NULL);
	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	if (private != NULL) {
		free(private);
	}
}

JSObject *jsapi_InitClass_Event(JSContext *cx, JSObject *parent)
{
	JSObject *prototype;

	prototype = JS_InitClass(cx,
		parent,
		NULL,
		&JSClass_Event,
		NULL,
		0,
		NULL,
		NULL, 
		NULL, 
		NULL);
	/**** Event ****/
	JS_DefineProperty(cx,
		prototype,
		"NONE",
		INT_TO_JSVAL(0),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"CAPTURING_PHASE",
		INT_TO_JSVAL(1),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"AT_TARGET",
		INT_TO_JSVAL(2),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"BUBBLING_PHASE",
		INT_TO_JSVAL(3),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	return prototype;
}

JSObject *jsapi_new_Event(JSContext *cx,
		JSObject *prototype,
		JSObject *parent,
		dom_event *event)
{
	JSObject *newobject;
	struct jsclass_private *private;

	private = malloc(sizeof(struct jsclass_private));
	if (private == NULL) {
		return NULL;
	}
	private->event = event;

	newobject = JS_NewObject(cx, &JSClass_Event, prototype, parent);
	if (newobject == NULL) {
		free(private);
		return NULL;
	}

	if (JSAPI_ADD_OBJECT_ROOT(cx, &newobject) != JS_TRUE) {
		free(private);
		return NULL;
	}


	/* attach private pointer */
	if (JS_SetPrivate(cx, newobject, private) != JS_TRUE) {
		free(private);
		return NULL;
	}

	if (JS_DefineFunctions(cx, newobject, jsclass_functions) != JS_TRUE) {
		free(private);
		return NULL;
	}

	if (JS_DefineProperties(cx, newobject, jsclass_properties) != JS_TRUE) {
		free(private);
		return NULL;
	}

	JSAPI_REMOVE_OBJECT_ROOT(cx, &newobject);

	return newobject;
}


