/* Generated by nsgenbind from javascript/jsapi/htmlcollection.bnd
 *
 * nsgenbind is published under the MIT Licence.
 * nsgenbind is similar to a compiler is a purely transformative tool which
 * explicitly makes no copyright claim on this generated output
 * 
 * Copyright 2012 Vincent Sanders <vince@netsurf-browser.org>
 * 
 * This file is part of NetSurf, http://www.netsurf-browser.org/
 * 
 * Released under the terms of the MIT License,
 * 
 *         http://www.opensource.org/licenses/mit-license
 */



#include <dom/dom.h>
        
#include "utils/config.h"
#include "utils/log.h"
#include "javascript/jsapi.h"
#include "render/html_internal.h"

#include "htmlelement.h"
#include "htmlcollection.h"



struct jsclass_private {
        dom_html_collection *collection;
        struct html_content *htmlc;
};

static void jsclass_finalize(JSContext *cx, JSObject *obj);

static JSPropertySpec jsclass_properties[];

JSClass JSClass_HTMLCollection = {
	"HTMLCollection",
	0 | JSCLASS_HAS_PRIVATE,
	JS_PropertyStub,	/* addProperty */
	JS_PropertyStub,	/* delProperty */
	JS_PropertyStub,	/* getProperty */
	JS_StrictPropertyStub,	/* setProperty */
	JS_EnumerateStub,	/* enumerate */
	JS_ResolveStub,
	JS_ConvertStub,	/* convert */
	jsclass_finalize,
	0,	/* reserved */
	NULL,	/* checkAccess */
	NULL,	/* call */
	NULL,	/* construct */
	NULL,	/* xdr Object */
	NULL,	/* hasInstance */
	NULL, /* trace/mark */
	JSAPI_CLASS_NO_INTERNAL_MEMBERS
};

enum property_tinyid {
	/**** HTMLCollection ****/
	JSAPI_PROP_TINYID_length,
	JSAPI_PROP_TINYID_END,
};



/**** HTMLCollection ****/
static JSBool JSAPI_FUNC(item, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Element */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	uint32_t index = 0;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLCollection,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JS_ValueToECMAUint32(cx, argv[0], &index);

        dom_exception err;
        dom_node *domnode;

        err = dom_html_collection_item(private->collection, index, &domnode);
        if (err != DOM_NO_ERR)  {
                return JS_FALSE;
        }

        if (domnode != NULL) {
                jsret = jsapi_new_HTMLElement(cx, NULL, NULL, (dom_element *)domnode, private->htmlc);
        }
        
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(namedItem, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* object */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *name_jsstr = NULL;
	int name_len = 0;
	char *name = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_HTMLCollection,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		name_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		name_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (name_jsstr != NULL) {
		JSString_to_char(name_jsstr, name, name_len);
	}


        dom_exception err;
        dom_node *domnode;
        dom_string *name_dom;

        err = dom_string_create((uint8_t *)name, name_len, &name_dom);
        if (err != DOM_NO_ERR) {
                return JS_FALSE;
        }

        err = dom_html_collection_named_item(private->collection, name_dom, &domnode);
        if (err != DOM_NO_ERR)  {
                return JS_FALSE;
        }

        if (domnode != NULL) {
                jsret = jsapi_new_HTMLElement(cx, NULL, NULL, (dom_element *)domnode, private->htmlc);
        }


	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** HTMLCollection ****/
static JSBool JSAPI_PROP(length_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	uint32_t jsret = 0;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLCollection, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

        dom_exception err;

        err = dom_html_collection_get_length(private->collection, &jsret);
        if (err != DOM_NO_ERR) {
                return JS_FALSE;
        }
        
	JSAPI_PROP_SET_RVAL(cx, vp, INT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSFunctionSpec jsclass_functions[] = {
	/**** HTMLCollection ****/
	JSAPI_FS(item, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(namedItem, 0, JSPROP_ENUMERATE ),
	JSAPI_FS_END
};

static JSPropertySpec jsclass_properties[] = {
	/**** HTMLCollection ****/
	JSAPI_PS_RO("length",
		length,
		JSAPI_PROP_TINYID_length,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_END
};

static void jsclass_finalize(JSContext *cx, JSObject *obj)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_HTMLCollection, NULL);
	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

        if (private != NULL) {
                dom_html_collection_unref(private->collection);
        }

	if (private != NULL) {
		free(private);
	}
}

JSObject *jsapi_InitClass_HTMLCollection(JSContext *cx, JSObject *parent)
{
	JSObject *prototype;

	prototype = JS_InitClass(cx,
		parent,
		NULL,
		&JSClass_HTMLCollection,
		NULL,
		0,
		NULL,
		NULL, 
		NULL, 
		NULL);
	/**** HTMLCollection ****/
	return prototype;
}

JSObject *jsapi_new_HTMLCollection(JSContext *cx,
		JSObject *prototype,
		JSObject *parent,
		dom_html_collection *collection,
		struct html_content *htmlc)
{
	JSObject *newobject;
	struct jsclass_private *private;

	private = malloc(sizeof(struct jsclass_private));
	if (private == NULL) {
		return NULL;
	}
	private->collection = collection;
	private->htmlc = htmlc;

	newobject = JS_NewObject(cx, &JSClass_HTMLCollection, prototype, parent);
	if (newobject == NULL) {
		free(private);
		return NULL;
	}

	if (JSAPI_ADD_OBJECT_ROOT(cx, &newobject) != JS_TRUE) {
		free(private);
		return NULL;
	}


	/* attach private pointer */
	if (JS_SetPrivate(cx, newobject, private) != JS_TRUE) {
		free(private);
		return NULL;
	}

	if (JS_DefineFunctions(cx, newobject, jsclass_functions) != JS_TRUE) {
		free(private);
		return NULL;
	}

	if (JS_DefineProperties(cx, newobject, jsclass_properties) != JS_TRUE) {
		free(private);
		return NULL;
	}

	JSAPI_REMOVE_OBJECT_ROOT(cx, &newobject);

	return newobject;
}


