/* Generated by nsgenbind from javascript/jsapi/node.bnd
 *
 * nsgenbind is published under the MIT Licence.
 * nsgenbind is similar to a compiler is a purely transformative tool which
 * explicitly makes no copyright claim on this generated output
 * 
 * Copyright 2012 Vincent Sanders <vince@netsurf-browser.org>
 * 
 * This file is part of NetSurf, http://www.netsurf-browser.org/
 * 
 * Released under the terms of the MIT License,
 * 
 *         http://www.opensource.org/licenses/mit-license
 */



#include <dom/dom.h>
        
#include "utils/config.h"
#include "utils/log.h"

#include "javascript/jsapi.h"

#include "node.h"



static JSPropertySpec jsclass_properties[];

JSClass JSClass_Node = {
	"Node",
	0,
	JS_PropertyStub,	/* addProperty */
	JS_PropertyStub,	/* delProperty */
	JS_PropertyStub,	/* getProperty */
	JS_StrictPropertyStub,	/* setProperty */
	JS_EnumerateStub,	/* enumerate */
	JS_ResolveStub,
	JS_ConvertStub,	/* convert */
	JS_FinalizeStub,
	0,	/* reserved */
	NULL,	/* checkAccess */
	NULL,	/* call */
	NULL,	/* construct */
	NULL,	/* xdr Object */
	NULL,	/* hasInstance */
	NULL, /* trace/mark */
	JSAPI_CLASS_NO_INTERNAL_MEMBERS
};

enum property_tinyid {
	/**** Node ****/
	JSAPI_PROP_TINYID_nodeType,
	JSAPI_PROP_TINYID_nodeName,
	JSAPI_PROP_TINYID_baseURI,
	JSAPI_PROP_TINYID_ownerDocument,
	JSAPI_PROP_TINYID_parentNode,
	JSAPI_PROP_TINYID_parentElement,
	JSAPI_PROP_TINYID_childNodes,
	JSAPI_PROP_TINYID_firstChild,
	JSAPI_PROP_TINYID_lastChild,
	JSAPI_PROP_TINYID_previousSibling,
	JSAPI_PROP_TINYID_nextSibling,
	JSAPI_PROP_TINYID_nodeValue,
	JSAPI_PROP_TINYID_textContent,
	/**** EventTarget ****/
	JSAPI_PROP_TINYID_END,
};



/**** Node ****/
static JSBool JSAPI_FUNC(hasChildNodes, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	JSLOG("operation Node.hasChildNodes has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(insertBefore, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *node = NULL;
	JSObject *child = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	node = JSVAL_TO_OBJECT(argv[0]);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[1])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[1]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	child = JSVAL_TO_OBJECT(argv[1]);
	JSLOG("operation Node.insertBefore has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(appendChild, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *node = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	node = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation Node.appendChild has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(replaceChild, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *node = NULL;
	JSObject *child = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	node = JSVAL_TO_OBJECT(argv[0]);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[1])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[1]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	child = JSVAL_TO_OBJECT(argv[1]);
	JSLOG("operation Node.replaceChild has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(removeChild, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *child = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	child = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation Node.removeChild has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(normalize, JSContext *cx, uintN argc, jsval *vp)
{
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	JSLOG("operation Node.normalize has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(cloneNode, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	JSLOG("operation Node.cloneNode has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(isEqualNode, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *node = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	node = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation Node.isEqualNode has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(compareDocumentPosition, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *other = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	other = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation Node.compareDocumentPosition has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(contains, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *other = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	other = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation Node.contains has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(lookupPrefix, JSContext *cx, uintN argc, jsval *vp)
{
	JSString *jsret = NULL;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *namespace_jsstr = NULL;
	int namespace_len = 0;
	char *namespace = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (argc > 0) {
		namespace_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		namespace_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (namespace_jsstr != NULL) {
		JSString_to_char(namespace_jsstr, namespace, namespace_len);
	}

	JSLOG("operation Node.lookupPrefix has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(lookupNamespaceURI, JSContext *cx, uintN argc, jsval *vp)
{
	JSString *jsret = NULL;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *prefix_jsstr = NULL;
	int prefix_len = 0;
	char *prefix = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (argc > 0) {
		prefix_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		prefix_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (prefix_jsstr != NULL) {
		JSString_to_char(prefix_jsstr, prefix, prefix_len);
	}

	JSLOG("operation Node.lookupNamespaceURI has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(isDefaultNamespace, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *namespace_jsstr = NULL;
	int namespace_len = 0;
	char *namespace = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (argc > 0) {
		namespace_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		namespace_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (namespace_jsstr != NULL) {
		JSString_to_char(namespace_jsstr, namespace, namespace_len);
	}

	JSLOG("operation Node.isDefaultNamespace has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** EventTarget ****/
static JSBool JSAPI_FUNC(addEventListener, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *type_jsstr = NULL;
	int type_len = 0;
	char *type = NULL;
	JSObject *callback = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (argc > 0) {
		type_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		type_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (type_jsstr != NULL) {
		JSString_to_char(type_jsstr, type, type_len);
	}

	if (!JSAPI_JSVAL_IS_OBJECT(argv[1])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[1]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	callback = JSVAL_TO_OBJECT(argv[1]);
	JSLOG("operation Node.addEventListener has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(removeEventListener, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *type_jsstr = NULL;
	int type_len = 0;
	char *type = NULL;
	JSObject *callback = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (argc > 0) {
		type_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		type_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (type_jsstr != NULL) {
		JSString_to_char(type_jsstr, type, type_len);
	}

	if (!JSAPI_JSVAL_IS_OBJECT(argv[1])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[1]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	callback = JSVAL_TO_OBJECT(argv[1]);
	JSLOG("operation Node.removeEventListener has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(dispatchEvent, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *event = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, JSAPI_THIS_OBJECT(cx,vp));
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	event = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation Node.dispatchEvent has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** Node ****/
static JSBool JSAPI_PROP(nodeType_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	uint16_t jsret = 0;
	JSLOG("jscontext:%p jsobject:%p", cx, obj);
	JSLOG("property Node.nodeType has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, INT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(nodeName_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, obj);
	JSLOG("property Node.nodeName has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(baseURI_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, obj);
	JSLOG("property Node.baseURI has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(ownerDocument_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Document */
	JSLOG("jscontext:%p jsobject:%p", cx, obj);
	JSLOG("property Node.ownerDocument has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(parentNode_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	JSLOG("jscontext:%p jsobject:%p", cx, obj);
	JSLOG("property Node.parentNode has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(parentElement_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Element */
	JSLOG("jscontext:%p jsobject:%p", cx, obj);
	JSLOG("property Node.parentElement has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(childNodes_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* NodeList */
	JSLOG("jscontext:%p jsobject:%p", cx, obj);
	JSLOG("property Node.childNodes has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(firstChild_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	JSLOG("jscontext:%p jsobject:%p", cx, obj);
	JSLOG("property Node.firstChild has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(lastChild_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	JSLOG("jscontext:%p jsobject:%p", cx, obj);
	JSLOG("property Node.lastChild has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(previousSibling_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	JSLOG("jscontext:%p jsobject:%p", cx, obj);
	JSLOG("property Node.previousSibling has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(nextSibling_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	JSLOG("jscontext:%p jsobject:%p", cx, obj);
	JSLOG("property Node.nextSibling has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(nodeValue_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSLOG("jscontext:%p jsobject:%p", cx, obj);
	JSLOG("property Node.nodeValue has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(nodeValue_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, obj);
	JSLOG("property Node.nodeValue has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(textContent_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSLOG("jscontext:%p jsobject:%p", cx, obj);
	JSLOG("property Node.textContent has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(textContent_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	JSLOG("jscontext:%p jsobject:%p", cx, obj);
	JSLOG("property Node.textContent has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** EventTarget ****/
static JSFunctionSpec jsclass_functions[] = {
	/**** Node ****/
	JSAPI_FS(hasChildNodes, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(insertBefore, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(appendChild, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(replaceChild, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(removeChild, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(normalize, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(cloneNode, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(isEqualNode, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(compareDocumentPosition, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(contains, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(lookupPrefix, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(lookupNamespaceURI, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(isDefaultNamespace, 0, JSPROP_ENUMERATE ),
	/**** EventTarget ****/
	JSAPI_FS(addEventListener, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(removeEventListener, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(dispatchEvent, 0, JSPROP_ENUMERATE ),
	JSAPI_FS_END
};

static JSPropertySpec jsclass_properties[] = {
	/**** Node ****/
	JSAPI_PS_RO("nodeType",
		nodeType,
		JSAPI_PROP_TINYID_nodeType,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("nodeName",
		nodeName,
		JSAPI_PROP_TINYID_nodeName,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("baseURI",
		baseURI,
		JSAPI_PROP_TINYID_baseURI,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("ownerDocument",
		ownerDocument,
		JSAPI_PROP_TINYID_ownerDocument,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("parentNode",
		parentNode,
		JSAPI_PROP_TINYID_parentNode,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("parentElement",
		parentElement,
		JSAPI_PROP_TINYID_parentElement,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("childNodes",
		childNodes,
		JSAPI_PROP_TINYID_childNodes,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("firstChild",
		firstChild,
		JSAPI_PROP_TINYID_firstChild,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("lastChild",
		lastChild,
		JSAPI_PROP_TINYID_lastChild,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("previousSibling",
		previousSibling,
		JSAPI_PROP_TINYID_previousSibling,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("nextSibling",
		nextSibling,
		JSAPI_PROP_TINYID_nextSibling,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("nodeValue",
		nodeValue,
		JSAPI_PROP_TINYID_nodeValue,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("textContent",
		textContent,
		JSAPI_PROP_TINYID_textContent,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	/**** EventTarget ****/
	JSAPI_PS_END
};

JSObject *jsapi_InitClass_Node(JSContext *cx, JSObject *parent)
{
	JSObject *prototype;

	prototype = JS_InitClass(cx,
		parent,
		NULL,
		&JSClass_Node,
		NULL,
		0,
		NULL,
		NULL, 
		NULL, 
		NULL);
	/**** Node ****/
	JS_DefineProperty(cx,
		prototype,
		"ELEMENT_NODE",
		INT_TO_JSVAL(1),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"ATTRIBUTE_NODE",
		INT_TO_JSVAL(2),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"TEXT_NODE",
		INT_TO_JSVAL(3),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"CDATA_SECTION_NODE",
		INT_TO_JSVAL(4),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"ENTITY_REFERENCE_NODE",
		INT_TO_JSVAL(5),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"ENTITY_NODE",
		INT_TO_JSVAL(6),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"PROCESSING_INSTRUCTION_NODE",
		INT_TO_JSVAL(7),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"COMMENT_NODE",
		INT_TO_JSVAL(8),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_NODE",
		INT_TO_JSVAL(9),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_TYPE_NODE",
		INT_TO_JSVAL(10),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_FRAGMENT_NODE",
		INT_TO_JSVAL(11),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"NOTATION_NODE",
		INT_TO_JSVAL(12),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_POSITION_DISCONNECTED",
		INT_TO_JSVAL(1),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_POSITION_PRECEDING",
		INT_TO_JSVAL(2),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_POSITION_FOLLOWING",
		INT_TO_JSVAL(4),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_POSITION_CONTAINS",
		INT_TO_JSVAL(8),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_POSITION_CONTAINED_BY",
		INT_TO_JSVAL(16),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC",
		INT_TO_JSVAL(32),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	/**** EventTarget ****/
	return prototype;
}

JSObject *jsapi_new_Node(JSContext *cx,
		JSObject *prototype,
		JSObject *parent)
{
	JSObject *newobject;

	newobject = JS_NewObject(cx, &JSClass_Node, prototype, parent);
	if (newobject == NULL) {
		return NULL;
	}
	if (JSAPI_ADD_OBJECT_ROOT(cx, &newobject) != JS_TRUE) {
		return NULL;
	}

	if (JS_DefineFunctions(cx, newobject, jsclass_functions) != JS_TRUE) {
		return NULL;
	}

	if (JS_DefineProperties(cx, newobject, jsclass_properties) != JS_TRUE) {
		return NULL;
	}

	JSAPI_REMOVE_OBJECT_ROOT(cx, &newobject);

	return newobject;
}


