/* Generated by nsgenbind from javascript/jsapi/text.bnd
 *
 * nsgenbind is published under the MIT Licence.
 * nsgenbind is similar to a compiler is a purely transformative tool which
 * explicitly makes no copyright claim on this generated output
 * 
 * Copyright 2012 Vincent Sanders <vince@netsurf-browser.org>
 * 
 * This file is part of NetSurf, http://www.netsurf-browser.org/
 * 
 * Released under the terms of the MIT License,
 * 
 *         http://www.opensource.org/licenses/mit-license
 */



#include <dom/dom.h>

#include "utils/config.h"
#include "utils/log.h"
#include "render/html_internal.h"
#include "javascript/jsapi.h"

#include "text.h"


#include "comment.h"
#include "text.h"
#include "htmlelement.h"


struct jsclass_private {
        dom_text *node;
        struct html_content *htmlc;
};

static void jsclass_finalize(JSContext *cx, JSObject *obj);

static JSPropertySpec jsclass_properties[];

JSClass JSClass_Text = {
	"Text",
	0 | JSCLASS_HAS_PRIVATE,
	JS_PropertyStub,	/* addProperty */
	JS_PropertyStub,	/* delProperty */
	JS_PropertyStub,	/* getProperty */
	JS_StrictPropertyStub,	/* setProperty */
	JS_EnumerateStub,	/* enumerate */
	JS_ResolveStub,
	JS_ConvertStub,	/* convert */
	jsclass_finalize,
	0,	/* reserved */
	NULL,	/* checkAccess */
	NULL,	/* call */
	NULL,	/* construct */
	NULL,	/* xdr Object */
	NULL,	/* hasInstance */
	NULL, /* trace/mark */
	JSAPI_CLASS_NO_INTERNAL_MEMBERS
};

enum property_tinyid {
	/**** Text ****/
	JSAPI_PROP_TINYID_wholeText,
	/**** CharacterData ****/
	JSAPI_PROP_TINYID_data,
	JSAPI_PROP_TINYID_length,
	/**** Node ****/
	JSAPI_PROP_TINYID_nodeType,
	JSAPI_PROP_TINYID_nodeName,
	JSAPI_PROP_TINYID_baseURI,
	JSAPI_PROP_TINYID_ownerDocument,
	JSAPI_PROP_TINYID_parentNode,
	JSAPI_PROP_TINYID_parentElement,
	JSAPI_PROP_TINYID_childNodes,
	JSAPI_PROP_TINYID_firstChild,
	JSAPI_PROP_TINYID_lastChild,
	JSAPI_PROP_TINYID_previousSibling,
	JSAPI_PROP_TINYID_nextSibling,
	JSAPI_PROP_TINYID_nodeValue,
	JSAPI_PROP_TINYID_textContent,
	/**** EventTarget ****/
	JSAPI_PROP_TINYID_END,
};


/* CAUTION this expects all javascript Node objects private pointers
 * to have private->node in the same place.
 */
static struct dom_node *jsnode_to_domnode(JSContext *cx, JSObject *jsnode)
{
	struct jsclass_private *jsnode_private;

	if (jsnode == NULL) {
		return NULL;
	}

	/* element */
	jsnode_private = JS_GetInstancePrivate(cx,
					       jsnode,
					       &JSClass_HTMLElement,
					       NULL);
	if (jsnode_private != NULL) {
		return (struct dom_node *)jsnode_private->node;
	}

	/* text */
	jsnode_private = JS_GetInstancePrivate(cx,
					       jsnode,
					       &JSClass_Text,
					       NULL);
	if (jsnode_private != NULL) {
		return (struct dom_node *)jsnode_private->node;
	}

	/* comment */
	jsnode_private = JS_GetInstancePrivate(cx,
					       jsnode,
					       &JSClass_Comment,
					       NULL);
	if (jsnode_private != NULL) {
		return (struct dom_node *)jsnode_private->node;
	}

	return NULL;
}



/**** Text ****/
static JSBool JSAPI_FUNC(splitText, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Text */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	uint32_t offset = 0;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JS_ValueToECMAUint32(cx, argv[0], &offset);
	JSLOG("operation Text.splitText has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** CharacterData ****/
static JSBool JSAPI_FUNC(substringData, JSContext *cx, uintN argc, jsval *vp)
{
	JSString *jsret = NULL;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	uint32_t offset = 0;
	uint32_t count = 0;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JS_ValueToECMAUint32(cx, argv[0], &offset);
	JS_ValueToECMAUint32(cx, argv[1], &count);
	JSLOG("operation Text.substringData has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(appendData, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *data_jsstr = NULL;
	int data_len = 0;
	char *data = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		data_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		data_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (data_jsstr != NULL) {
		JSString_to_char(data_jsstr, data, data_len);
	}

	JSLOG("operation Text.appendData has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(insertData, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	uint32_t offset = 0;
	JSString *data_jsstr = NULL;
	int data_len = 0;
	char *data = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JS_ValueToECMAUint32(cx, argv[0], &offset);
	if (argc > 1) {
		data_jsstr = JS_ValueToString(cx, argv[1]);
	} else {
		data_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (data_jsstr != NULL) {
		JSString_to_char(data_jsstr, data, data_len);
	}

	JSLOG("operation Text.insertData has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(deleteData, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	uint32_t offset = 0;
	uint32_t count = 0;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JS_ValueToECMAUint32(cx, argv[0], &offset);
	JS_ValueToECMAUint32(cx, argv[1], &count);
	JSLOG("operation Text.deleteData has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(replaceData, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	uint32_t offset = 0;
	uint32_t count = 0;
	JSString *data_jsstr = NULL;
	int data_len = 0;
	char *data = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JS_ValueToECMAUint32(cx, argv[0], &offset);
	JS_ValueToECMAUint32(cx, argv[1], &count);
	if (argc > 2) {
		data_jsstr = JS_ValueToString(cx, argv[2]);
	} else {
		data_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (data_jsstr != NULL) {
		JSString_to_char(data_jsstr, data, data_len);
	}

	JSLOG("operation Text.replaceData has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(before, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Text.before has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(after, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Text.after has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(replace, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Text.replace has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(remove, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Text.remove has no implementation");
	return JS_TRUE;
}

/**** Node ****/
static JSBool JSAPI_FUNC(hasChildNodes, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Text.hasChildNodes has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(insertBefore, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *node = NULL;
	JSObject *child = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	node = JSVAL_TO_OBJECT(argv[0]);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[1])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[1]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	child = JSVAL_TO_OBJECT(argv[1]);
	JSLOG("operation Text.insertBefore has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(appendChild, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *node = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	node = JSVAL_TO_OBJECT(argv[0]);

	struct dom_node *domnode; /* dom node from js input node */
	struct dom_node *result = NULL;
	dom_exception exc;
	dom_node_type node_type;

	domnode = jsnode_to_domnode(cx, node);
	if (domnode == NULL) {
		/* should cause Error: NOT_FOUND_ERR: DOM Exception 8 */
		JSLOG("Error: NOT_FOUND_ERR: DOM Exception 8");
		return JS_FALSE;
	}

	JSLOG("appending js node %p (dom %p)", node, domnode);

	/* append the found element */
	exc = dom_node_append_child(private->node, domnode, &result);
	if (exc != DOM_NO_ERR) {
		JSLOG("Error: DOM Exception (libdom append child)");
		return JS_FALSE;
	}

	if (result != NULL) {
		exc = dom_node_get_node_type(result, &node_type);
		if (exc != DOM_NO_ERR) {
			return JS_FALSE;
		}
		switch (node_type) {
		case DOM_ELEMENT_NODE:
			jsret = jsapi_new_HTMLElement(cx, NULL, NULL, (dom_element *)result, private->htmlc);
			break;

		case DOM_TEXT_NODE:
			jsret = jsapi_new_Text(cx, NULL, NULL, (dom_text *)result, private->htmlc);
			break;

		default:
			JSLOG("Unsupported result node type %d", node_type);
		}

	} else {
		JSLOG("No result");
	}

	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(replaceChild, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *node = NULL;
	JSObject *child = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	node = JSVAL_TO_OBJECT(argv[0]);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[1])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[1]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	child = JSVAL_TO_OBJECT(argv[1]);
	JSLOG("operation Text.replaceChild has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(removeChild, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *child = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	child = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation Text.removeChild has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(normalize, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Text.normalize has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(cloneNode, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Text.cloneNode has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(isEqualNode, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *node = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	node = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation Text.isEqualNode has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(compareDocumentPosition, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *other = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	other = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation Text.compareDocumentPosition has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(contains, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *other = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	other = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation Text.contains has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(lookupPrefix, JSContext *cx, uintN argc, jsval *vp)
{
	JSString *jsret = NULL;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *namespace_jsstr = NULL;
	int namespace_len = 0;
	char *namespace = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		namespace_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		namespace_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (namespace_jsstr != NULL) {
		JSString_to_char(namespace_jsstr, namespace, namespace_len);
	}

	JSLOG("operation Text.lookupPrefix has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(lookupNamespaceURI, JSContext *cx, uintN argc, jsval *vp)
{
	JSString *jsret = NULL;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *prefix_jsstr = NULL;
	int prefix_len = 0;
	char *prefix = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		prefix_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		prefix_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (prefix_jsstr != NULL) {
		JSString_to_char(prefix_jsstr, prefix, prefix_len);
	}

	JSLOG("operation Text.lookupNamespaceURI has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(isDefaultNamespace, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *namespace_jsstr = NULL;
	int namespace_len = 0;
	char *namespace = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		namespace_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		namespace_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (namespace_jsstr != NULL) {
		JSString_to_char(namespace_jsstr, namespace, namespace_len);
	}

	JSLOG("operation Text.isDefaultNamespace has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** EventTarget ****/
static JSBool JSAPI_FUNC(addEventListener, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *type_jsstr = NULL;
	int type_len = 0;
	char *type = NULL;
	JSObject *callback = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		type_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		type_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (type_jsstr != NULL) {
		JSString_to_char(type_jsstr, type, type_len);
	}

	if (!JSAPI_JSVAL_IS_OBJECT(argv[1])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[1]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	callback = JSVAL_TO_OBJECT(argv[1]);
	JSLOG("operation Text.addEventListener has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(removeEventListener, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *type_jsstr = NULL;
	int type_len = 0;
	char *type = NULL;
	JSObject *callback = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		type_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		type_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (type_jsstr != NULL) {
		JSString_to_char(type_jsstr, type, type_len);
	}

	if (!JSAPI_JSVAL_IS_OBJECT(argv[1])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[1]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	callback = JSVAL_TO_OBJECT(argv[1]);
	JSLOG("operation Text.removeEventListener has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(dispatchEvent, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *event = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Text,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	event = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation Text.dispatchEvent has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** Text ****/
static JSBool JSAPI_PROP(wholeText_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Text, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Text.wholeText has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** CharacterData ****/
static JSBool JSAPI_STRICTPROP(data_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Text, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Text.data has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(data_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Text, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Text.data has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(length_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	uint32_t jsret = 0;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Text, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Text.length has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, INT_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** Node ****/
static JSBool JSAPI_PROP(nodeType_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	uint16_t jsret = 0;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Text, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	dom_exception exc;
	dom_node_type node_type;

	exc = dom_node_get_node_type(private->node, &node_type);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}
	jsret = node_type;

	JSAPI_PROP_SET_RVAL(cx, vp, INT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(nodeName_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Text, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	dom_exception exc;
	dom_string *name;

	exc = dom_node_get_node_name(private->node, &name);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	if (name != NULL) {
		jsret = JS_NewStringCopyN(cx,
					  dom_string_data(name),
					  dom_string_length(name));
		dom_string_unref(name);
	}

	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(baseURI_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Text, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Text.baseURI has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(ownerDocument_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Document */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Text, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Text.ownerDocument has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(parentNode_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Text, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Text.parentNode has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(parentElement_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Element */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Text, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Text.parentElement has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(childNodes_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* NodeList */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Text, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Text.childNodes has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(firstChild_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Text, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Text.firstChild has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(lastChild_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Text, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Text.lastChild has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(previousSibling_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Text, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Text.previousSibling has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(nextSibling_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Node */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Text, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Text.nextSibling has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(nodeValue_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Text, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Text.nodeValue has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(nodeValue_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Text, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	dom_exception exc;
	dom_string *value;

	exc = dom_node_get_node_value(private->node, &value);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	if (value != NULL) {
		jsret = JS_NewStringCopyN(cx,
					  dom_string_data(value),
					  dom_string_length(value));
		dom_string_unref(value);
	}

	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(textContent_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Text, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Text.textContent has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(textContent_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Text, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	dom_exception exc;
	dom_string *content;

	exc = dom_node_get_text_content(private->node, &content);
	if (exc != DOM_NO_ERR) {
		return JS_FALSE;
	}

	if (content != NULL) {
		jsret = JS_NewStringCopyN(cx, dom_string_data(content), dom_string_length(content));
		dom_string_unref(content);

	}

	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** EventTarget ****/
static JSFunctionSpec jsclass_functions[] = {
	/**** Text ****/
	JSAPI_FS(splitText, 0, JSPROP_ENUMERATE ),
	/**** CharacterData ****/
	JSAPI_FS(substringData, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(appendData, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(insertData, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(deleteData, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(replaceData, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(before, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(after, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(replace, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(remove, 0, JSPROP_ENUMERATE ),
	/**** Node ****/
	JSAPI_FS(hasChildNodes, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(insertBefore, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(appendChild, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(replaceChild, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(removeChild, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(normalize, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(cloneNode, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(isEqualNode, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(compareDocumentPosition, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(contains, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(lookupPrefix, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(lookupNamespaceURI, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(isDefaultNamespace, 0, JSPROP_ENUMERATE ),
	/**** EventTarget ****/
	JSAPI_FS(addEventListener, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(removeEventListener, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(dispatchEvent, 0, JSPROP_ENUMERATE ),
	JSAPI_FS_END
};

static JSPropertySpec jsclass_properties[] = {
	/**** Text ****/
	JSAPI_PS_RO("wholeText",
		wholeText,
		JSAPI_PROP_TINYID_wholeText,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	/**** CharacterData ****/
	JSAPI_PS("data",
		data,
		JSAPI_PROP_TINYID_data,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("length",
		length,
		JSAPI_PROP_TINYID_length,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	/**** Node ****/
	JSAPI_PS_RO("nodeType",
		nodeType,
		JSAPI_PROP_TINYID_nodeType,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("nodeName",
		nodeName,
		JSAPI_PROP_TINYID_nodeName,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("baseURI",
		baseURI,
		JSAPI_PROP_TINYID_baseURI,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("ownerDocument",
		ownerDocument,
		JSAPI_PROP_TINYID_ownerDocument,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("parentNode",
		parentNode,
		JSAPI_PROP_TINYID_parentNode,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("parentElement",
		parentElement,
		JSAPI_PROP_TINYID_parentElement,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("childNodes",
		childNodes,
		JSAPI_PROP_TINYID_childNodes,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("firstChild",
		firstChild,
		JSAPI_PROP_TINYID_firstChild,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("lastChild",
		lastChild,
		JSAPI_PROP_TINYID_lastChild,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("previousSibling",
		previousSibling,
		JSAPI_PROP_TINYID_previousSibling,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("nextSibling",
		nextSibling,
		JSAPI_PROP_TINYID_nextSibling,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("nodeValue",
		nodeValue,
		JSAPI_PROP_TINYID_nodeValue,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("textContent",
		textContent,
		JSAPI_PROP_TINYID_textContent,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	/**** EventTarget ****/
	JSAPI_PS_END
};

static void jsclass_finalize(JSContext *cx, JSObject *obj)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Text, NULL);
	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

        if (private != NULL) {
                dom_node_unref(private->node);
        }

	if (private != NULL) {
		free(private);
	}
}

JSObject *jsapi_InitClass_Text(JSContext *cx, JSObject *parent)
{
	JSObject *prototype;

	prototype = JS_InitClass(cx,
		parent,
		NULL,
		&JSClass_Text,
		NULL,
		0,
		NULL,
		NULL, 
		NULL, 
		NULL);
	/**** Text ****/
	/**** CharacterData ****/
	/**** Node ****/
	JS_DefineProperty(cx,
		prototype,
		"ELEMENT_NODE",
		INT_TO_JSVAL(1),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"ATTRIBUTE_NODE",
		INT_TO_JSVAL(2),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"TEXT_NODE",
		INT_TO_JSVAL(3),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"CDATA_SECTION_NODE",
		INT_TO_JSVAL(4),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"ENTITY_REFERENCE_NODE",
		INT_TO_JSVAL(5),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"ENTITY_NODE",
		INT_TO_JSVAL(6),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"PROCESSING_INSTRUCTION_NODE",
		INT_TO_JSVAL(7),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"COMMENT_NODE",
		INT_TO_JSVAL(8),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_NODE",
		INT_TO_JSVAL(9),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_TYPE_NODE",
		INT_TO_JSVAL(10),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_FRAGMENT_NODE",
		INT_TO_JSVAL(11),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"NOTATION_NODE",
		INT_TO_JSVAL(12),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_POSITION_DISCONNECTED",
		INT_TO_JSVAL(1),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_POSITION_PRECEDING",
		INT_TO_JSVAL(2),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_POSITION_FOLLOWING",
		INT_TO_JSVAL(4),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_POSITION_CONTAINS",
		INT_TO_JSVAL(8),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_POSITION_CONTAINED_BY",
		INT_TO_JSVAL(16),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	JS_DefineProperty(cx,
		prototype,
		"DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC",
		INT_TO_JSVAL(32),
		JS_PropertyStub,
		JS_StrictPropertyStub,
		JSPROP_READONLY | JSPROP_ENUMERATE | JSPROP_PERMANENT);

	/**** EventTarget ****/
	return prototype;
}

JSObject *jsapi_new_Text(JSContext *cx,
		JSObject *prototype,
		JSObject *parent,
		dom_text *node,
		struct html_content *htmlc)
{
	JSObject *newobject;
	struct jsclass_private *private;

	private = malloc(sizeof(struct jsclass_private));
	if (private == NULL) {
		return NULL;
	}
	private->node = node;
	private->htmlc = htmlc;

	newobject = JS_NewObject(cx, &JSClass_Text, prototype, parent);
	if (newobject == NULL) {
		free(private);
		return NULL;
	}

	if (JSAPI_ADD_OBJECT_ROOT(cx, &newobject) != JS_TRUE) {
		free(private);
		return NULL;
	}


	/* attach private pointer */
	if (JS_SetPrivate(cx, newobject, private) != JS_TRUE) {
		free(private);
		return NULL;
	}

	if (JS_DefineFunctions(cx, newobject, jsclass_functions) != JS_TRUE) {
		free(private);
		return NULL;
	}

	if (JS_DefineProperties(cx, newobject, jsclass_properties) != JS_TRUE) {
		free(private);
		return NULL;
	}

	JSAPI_REMOVE_OBJECT_ROOT(cx, &newobject);

	return newobject;
}


