/* Generated by nsgenbind from javascript/jsapi/window.bnd
 *
 * nsgenbind is published under the MIT Licence.
 * nsgenbind is similar to a compiler is a purely transformative tool which
 * explicitly makes no copyright claim on this generated output
 * 
 * Copyright 2012 Vincent Sanders <vince@netsurf-browser.org>
 * 
 * This file is part of NetSurf, http://www.netsurf-browser.org/
 * 
 * Released under the terms of the MIT License,
 * 
 *         http://www.opensource.org/licenses/mit-license
 */



#include <dom/dom.h>

#include "utils/config.h"
#include "utils/log.h"
#include "utils/corestrings.h"
#include "render/html_internal.h"
#include "javascript/jsapi.h"

#include "console.h"
#include "navigator.h"
#include "event.h"
#include "node.h"
#include "htmlcollection.h"
#include "nodelist.h"
#include "htmldocument.h"
#include "text.h"
#include "comment.h"
#include "htmlelement.h"
#include "window.h"
#include "location.h"

struct browser_window *jsapi_get_browser_window(JSContext *cx);



struct jsclass_private {
        struct browser_window *bw;
        struct html_content *htmlc;
        JSObject *prototype_Document;
        JSObject *prototype_Navigator;
        JSObject *prototype_Location;
        JSObject *prototype_Console;
        JSObject *prototype_HTMLElement;
        JSObject *prototype_HTMLCollection;
        JSObject *prototype_NodeList;
        JSObject *prototype_Text;
        JSObject *prototype_Comment;
        JSObject *prototype_Node;
        JSObject *prototype_Event;
};

static JSAPI_MARKOP(jsclass_mark);

static void jsclass_finalize(JSContext *cx, JSObject *obj);

static JSPropertySpec jsclass_properties[];

JSClass JSClass_Window = {
	"Window",
	JSCLASS_GLOBAL_FLAGS | JSAPI_JSCLASS_MARK_IS_TRACE | JSCLASS_HAS_PRIVATE,
	JS_PropertyStub,	/* addProperty */
	JS_PropertyStub,	/* delProperty */
	JS_PropertyStub,	/* getProperty */
	JS_StrictPropertyStub,	/* setProperty */
	JS_EnumerateStub,	/* enumerate */
	JS_ResolveStub,
	JS_ConvertStub,	/* convert */
	jsclass_finalize,
	0,	/* reserved */
	NULL,	/* checkAccess */
	NULL,	/* call */
	NULL,	/* construct */
	NULL,	/* xdr Object */
	NULL,	/* hasInstance */
	JSAPI_JSCLASS_MARKOP(jsclass_mark),
	JSAPI_CLASS_NO_INTERNAL_MEMBERS
};

enum property_tinyid {
	/**** Window ****/
	JSAPI_PROP_TINYID_window,
	JSAPI_PROP_TINYID_self,
	JSAPI_PROP_TINYID_document,
	JSAPI_PROP_TINYID_name,
	JSAPI_PROP_TINYID_location,
	JSAPI_PROP_TINYID_history,
	JSAPI_PROP_TINYID_locationbar,
	JSAPI_PROP_TINYID_menubar,
	JSAPI_PROP_TINYID_personalbar,
	JSAPI_PROP_TINYID_scrollbars,
	JSAPI_PROP_TINYID_statusbar,
	JSAPI_PROP_TINYID_toolbar,
	JSAPI_PROP_TINYID_status,
	JSAPI_PROP_TINYID_frames,
	JSAPI_PROP_TINYID_length,
	JSAPI_PROP_TINYID_top,
	JSAPI_PROP_TINYID_opener,
	JSAPI_PROP_TINYID_parent,
	JSAPI_PROP_TINYID_frameElement,
	JSAPI_PROP_TINYID_navigator,
	JSAPI_PROP_TINYID_external,
	JSAPI_PROP_TINYID_applicationCache,
	JSAPI_PROP_TINYID_onabort,
	JSAPI_PROP_TINYID_onafterprint,
	JSAPI_PROP_TINYID_onbeforeprint,
	JSAPI_PROP_TINYID_onbeforeunload,
	JSAPI_PROP_TINYID_onblur,
	JSAPI_PROP_TINYID_oncancel,
	JSAPI_PROP_TINYID_oncanplay,
	JSAPI_PROP_TINYID_oncanplaythrough,
	JSAPI_PROP_TINYID_onchange,
	JSAPI_PROP_TINYID_onclick,
	JSAPI_PROP_TINYID_onclose,
	JSAPI_PROP_TINYID_oncontextmenu,
	JSAPI_PROP_TINYID_oncuechange,
	JSAPI_PROP_TINYID_ondblclick,
	JSAPI_PROP_TINYID_ondrag,
	JSAPI_PROP_TINYID_ondragend,
	JSAPI_PROP_TINYID_ondragenter,
	JSAPI_PROP_TINYID_ondragleave,
	JSAPI_PROP_TINYID_ondragover,
	JSAPI_PROP_TINYID_ondragstart,
	JSAPI_PROP_TINYID_ondrop,
	JSAPI_PROP_TINYID_ondurationchange,
	JSAPI_PROP_TINYID_onemptied,
	JSAPI_PROP_TINYID_onended,
	JSAPI_PROP_TINYID_onerror,
	JSAPI_PROP_TINYID_onfocus,
	JSAPI_PROP_TINYID_onhashchange,
	JSAPI_PROP_TINYID_oninput,
	JSAPI_PROP_TINYID_oninvalid,
	JSAPI_PROP_TINYID_onkeydown,
	JSAPI_PROP_TINYID_onkeypress,
	JSAPI_PROP_TINYID_onkeyup,
	JSAPI_PROP_TINYID_onload,
	JSAPI_PROP_TINYID_onloadeddata,
	JSAPI_PROP_TINYID_onloadedmetadata,
	JSAPI_PROP_TINYID_onloadstart,
	JSAPI_PROP_TINYID_onmessage,
	JSAPI_PROP_TINYID_onmousedown,
	JSAPI_PROP_TINYID_onmousemove,
	JSAPI_PROP_TINYID_onmouseout,
	JSAPI_PROP_TINYID_onmouseover,
	JSAPI_PROP_TINYID_onmouseup,
	JSAPI_PROP_TINYID_onmousewheel,
	JSAPI_PROP_TINYID_onoffline,
	JSAPI_PROP_TINYID_ononline,
	JSAPI_PROP_TINYID_onpause,
	JSAPI_PROP_TINYID_onplay,
	JSAPI_PROP_TINYID_onplaying,
	JSAPI_PROP_TINYID_onpagehide,
	JSAPI_PROP_TINYID_onpageshow,
	JSAPI_PROP_TINYID_onpopstate,
	JSAPI_PROP_TINYID_onprogress,
	JSAPI_PROP_TINYID_onratechange,
	JSAPI_PROP_TINYID_onreset,
	JSAPI_PROP_TINYID_onresize,
	JSAPI_PROP_TINYID_onscroll,
	JSAPI_PROP_TINYID_onseeked,
	JSAPI_PROP_TINYID_onseeking,
	JSAPI_PROP_TINYID_onselect,
	JSAPI_PROP_TINYID_onshow,
	JSAPI_PROP_TINYID_onstalled,
	JSAPI_PROP_TINYID_onstorage,
	JSAPI_PROP_TINYID_onsubmit,
	JSAPI_PROP_TINYID_onsuspend,
	JSAPI_PROP_TINYID_ontimeupdate,
	JSAPI_PROP_TINYID_onunload,
	JSAPI_PROP_TINYID_onvolumechange,
	JSAPI_PROP_TINYID_onwaiting,
	/**** Window ****/
	JSAPI_PROP_TINYID_console,
	/**** EventTarget ****/
	/**** WindowBase64 ****/
	/**** WindowTimers ****/
	/**** WindowSessionStorage ****/
	JSAPI_PROP_TINYID_sessionStorage,
	/**** WindowLocalStorage ****/
	JSAPI_PROP_TINYID_localStorage,
	JSAPI_PROP_TINYID_END,
};



struct browser_window *jsapi_get_browser_window(JSContext *cx)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
					JS_GetGlobalObject(cx),
					&JSClass_Window,
					NULL);
	if (private != NULL) {
		return private->bw;
	}

	return NULL;
}

static bool
init_user_prototypes(JSContext *cx,
		     struct jsclass_private *private,
		     JSObject *parent)
{
	/* Initialises all the user javascript classes to make their
	 * prototypes available.
	 */
	/** @todo should we be managing these prototype objects ourselves */
	private->prototype_Document = jsapi_InitClass_Document(cx, parent);
	if (private->prototype_Document == NULL) {
		return false;
	}

	private->prototype_Navigator = jsapi_InitClass_Navigator(cx, parent);
	if (private->prototype_Navigator == NULL) {
		return false;
	}

	private->prototype_Location = jsapi_InitClass_Location(cx, parent);
	if (private->prototype_Location == NULL) {
		return false;
	}

	private->prototype_Console = jsapi_InitClass_Console(cx, parent);
	if (private->prototype_Console == NULL) {
		return false;
	}

	private->prototype_HTMLElement = jsapi_InitClass_HTMLElement(cx, parent);
	if (private->prototype_HTMLElement == NULL) {
		return false;
	}

	private->prototype_HTMLCollection = jsapi_InitClass_HTMLCollection(cx, parent);
	if (private->prototype_HTMLCollection == NULL) {
		return false;
	}

	private->prototype_NodeList = jsapi_InitClass_NodeList(cx, parent);
	if (private->prototype_NodeList == NULL) {
		return false;
	}

	private->prototype_Text = jsapi_InitClass_Text(cx, parent);
	if (private->prototype_Text == NULL) {
		return false;
	}

	private->prototype_Comment = jsapi_InitClass_Comment(cx, parent);
	if (private->prototype_Comment == NULL) {
		return false;
	}

	private->prototype_Node = jsapi_InitClass_Node(cx, parent);
	if (private->prototype_Node == NULL) {
		return false;
	}

	private->prototype_Event = jsapi_InitClass_Event(cx, parent);
	if (private->prototype_Event == NULL) {
		return false;
	}
	return true;
}



/**** Window ****/
static JSBool JSAPI_FUNC(close, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Window,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Window.close has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(stop, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Window,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Window.stop has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(focus, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Window,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Window.focus has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(blur, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Window,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Window.blur has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(open, JSContext *cx, uintN argc, jsval *vp)
{
	JSObject *jsret = NULL; /* WindowProxy */
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Window,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Window.open has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(alert, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *message_jsstr = NULL;
	int message_len = 0;
	char *message = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Window,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		message_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		message_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (message_jsstr != NULL) {
		JSString_to_char(message_jsstr, message, message_len);
	}


	warn_user(message, NULL);

	return JS_TRUE;
}

static JSBool JSAPI_FUNC(confirm, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *message_jsstr = NULL;
	int message_len = 0;
	char *message = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Window,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		message_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		message_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (message_jsstr != NULL) {
		JSString_to_char(message_jsstr, message, message_len);
	}


	warn_user(message, NULL);

	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(prompt, JSContext *cx, uintN argc, jsval *vp)
{
	JSString *jsret = NULL;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *message_jsstr = NULL;
	int message_len = 0;
	char *message = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Window,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		message_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		message_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (message_jsstr != NULL) {
		JSString_to_char(message_jsstr, message, message_len);
	}


	warn_user(message, NULL);

	JSAPI_FUNC_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(print, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Window,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JSLOG("operation Window.print has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(showModalDialog, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *url_jsstr = NULL;
	int url_len = 0;
	char *url = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Window,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		url_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		url_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (url_jsstr != NULL) {
		JSString_to_char(url_jsstr, url, url_len);
	}

	JSLOG("operation Window.showModalDialog has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(postMessage, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *targetOrigin_jsstr = NULL;
	int targetOrigin_len = 0;
	char *targetOrigin = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Window,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 1) {
		targetOrigin_jsstr = JS_ValueToString(cx, argv[1]);
	} else {
		targetOrigin_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (targetOrigin_jsstr != NULL) {
		JSString_to_char(targetOrigin_jsstr, targetOrigin, targetOrigin_len);
	}

	JSLOG("operation Window.postMessage has no implementation");
	return JS_TRUE;
}

/**** Window ****/
/**** EventTarget ****/
static JSBool JSAPI_FUNC(addEventListener, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *type_jsstr = NULL;
	int type_len = 0;
	char *type = NULL;
	JSObject *callback = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Window,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		type_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		type_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (type_jsstr != NULL) {
		JSString_to_char(type_jsstr, type, type_len);
	}

	if (!JSAPI_JSVAL_IS_OBJECT(argv[1])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[1]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	callback = JSVAL_TO_OBJECT(argv[1]);
	JSLOG("operation Window.addEventListener has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(removeEventListener, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *type_jsstr = NULL;
	int type_len = 0;
	char *type = NULL;
	JSObject *callback = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Window,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		type_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		type_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (type_jsstr != NULL) {
		JSString_to_char(type_jsstr, type, type_len);
	}

	if (!JSAPI_JSVAL_IS_OBJECT(argv[1])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[1]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	callback = JSVAL_TO_OBJECT(argv[1]);
	JSLOG("operation Window.removeEventListener has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(dispatchEvent, JSContext *cx, uintN argc, jsval *vp)
{
	JSBool jsret = JS_FALSE;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *event = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Window,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	event = JSVAL_TO_OBJECT(argv[0]);

	/* this implementation is unique to the window object as it is
	 * not a "real" dom node.
	 */

	/* caution, this must match the struct generated from event.bnd */
	struct {
		dom_event *event;
	} *event_private;
	dom_string *type_dom = NULL;
	dom_exception exc;
	jsval eventval = JSVAL_VOID;
	jsval event_argv[1];
	jsval event_rval;

	event_private = JS_GetInstancePrivate(cx, event, &JSClass_Event, NULL);
	if (event_private->event == NULL) {
		/** @todo type error? */
		jsret = JS_FALSE;
	} else {
		exc = dom_event_get_type(event_private->event, &type_dom);
		if (exc == DOM_NO_ERR) {

			if (dom_string_isequal(type_dom, corestring_dom_load)) {
				JS_GetProperty(cx, JSAPI_THIS_OBJECT(cx, vp), "onload", &eventval);
			}

			if (!JSVAL_IS_VOID(eventval)) {
				event_argv[0] = eventval;
				jsret = JS_CallFunctionValue(cx, NULL, eventval, 1, event_argv, &event_rval);
			}
		}
	}

	JSAPI_FUNC_SET_RVAL(cx, vp, BOOLEAN_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** WindowBase64 ****/
static JSBool JSAPI_FUNC(btoa, JSContext *cx, uintN argc, jsval *vp)
{
	JSString *jsret = NULL;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *btoa_jsstr = NULL;
	int btoa_len = 0;
	char *btoa = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Window,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		btoa_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		btoa_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (btoa_jsstr != NULL) {
		JSString_to_char(btoa_jsstr, btoa, btoa_len);
	}

	JSLOG("operation Window.btoa has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(atob, JSContext *cx, uintN argc, jsval *vp)
{
	JSString *jsret = NULL;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSString *atob_jsstr = NULL;
	int atob_len = 0;
	char *atob = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Window,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (argc > 0) {
		atob_jsstr = JS_ValueToString(cx, argv[0]);
	} else {
		atob_jsstr = JS_ValueToString(cx, JSVAL_VOID);
	}
	if (atob_jsstr != NULL) {
		JSString_to_char(atob_jsstr, atob, atob_len);
	}

	JSLOG("operation Window.atob has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** WindowTimers ****/
static JSBool JSAPI_FUNC(setTimeout, JSContext *cx, uintN argc, jsval *vp)
{
	int32_t jsret = 0;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *handler = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Window,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	handler = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation Window.setTimeout has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, INT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(clearTimeout, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	int32_t handle = 0;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Window,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JS_ValueToECMAInt32(cx, argv[0], &handle);
	JSLOG("operation Window.clearTimeout has no implementation");
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(setInterval, JSContext *cx, uintN argc, jsval *vp)
{
	int32_t jsret = 0;
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	JSObject *handler = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Window,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	if (!JSAPI_JSVAL_IS_OBJECT(argv[0])) {
		JSType argtype;
		argtype = JS_TypeOfValue(cx, argv[0]);
		JSLOG("User argument is type %s not an object", JS_GetTypeName(cx, argtype));
		return JS_FALSE;
	}
	handler = JSVAL_TO_OBJECT(argv[0]);
	JSLOG("operation Window.setInterval has no implementation");
	JSAPI_FUNC_SET_RVAL(cx, vp, INT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_FUNC(clearInterval, JSContext *cx, uintN argc, jsval *vp)
{
	jsval *argv = JSAPI_FUNC_ARGV(cx, vp);
	int32_t handle = 0;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx,
			JSAPI_THIS_OBJECT(cx,vp),
			&JSClass_Window,
			argv);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, JSAPI_THIS_OBJECT(cx,vp), private);
	JS_ValueToECMAInt32(cx, argv[0], &handle);
	JSLOG("operation Window.clearInterval has no implementation");
	return JS_TRUE;
}

/**** WindowSessionStorage ****/
/**** WindowLocalStorage ****/
/**** Window ****/
static JSBool JSAPI_PROP(window_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* WindowProxy */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	jsret = obj;

	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(self_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* WindowProxy */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	jsret = obj;

	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(document_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Document */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	if (!JSVAL_IS_VOID(JSAPI_PROP_RVAL(cx, vp))) {
		/* already created - return it */
		return JS_TRUE;
	}

	/* instantiate the subclasses off the window global */
	jsret = jsapi_new_Document(cx,
				   NULL,
				   NULL,
				   (dom_document *)dom_node_ref(private->htmlc->document),
				   private->htmlc);

	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(name_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Window.name has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(name_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Window.name has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

/* PutForwards setter */
static JSBool JSAPI_STRICTPROP(location_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	jsval propval;
	if (JS_GetProperty(cx, obj, "location", &propval) == JS_TRUE) {
		JS_SetProperty(cx, JSVAL_TO_OBJECT(propval), "href", vp);
	}
	return JS_FALSE; /* disallow the asignment */
}

static JSBool JSAPI_PROP(location_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Location */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	if (!JSVAL_IS_VOID(JSAPI_PROP_RVAL(cx, vp))) {
		/* already created - return it */
		return JS_TRUE;
	}

/* should get the docuemnts location
	jsval loc;
	JS_GetProperty(cx, private->document, "location", &loc);
	jsret = JSVAL_TO_OBJECT(loc);
*/

	jsret = jsapi_new_Location(cx,
				   NULL,
				   NULL,
				   llcache_handle_get_url(private->htmlc->base.llcache));

	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(history_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* History */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Window.history has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(locationbar_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* BarProp */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Window.locationbar has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(menubar_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* BarProp */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Window.menubar has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(personalbar_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* BarProp */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Window.personalbar has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(scrollbars_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* BarProp */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Window.scrollbars has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(statusbar_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* BarProp */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Window.statusbar has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(toolbar_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* BarProp */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Window.toolbar has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(status_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Window.status has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(status_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSString *jsret = NULL;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Window.status has no implementation");
	if (jsret == NULL) {
		jsret = JS_NewStringCopyN(cx, NULL, 0);
	}
	JSAPI_PROP_SET_RVAL(cx, vp, JSAPI_STRING_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(frames_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* WindowProxy */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Window.frames has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(length_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	uint32_t jsret = 0;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Window.length has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, INT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(top_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* WindowProxy */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	jsret = obj;

	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(opener_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Window.opener has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(opener_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* WindowProxy */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Window.opener has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(parent_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* WindowProxy */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Window.parent has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(frameElement_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Element */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Window.frameElement has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(navigator_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Navigator */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	if (!JSVAL_IS_VOID(JSAPI_PROP_RVAL(cx, vp))) {
		/* already created - return it */
		return JS_TRUE;
	}

	jsret = jsapi_new_Navigator(cx, NULL, NULL);

	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(external_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* External */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Window.external has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_PROP(applicationCache_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* ApplicationCache */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Window.applicationCache has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool JSAPI_STRICTPROP(onerror_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Window.onerror has no implementation");
        return JS_FALSE; /* disallow the asignment by default */
}

static JSBool JSAPI_PROP(onerror_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* OnErrorEventHandler */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Window.onerror has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** Window ****/
static JSBool JSAPI_PROP(console_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Console */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);

	if (!JSVAL_IS_VOID(JSAPI_PROP_RVAL(cx, vp))) {
		/* already created - return it */
		return JS_TRUE;
	}

	jsret = jsapi_new_Console(cx, NULL, NULL);

	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** EventTarget ****/
/**** WindowBase64 ****/
/**** WindowTimers ****/
/**** WindowSessionStorage ****/
static JSBool JSAPI_PROP(sessionStorage_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Storage */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Window.sessionStorage has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

/**** WindowLocalStorage ****/
static JSBool JSAPI_PROP(localStorage_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	JSObject *jsret = NULL; /* Storage */
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	JSLOG("property Window.localStorage has no implementation");
	JSAPI_PROP_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(jsret));
	return JS_TRUE;
}

static JSBool
JSAPI_STRICTPROP(EventHandler_set, JSContext *cx, JSObject *obj, jsval *vp)
{
	jsval tinyid_jsval;
	int8_t tinyid = JSAPI_PROP_TINYID_END;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	 /* obtain property tinyid */
	JSAPI_PROP_IDVAL(cx, &tinyid_jsval);
	tinyid = JSVAL_TO_INT(tinyid_jsval);


	/* this implementation is unique to the window object as it is
	 * not a dom node.
	 */
	JSLOG("propname[%d]=\"%s\"",
	      tinyid,
	      jsclass_properties[tinyid].name);

	return JS_TRUE;
}

static JSBool JSAPI_PROP(EventHandler_get, JSContext *cx, JSObject *obj, jsval *vp)
{
	jsval tinyid_jsval;
	int8_t tinyid = JSAPI_PROP_TINYID_END;
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	if (private == NULL) {
		return JS_FALSE;
	}

	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	 /* obtain property tinyid */
	JSAPI_PROP_IDVAL(cx, &tinyid_jsval);
	tinyid = JSVAL_TO_INT(tinyid_jsval);


	/* this implementation is unique to the window object as it is
	 * not a dom node.
	 */
	JSLOG("propname[%d]=\"%s\"",
	      tinyid,
	      jsclass_properties[tinyid].name);

        return JS_TRUE;
}

static JSFunctionSpec jsclass_functions[] = {
	/**** Window ****/
	JSAPI_FS(close, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(stop, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(focus, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(blur, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(open, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(alert, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(confirm, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(prompt, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(print, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(showModalDialog, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(postMessage, 0, JSPROP_ENUMERATE ),
	/**** Window ****/
	/**** EventTarget ****/
	JSAPI_FS(addEventListener, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(removeEventListener, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(dispatchEvent, 0, JSPROP_ENUMERATE ),
	/**** WindowBase64 ****/
	JSAPI_FS(btoa, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(atob, 0, JSPROP_ENUMERATE ),
	/**** WindowTimers ****/
	JSAPI_FS(setTimeout, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(clearTimeout, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(setInterval, 0, JSPROP_ENUMERATE ),
	JSAPI_FS(clearInterval, 0, JSPROP_ENUMERATE ),
	/**** WindowSessionStorage ****/
	/**** WindowLocalStorage ****/
	JSAPI_FS_END
};

static JSPropertySpec jsclass_properties[] = {
	/**** Window ****/
	JSAPI_PS_RO("window",
		window,
		JSAPI_PROP_TINYID_window,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("self",
		self,
		JSAPI_PROP_TINYID_self,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("document",
		document,
		JSAPI_PROP_TINYID_document,
		JSPROP_ENUMERATE),
	JSAPI_PS("name",
		name,
		JSAPI_PROP_TINYID_name,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("location",
		location,
		JSAPI_PROP_TINYID_location,
		JSPROP_ENUMERATE),
	JSAPI_PS_RO("history",
		history,
		JSAPI_PROP_TINYID_history,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("locationbar",
		locationbar,
		JSAPI_PROP_TINYID_locationbar,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("menubar",
		menubar,
		JSAPI_PROP_TINYID_menubar,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("personalbar",
		personalbar,
		JSAPI_PROP_TINYID_personalbar,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("scrollbars",
		scrollbars,
		JSAPI_PROP_TINYID_scrollbars,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("statusbar",
		statusbar,
		JSAPI_PROP_TINYID_statusbar,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("toolbar",
		toolbar,
		JSAPI_PROP_TINYID_toolbar,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("status",
		status,
		JSAPI_PROP_TINYID_status,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("frames",
		frames,
		JSAPI_PROP_TINYID_frames,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("length",
		length,
		JSAPI_PROP_TINYID_length,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("top",
		top,
		JSAPI_PROP_TINYID_top,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("opener",
		opener,
		JSAPI_PROP_TINYID_opener,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("parent",
		parent,
		JSAPI_PROP_TINYID_parent,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("frameElement",
		frameElement,
		JSAPI_PROP_TINYID_frameElement,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("navigator",
		navigator,
		JSAPI_PROP_TINYID_navigator,
		JSPROP_ENUMERATE),
	JSAPI_PS_RO("external",
		external,
		JSAPI_PROP_TINYID_external,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_RO("applicationCache",
		applicationCache,
		JSAPI_PROP_TINYID_applicationCache,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("onabort",
		EventHandler,
		JSAPI_PROP_TINYID_onabort,
		JSPROP_ENUMERATE),
	JSAPI_PS("onafterprint",
		EventHandler,
		JSAPI_PROP_TINYID_onafterprint,
		JSPROP_ENUMERATE),
	JSAPI_PS("onbeforeprint",
		EventHandler,
		JSAPI_PROP_TINYID_onbeforeprint,
		JSPROP_ENUMERATE),
	JSAPI_PS("onbeforeunload",
		EventHandler,
		JSAPI_PROP_TINYID_onbeforeunload,
		JSPROP_ENUMERATE),
	JSAPI_PS("onblur",
		EventHandler,
		JSAPI_PROP_TINYID_onblur,
		JSPROP_ENUMERATE),
	JSAPI_PS("oncancel",
		EventHandler,
		JSAPI_PROP_TINYID_oncancel,
		JSPROP_ENUMERATE),
	JSAPI_PS("oncanplay",
		EventHandler,
		JSAPI_PROP_TINYID_oncanplay,
		JSPROP_ENUMERATE),
	JSAPI_PS("oncanplaythrough",
		EventHandler,
		JSAPI_PROP_TINYID_oncanplaythrough,
		JSPROP_ENUMERATE),
	JSAPI_PS("onchange",
		EventHandler,
		JSAPI_PROP_TINYID_onchange,
		JSPROP_ENUMERATE),
	JSAPI_PS("onclick",
		EventHandler,
		JSAPI_PROP_TINYID_onclick,
		JSPROP_ENUMERATE),
	JSAPI_PS("onclose",
		EventHandler,
		JSAPI_PROP_TINYID_onclose,
		JSPROP_ENUMERATE),
	JSAPI_PS("oncontextmenu",
		EventHandler,
		JSAPI_PROP_TINYID_oncontextmenu,
		JSPROP_ENUMERATE),
	JSAPI_PS("oncuechange",
		EventHandler,
		JSAPI_PROP_TINYID_oncuechange,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondblclick",
		EventHandler,
		JSAPI_PROP_TINYID_ondblclick,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondrag",
		EventHandler,
		JSAPI_PROP_TINYID_ondrag,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondragend",
		EventHandler,
		JSAPI_PROP_TINYID_ondragend,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondragenter",
		EventHandler,
		JSAPI_PROP_TINYID_ondragenter,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondragleave",
		EventHandler,
		JSAPI_PROP_TINYID_ondragleave,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondragover",
		EventHandler,
		JSAPI_PROP_TINYID_ondragover,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondragstart",
		EventHandler,
		JSAPI_PROP_TINYID_ondragstart,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondrop",
		EventHandler,
		JSAPI_PROP_TINYID_ondrop,
		JSPROP_ENUMERATE),
	JSAPI_PS("ondurationchange",
		EventHandler,
		JSAPI_PROP_TINYID_ondurationchange,
		JSPROP_ENUMERATE),
	JSAPI_PS("onemptied",
		EventHandler,
		JSAPI_PROP_TINYID_onemptied,
		JSPROP_ENUMERATE),
	JSAPI_PS("onended",
		EventHandler,
		JSAPI_PROP_TINYID_onended,
		JSPROP_ENUMERATE),
	JSAPI_PS("onerror",
		onerror,
		JSAPI_PROP_TINYID_onerror,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS("onfocus",
		EventHandler,
		JSAPI_PROP_TINYID_onfocus,
		JSPROP_ENUMERATE),
	JSAPI_PS("onhashchange",
		EventHandler,
		JSAPI_PROP_TINYID_onhashchange,
		JSPROP_ENUMERATE),
	JSAPI_PS("oninput",
		EventHandler,
		JSAPI_PROP_TINYID_oninput,
		JSPROP_ENUMERATE),
	JSAPI_PS("oninvalid",
		EventHandler,
		JSAPI_PROP_TINYID_oninvalid,
		JSPROP_ENUMERATE),
	JSAPI_PS("onkeydown",
		EventHandler,
		JSAPI_PROP_TINYID_onkeydown,
		JSPROP_ENUMERATE),
	JSAPI_PS("onkeypress",
		EventHandler,
		JSAPI_PROP_TINYID_onkeypress,
		JSPROP_ENUMERATE),
	JSAPI_PS("onkeyup",
		EventHandler,
		JSAPI_PROP_TINYID_onkeyup,
		JSPROP_ENUMERATE),
	JSAPI_PS("onload",
		EventHandler,
		JSAPI_PROP_TINYID_onload,
		JSPROP_ENUMERATE),
	JSAPI_PS("onloadeddata",
		EventHandler,
		JSAPI_PROP_TINYID_onloadeddata,
		JSPROP_ENUMERATE),
	JSAPI_PS("onloadedmetadata",
		EventHandler,
		JSAPI_PROP_TINYID_onloadedmetadata,
		JSPROP_ENUMERATE),
	JSAPI_PS("onloadstart",
		EventHandler,
		JSAPI_PROP_TINYID_onloadstart,
		JSPROP_ENUMERATE),
	JSAPI_PS("onmessage",
		EventHandler,
		JSAPI_PROP_TINYID_onmessage,
		JSPROP_ENUMERATE),
	JSAPI_PS("onmousedown",
		EventHandler,
		JSAPI_PROP_TINYID_onmousedown,
		JSPROP_ENUMERATE),
	JSAPI_PS("onmousemove",
		EventHandler,
		JSAPI_PROP_TINYID_onmousemove,
		JSPROP_ENUMERATE),
	JSAPI_PS("onmouseout",
		EventHandler,
		JSAPI_PROP_TINYID_onmouseout,
		JSPROP_ENUMERATE),
	JSAPI_PS("onmouseover",
		EventHandler,
		JSAPI_PROP_TINYID_onmouseover,
		JSPROP_ENUMERATE),
	JSAPI_PS("onmouseup",
		EventHandler,
		JSAPI_PROP_TINYID_onmouseup,
		JSPROP_ENUMERATE),
	JSAPI_PS("onmousewheel",
		EventHandler,
		JSAPI_PROP_TINYID_onmousewheel,
		JSPROP_ENUMERATE),
	JSAPI_PS("onoffline",
		EventHandler,
		JSAPI_PROP_TINYID_onoffline,
		JSPROP_ENUMERATE),
	JSAPI_PS("ononline",
		EventHandler,
		JSAPI_PROP_TINYID_ononline,
		JSPROP_ENUMERATE),
	JSAPI_PS("onpause",
		EventHandler,
		JSAPI_PROP_TINYID_onpause,
		JSPROP_ENUMERATE),
	JSAPI_PS("onplay",
		EventHandler,
		JSAPI_PROP_TINYID_onplay,
		JSPROP_ENUMERATE),
	JSAPI_PS("onplaying",
		EventHandler,
		JSAPI_PROP_TINYID_onplaying,
		JSPROP_ENUMERATE),
	JSAPI_PS("onpagehide",
		EventHandler,
		JSAPI_PROP_TINYID_onpagehide,
		JSPROP_ENUMERATE),
	JSAPI_PS("onpageshow",
		EventHandler,
		JSAPI_PROP_TINYID_onpageshow,
		JSPROP_ENUMERATE),
	JSAPI_PS("onpopstate",
		EventHandler,
		JSAPI_PROP_TINYID_onpopstate,
		JSPROP_ENUMERATE),
	JSAPI_PS("onprogress",
		EventHandler,
		JSAPI_PROP_TINYID_onprogress,
		JSPROP_ENUMERATE),
	JSAPI_PS("onratechange",
		EventHandler,
		JSAPI_PROP_TINYID_onratechange,
		JSPROP_ENUMERATE),
	JSAPI_PS("onreset",
		EventHandler,
		JSAPI_PROP_TINYID_onreset,
		JSPROP_ENUMERATE),
	JSAPI_PS("onresize",
		EventHandler,
		JSAPI_PROP_TINYID_onresize,
		JSPROP_ENUMERATE),
	JSAPI_PS("onscroll",
		EventHandler,
		JSAPI_PROP_TINYID_onscroll,
		JSPROP_ENUMERATE),
	JSAPI_PS("onseeked",
		EventHandler,
		JSAPI_PROP_TINYID_onseeked,
		JSPROP_ENUMERATE),
	JSAPI_PS("onseeking",
		EventHandler,
		JSAPI_PROP_TINYID_onseeking,
		JSPROP_ENUMERATE),
	JSAPI_PS("onselect",
		EventHandler,
		JSAPI_PROP_TINYID_onselect,
		JSPROP_ENUMERATE),
	JSAPI_PS("onshow",
		EventHandler,
		JSAPI_PROP_TINYID_onshow,
		JSPROP_ENUMERATE),
	JSAPI_PS("onstalled",
		EventHandler,
		JSAPI_PROP_TINYID_onstalled,
		JSPROP_ENUMERATE),
	JSAPI_PS("onstorage",
		EventHandler,
		JSAPI_PROP_TINYID_onstorage,
		JSPROP_ENUMERATE),
	JSAPI_PS("onsubmit",
		EventHandler,
		JSAPI_PROP_TINYID_onsubmit,
		JSPROP_ENUMERATE),
	JSAPI_PS("onsuspend",
		EventHandler,
		JSAPI_PROP_TINYID_onsuspend,
		JSPROP_ENUMERATE),
	JSAPI_PS("ontimeupdate",
		EventHandler,
		JSAPI_PROP_TINYID_ontimeupdate,
		JSPROP_ENUMERATE),
	JSAPI_PS("onunload",
		EventHandler,
		JSAPI_PROP_TINYID_onunload,
		JSPROP_ENUMERATE),
	JSAPI_PS("onvolumechange",
		EventHandler,
		JSAPI_PROP_TINYID_onvolumechange,
		JSPROP_ENUMERATE),
	JSAPI_PS("onwaiting",
		EventHandler,
		JSAPI_PROP_TINYID_onwaiting,
		JSPROP_ENUMERATE),
	/**** Window ****/
	JSAPI_PS_RO("console",
		console,
		JSAPI_PROP_TINYID_console,
		JSPROP_ENUMERATE),
	/**** EventTarget ****/
	/**** WindowBase64 ****/
	/**** WindowTimers ****/
	/**** WindowSessionStorage ****/
	JSAPI_PS_RO("sessionStorage",
		sessionStorage,
		JSAPI_PROP_TINYID_sessionStorage,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	/**** WindowLocalStorage ****/
	JSAPI_PS_RO("localStorage",
		localStorage,
		JSAPI_PROP_TINYID_localStorage,
		JSPROP_SHARED | JSPROP_ENUMERATE),
	JSAPI_PS_END
};

static void jsclass_finalize(JSContext *cx, JSObject *obj)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(cx, obj, &JSClass_Window, NULL);
	JSLOG("jscontext:%p jsobject:%p private:%p", cx, obj, private);
	if (private != NULL) {
		free(private);
	}
}

static JSAPI_MARKOP(jsclass_mark)
{
	struct jsclass_private *private;

	private = JS_GetInstancePrivate(JSAPI_MARKCX, obj, &JSClass_Window, NULL);
	JSLOG("jscontext:%p jsobject:%p private:%p", JSAPI_MARKCX, obj, private);


	if (private != NULL) {
		if (private->prototype_Document != NULL) {
			JSAPI_GCMARK(private->prototype_Document);
		}

		if (private->prototype_Navigator != NULL) {
			JSAPI_GCMARK(private->prototype_Navigator);
		}

		if (private->prototype_Location != NULL) {
			JSAPI_GCMARK(private->prototype_Location);
		}

		if (private->prototype_Console != NULL) {
			JSAPI_GCMARK(private->prototype_Console);
		}

		if (private->prototype_HTMLElement != NULL) {
			JSAPI_GCMARK(private->prototype_HTMLElement);
		}

		if (private->prototype_HTMLCollection != NULL) {
			JSAPI_GCMARK(private->prototype_HTMLCollection);
		}

		if (private->prototype_NodeList != NULL) {
			JSAPI_GCMARK(private->prototype_NodeList);
		}

		if (private->prototype_Text != NULL) {
			JSAPI_GCMARK(private->prototype_Text);
		}

		if (private->prototype_Comment != NULL) {
			JSAPI_GCMARK(private->prototype_Comment);
		}

		if (private->prototype_Node != NULL) {
			JSAPI_GCMARK(private->prototype_Node);
		}

		if (private->prototype_Event != NULL) {
			JSAPI_GCMARK(private->prototype_Event);
		}
	}

	JSAPI_MARKOP_RETURN(JS_TRUE);
}

JSObject *jsapi_InitClass_Window(JSContext *cx, JSObject *parent)
{
	JSObject *prototype;

	prototype = JS_NewCompartmentAndGlobalObject(cx, &JSClass_Window, NULL);
	if (prototype == NULL) {
		return NULL;
	}

	/** @todo reconsider global object handling. future
	 * editions of spidermonkey appear to be removing the
	 * idea of a global so we probably need to handle
	 * global object references internally
	 */

	/* set the contexts global */
	JS_SetGlobalObject(cx, prototype);

	/* Populate the global object with the standard globals, like
	 *  Object and Array.
	 */
	if (!JS_InitStandardClasses(cx, prototype)) {
		return NULL;
	}

	/* add functions to prototype */
	if (!JS_DefineFunctions(cx, prototype, jsclass_functions)) {
		return NULL;
	}

	/* add properties to prototype */
	if (!JS_DefineProperties(cx, prototype, jsclass_properties))
		return NULL;

	/* as the global just got changed, force a GC run */
	JS_GC(cx);

	/**** Window ****/
	/**** Window ****/
	/**** EventTarget ****/
	/**** WindowBase64 ****/
	/**** WindowTimers ****/
	/**** WindowSessionStorage ****/
	/**** WindowLocalStorage ****/
	return prototype;
}

JSObject *jsapi_new_Window(JSContext *cx,
		JSObject *prototype,
		JSObject *parent,
		struct browser_window *bw,
		struct html_content *htmlc)
{
	JSObject *newobject;
	struct jsclass_private *private;

	private = malloc(sizeof(struct jsclass_private));
	if (private == NULL) {
		return NULL;
	}
	private->bw = bw;
	private->htmlc = htmlc;

	/* @todo sort out windows that are not globals */
	assert(parent == NULL);

	/* the window object is the global so its prototype *is* the instance */
	newobject = prototype;

	if (init_user_prototypes(cx, private, prototype) == false) {
		/* prototype initialisation failed */
		free(private);
		return NULL;
	}

	LOG(("Created new window object %p", newobject));

	if (newobject == NULL) {
		free(private);
		return NULL;
	}

	if (JSAPI_ADD_OBJECT_ROOT(cx, &newobject) != JS_TRUE) {
		free(private);
		return NULL;
	}


	/* attach private pointer */
	if (JS_SetPrivate(cx, newobject, private) != JS_TRUE) {
		free(private);
		return NULL;
	}

	if (JS_DefineFunctions(cx, newobject, jsclass_functions) != JS_TRUE) {
		free(private);
		return NULL;
	}

	if (JS_DefineProperties(cx, newobject, jsclass_properties) != JS_TRUE) {
		free(private);
		return NULL;
	}

	JSAPI_REMOVE_OBJECT_ROOT(cx, &newobject);

	return newobject;
}


